SystemOrganization addCategory: #DynamicOwnership!
SystemOrganization addCategory: #'DynamicOwnership-FirstModel'!
SystemOrganization addCategory: #'DynamicOwnership-FirstModel-Test'!
SystemOrganization addCategory: #'DynamicOwnership-SecondModel'!
SystemOrganization addCategory: #'DynamicOwnership-SecondModel-Test'!
SystemOrganization addCategory: #'DynamicOwnership-ThirdModel'!
SystemOrganization addCategory: #'DynamicOwnership-ThirdModel-Test'!
SystemOrganization addCategory: #'DynamicOwnership-Examples-SnakesAndLadders'!
SystemOrganization addCategory: #'DynamicOwnership-AdaptedClasses'!
SystemOrganization addCategory: #'DynamicOwnership-TestStuff'!
SystemOrganization addCategory: #'DynamicOwnership-Util'!
SystemOrganization addCategory: #'DynamicOwnership-Traits'!
SystemOrganization addCategory: #'DynamicOwnership-ThirdModel-UseCases'!
SystemOrganization addCategory: #'DynamicOwnership-DOClassesExport'!

Trait named: #TDeepOwernship
	uses: {}
	category: 'DynamicOwnership-Traits'!

!TDeepOwernship methodsFor: 'violation' stamp: 'ewe 4/26/2012 11:31'!
canCrossBoundary: anObject
	<meta> 
	^ false! !

!TDeepOwernship methodsFor: 'violation' stamp: 'ewe 5/1/2012 10:12'!
doCrossBoundary: anObject
	<meta> 
	Error signal: 'No object should pass through'. ! !

!TDeepOwernship methodsFor: 'violation' stamp: 'ewe 5/2/2012 15:33'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!TDeepOwernship methodsFor: 'filters' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#none}! !

!TDeepOwernship methodsFor: 'filters' stamp: 'ewe 5/1/2012 13:16'!
outFilters
	^ {#all}
	! !

Trait named: #TDefensiveCopyOwernship
	uses: {}
	category: 'DynamicOwnership-Traits'!

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:34'!
canCrossBoundary: anObject
	<meta> 
	^ false.! !

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:34'!
doCrossBoundary: anObject
	<meta> 
	Error signal: 'No object should pass through'. ! !

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:36'!
doNotCrossBoundary: anObject
	<meta> 
	( self selectedCopyClass includes: anObject class ) ifTrue: [
			Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') copied by ', self printString ) ; cr.
			^ anObject copy.
	]	ifFalse: [
			Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
			OwnershipViolation signal: 'Boundary crossed'    
	]
! !

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:32'!
inFilters
	^ {#none}! !

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:33'!
outFilters
	^ {#all}
	! !

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:35'!
selectedCopyClass 
	^ #()! !

Trait named: #TExceptionAssertion
	uses: {}
	category: 'DynamicOwnership-ThirdModel-Test'!

!TExceptionAssertion methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:00'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: DeepOwnershipViolation ! !

!TExceptionAssertion methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:00'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: DeepOwnershipViolation ! !

!TExceptionAssertion methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:00'!
assertMessageFilter: aBlock
 	 self should: aBlock  raise: MessageFiltered 
! !

!TExceptionAssertion methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:00'!
assertMessagePass: aBlock
  	 self shouldnt: aBlock  raise: MessageFiltered ! !

Trait named: #TNoOwernship
	uses: {}
	category: 'DynamicOwnership-Traits'!

!TNoOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:11'!
canCrossBoundary: anObject
	<meta> 
	^ true.! !

!TNoOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:10'!
doCrossBoundary: anObject
	<meta> 
	^ anObject. ! !

!TNoOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:12'!
doNotCrossBoundary: anObject
	<meta> 
	Error signal: 'All objects should pass through'. ! !

!TNoOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:22'!
inFilters
	^ {#all}! !

!TNoOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:16'!
outFilters
	^ {#all}
	! !

Trait named: #TSelectiveOwernship
	uses: {}
	category: 'DynamicOwnership-Traits'!

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:53'!
canCrossBoundary: anObject
	<meta> 
	^ self selectedClasses includes: anObject class. ! !

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:45'!
doCrossBoundary: anObject
	<meta> 
	^ anObject. ! !

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:32'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#none}! !

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ {#all}
	! !

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:54'!
selectedClasses 
	^ #()! !

CollectionRootTest subclass: #DOArrayTest
	uses: TEmptySequenceableTest + TSequencedElementAccessTest + TCloneTest + TIncludesWithIdentityCheckTest + TCopyTest + TSetArithmetic + TCreationWithTest + TPutBasicTest + TConvertTest - {} + TOccurrencesForMultiplinessTest + TIterateSequencedReadableTest + TSequencedConcatenationTest + TReplacementSequencedTest + TAsStringCommaAndDelimiterSequenceableTest + TBeginsEndsWith + TPrintOnSequencedTest + TIndexAccess + TSubCollectionAccess + TConvertAsSetForMultiplinessIdentityTest + TCopyPartOfSequenceable + TCopySequenceableSameContents + TCopySequenceableWithOrWithoutSpecificElements + TCopySequenceableWithReplacement + TIndexAccessForMultipliness + TCopyPartOfSequenceableForMultipliness + TConvertAsSortedTest + TPutTest + TSequencedStructuralEqualityTest + TSortTest
	instanceVariableNames: 'example1 literalArray selfEvaluatingArray otherArray nonSEArray1 nonSEarray2 example2 empty collectResult withoutEqualElements withEqualElements withCharacters unsortedCollection sortedInAscendingOrderCollection sizeCollection collectionNotIncluded removedCollection elementInForCopy elementNotInForCopy firstIndex secondIndex replacementCollection indexArray valueArray nonEmptyMoreThan1Element subCollectionNotIn replacementCollectionSameSize oldSubCollection nonEmpty1Element collectionOfCollection collectionOfFloatWithEqualElements floatCollectionWithSameBeginingAnEnd collectionWithoutNil duplicateElement collection5Elements collectionWith4Elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-AdaptedClasses'!

!DOArrayTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class Array. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- there is a chapter in the PharoByExample book (http://pharobyexample.org/)	
	- the sunit class category!

DOArrayTest class
	uses: TEmptySequenceableTest classTrait + TSequencedElementAccessTest classTrait + TCloneTest classTrait + TCopyTest classTrait + TSetArithmetic classTrait + TCreationWithTest classTrait + TPutBasicTest classTrait + TConvertTest classTrait + TSortTest classTrait + TIterateSequencedReadableTest classTrait + TSequencedConcatenationTest classTrait + TReplacementSequencedTest classTrait + TAsStringCommaAndDelimiterSequenceableTest classTrait + TBeginsEndsWith classTrait + TPrintOnSequencedTest classTrait + TIndexAccess classTrait + TSubCollectionAccess classTrait + TCopyPartOfSequenceable classTrait + TCopySequenceableSameContents classTrait + TCopySequenceableWithOrWithoutSpecificElements classTrait + TCopySequenceableWithReplacement classTrait + TIndexAccessForMultipliness classTrait + TCopyPartOfSequenceableForMultipliness classTrait + TConvertAsSortedTest classTrait + TPutTest classTrait + TIncludesWithIdentityCheckTest classTrait + TConvertAsSetForMultiplinessIdentityTest classTrait + TSequencedStructuralEqualityTest classTrait + TOccurrencesForMultiplinessTest classTrait
	instanceVariableNames: ''!

!DOArrayTest class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:02'!
compilerClass
	^DOTestsCompiler! !

!DOArrayTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:12'!
aValue

	^ 33! !

!DOArrayTest methodsFor: 'requirements' stamp: 'stephane.ducasse 10/30/2008 19:02'!
accessCollection

	^ example1! !

!DOArrayTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:13'!
anIndex

	^ 2! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 14:45'!
anotherElementNotIn
	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:05'!
anotherElementOrAssociationIn
	" return an element (or an association for Dictionary ) present  in 'collection' "
	^ self collection anyOne.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:05'!
anotherElementOrAssociationNotIn
	" return an element (or an association for Dictionary )not present  in 'collection' "
	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:19'!
anotherValue

	^ 66! !

!DOArrayTest methodsFor: 'tests - converting' stamp: 'cyrille.delaunay 3/26/2009 12:35'!
assertSameContents: aCollection whenConvertedTo: aClass 
	| result |
	result := aCollection perform: ('as' , aClass name) asSymbol.
	self assert: (result class includesBehavior: aClass).
	result do: 
		[ :each | 
		self assert: (aCollection occurrencesOf: each) = (result occurrencesOf: each) ].
	self assert: result size = aCollection size! !

!DOArrayTest methodsFor: 'initialization' stamp: 'cyrille.delaunay 12/18/2009 12:59'!
collection 

	^ collectionWith4Elements ! !

!DOArrayTest methodsFor: 'test - creation' stamp: 'pmaer 4/27/2012 13:59'!
collectionClass 
	
	^ DOArray! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/9/2009 11:11'!
collectionInForIncluding
	^ self nonEmpty copyWithoutFirst.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 15:16'!
collectionMoreThan1NoDuplicates
	" return a collection of size 5 without equal elements"
	^ withoutEqualElements ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 5/14/2009 14:01'!
collectionMoreThan5Elements
" return a collection including at least 5 elements"
	
	^ collection5Elements ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/30/2009 10:51'!
collectionNotIncluded
	^ collectionNotIncluded.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/15/2009 14:07'!
collectionOfFloat
	^ collectionOfCollection! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/17/2009 10:28'!
collectionWith1TimeSubcollection
	^ (self oldSubCollection copyWithoutFirst),self oldSubCollection,(self oldSubCollection copyWithoutFirst). ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/17/2009 10:29'!
collectionWith2TimeSubcollection
	^ (self oldSubCollection copyWithoutFirst),self oldSubCollection,(self oldSubCollection copyWithoutFirst),self oldSubCollection .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 3/26/2009 09:58'!
collectionWithCharacters
	^ withCharacters.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 14:02'!
collectionWithCopy
	"return a collection of type 'self collectionWIithoutEqualsElements clas' containing no elements equals ( with identity equality)
	but  2 elements only equals with classic equality"
	| result collection |
	collection := DOOrderedCollection withAll: self elementsCopyNonIdenticalWithoutEqualElements.
	collection add: collection first copy.
	result := self elementsCopyNonIdenticalWithoutEqualElements class withAll: collection.
	^ result! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 10:22'!
collectionWithCopyNonIdentical
	" return a collection that include elements for which 'copy' return a different object (this is not the case of SmallInteger)"
	^ collectionOfCollection! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/17/2009 15:24'!
collectionWithElementsToRemove
	^ removedCollection! !

!DOArrayTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 3/26/2009 09:57'!
collectionWithEqualElements
	^ withEqualElements.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 14:02'!
collectionWithIdentical
	"return a collection of type : 'self collectionWIithoutEqualsElements class containing two elements equals ( with identity equality)"
	| result collection element |
	collection := DOOrderedCollection withAll: self elementsCopyNonIdenticalWithoutEqualElements.
	element := collection first.
	collection add: element.
	result := self elementsCopyNonIdenticalWithoutEqualElements class withAll: collection.
	^ result! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:17'!
collectionWithNonIdentitySameAtEndAndBegining
	" return a collection with elements at end and begining equals only with classic equality (they are not the same object).
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingAnEnd ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/22/2009 11:15'!
collectionWithSameAtEndAndBegining
" return a collection with elements at end and begining equals .
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingAnEnd ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 10:27'!
collectionWithSortableElements
" return a collection elements that can be sorte ( understanding message ' < '  or ' > ')"
	^ withoutEqualElements ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 10:25'!
collectionWithoutEqualElements
	^ withoutEqualElements .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/16/2009 15:49'!
collectionWithoutEqualsElements
	^ withoutEqualElements ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 11:39'!
collectionWithoutNilElements
" return a collection that doesn't includes a nil element  and that doesn't includes equal elements'"
	^ collectionWithoutNil  ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'damienpollet 1/30/2009 17:27'!
element
	^ 3! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/15/2009 14:22'!
elementInCollectionOfFloat
	^ collectionOfCollection atRandom! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 10:28'!
elementInForCopy
	^ elementInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:39'!
elementInForElementAccessing
" return an element inculded in 'accessCollection '"
	^ self accessCollection anyOne! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/14/2009 13:55'!
elementInForIncludesTest

	^ elementInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/10/2009 14:49'!
elementInForIndexAccess
	^ elementInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 15:18'!
elementInForIndexAccessing

	^ withoutEqualElements anyOne! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/2/2009 11:54'!
elementInForOccurrences
	^ elementInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/6/2009 10:16'!
elementInForReplacement
	^ elementInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 14:45'!
elementNotIn
"return an element not included in 'nonEmpty' "

	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 10:29'!
elementNotInForCopy
	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:39'!
elementNotInForElementAccessing
" return an element not included in 'accessCollection' "
	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/7/2009 11:18'!
elementNotInForIndexAccessing

	^elementNotInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 14:45'!
elementNotInForOccurrences
	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'test - copy' stamp: 'delaunay 4/17/2009 15:26'!
elementToAdd
	^ 55! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 16:13'!
elementTwiceInForOccurrences
" return an element included exactly two time in # collectionWithEqualElements"
^ duplicateElement ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 13:46'!
elementsCopyNonIdenticalWithoutEqualElements
	" return a collection that does niot include equal elements ( classic equality )"
	^ collectionOfCollection! !

!DOArrayTest methodsFor: 'initialization' stamp: 'stephane.ducasse 10/5/2008 15:06'!
empty

	^ empty! !

!DOArrayTest methodsFor: 'test - iterate' stamp: 'luc.fabresse 11/29/2008 23:10'!
expectedSizeAfterReject
	^1! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/2/2009 16:41'!
firstCollection
	^example1 ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'damiencassou 1/27/2009 10:35'!
firstEven
	"Returns the first even number of #collection"
	^ -2! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 10:29'!
firstIndex
	^ firstIndex ! !

!DOArrayTest methodsFor: 'tests - copying with replacement' stamp: 'pmaer 4/27/2012 14:02'!
firstIndexesOf: subCollection in: collection
" return an OrderedCollection with the first indexes of the occurrences of subCollection in  collection "
	| tmp result currentIndex |
	tmp:= collection.
	result:= DOOrderedCollection new.
	currentIndex := 1.
	
	[tmp isEmpty ]whileFalse:
		[
		(tmp beginsWith: subCollection)
			ifTrue: [ 	
				result add: currentIndex.
				1 to: subCollection size do: 
					[:i | 
					tmp := tmp copyWithoutFirst.
					currentIndex := currentIndex + 1]
				]
			ifFalse: [
				tmp := tmp copyWithoutFirst.
				currentIndex := currentIndex +1.
				]
		 ].
	
	^ result.
	! !

!DOArrayTest methodsFor: 'requirements' stamp: 'damiencassou 1/27/2009 10:35'!
firstOdd
	"Returns the first odd number of #collection"
	^ 1! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/21/2009 14:00'!
floatCollectionWithSameAtEndAndBegining
" return a collection with elements at end and begining equals only with classic equality (they are not the same object).
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingAnEnd ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 16:00'!
indexArray
	^ indexArray .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/16/2009 15:59'!
indexInForCollectionWithoutDuplicates
	^ 2.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/16/2009 16:56'!
indexInNonEmpty
	^ 2 ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/9/2009 15:53'!
integerCollection
	^example1 .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 10:28'!
integerCollectionWithoutEqualElements
	^{1. 2. 6. 5.}! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:53'!
moreThan3Elements
	" return a collection including atLeast 3 elements"
	^ example1 ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:53'!
moreThan4Elements

" return a collection including at leat 4 elements"
	^ example1 ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/6/2009 10:16'!
newElement
	^999! !

!DOArrayTest methodsFor: 'initialization' stamp: 'stephane.ducasse 10/5/2008 15:06'!
nonEmpty

	^ example1! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/8/2009 11:40'!
nonEmpty1Element

	^ nonEmpty1Element  ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/2/2009 15:20'!
nonEmptyMoreThan1Element
	^nonEmptyMoreThan1Element .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/6/2009 11:41'!
oldSubCollection
	^oldSubCollection ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 10:29'!
replacementCollection
	^replacementCollection .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/6/2009 10:32'!
replacementCollectionSameSize
	^replacementCollectionSameSize ! !

!DOArrayTest methodsFor: 'initialization' stamp: 'cyrille.delaunay 12/18/2009 11:59'!
result
	
	^ collectResult! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/2/2009 16:41'!
secondCollection
	^example2 ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 10:29'!
secondIndex
	^ secondIndex ! !

!DOArrayTest methodsFor: 'parameters' stamp: 'stephane.ducasse 10/5/2008 15:12'!
selectorToAccessValuePutIn
	"return the selector of the method that should be invoked to access an element"
	
	^ #second! !

!DOArrayTest methodsFor: 'initialization' stamp: 'pmaer 4/27/2012 13:59'!
setUp

	
	literalArray := #(1 true 3 #four).
	selfEvaluatingArray := { 1. true. (3/4). Color black. (2 to: 4) . 5 }.
	nonSEArray1 := { 1 . Set with: 1 }.
	nonSEarray2 := { Smalltalk globals associationAt: #DOArray }.
	example1 := #(1 2 3 4 5) copy.
	indexArray:= {2. 3. 4.}.
	valueArray:={0. 0. 0.}.
	oldSubCollection:= {2. 3. 4.}.
	nonEmptyMoreThan1Element:= example1.
	subCollectionNotIn:= {1. 8. 3.}.
	collectionNotIncluded:= {7. 8. 9.}.
	removedCollection:=  { 2. 4. }.
	
	example2 := {1. 2. 3/4. 4. 5}.
	collectionWith4Elements := #(1 -2 3 1). 
	collectionWithoutNil := #( 1 2 3 4).
	collectResult := {SmallInteger. SmallInteger. SmallInteger. SmallInteger.}.
	empty := #().
	duplicateElement := 5.2.
	withEqualElements := {1.5. duplicateElement . 6.1. 2.0. duplicateElement .} .
	withoutEqualElements := {1.1. 4.4. 6.5. 2.4. 3.1.}.
	withCharacters := {$a. $x. $d. $c. $m.}.
	unsortedCollection := {1. 2.  8. 5. 6. 7.}.
	sortedInAscendingOrderCollection := {1. 2. 3. 4. 5. 6.}.
	elementInForCopy:= 2.
	elementNotInForCopy:= 9.
	firstIndex:= 2.
	secondIndex:= 4.
	replacementCollection:= {4. 3. 2. 1.}.
	replacementCollectionSameSize := {5. 4. 3.}.	
	nonEmpty1Element:={ 5.}.
	collectionOfCollection:={1.5. 5.5. 6.5.}.
	collectionOfFloatWithEqualElements:={1.5. 5.5. 6.5. 1.5}.
	floatCollectionWithSameBeginingAnEnd := {1.5. 5.5. 1.5 copy}.
	collection5Elements := { 1. 2. 5. 3. 4.}.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'damienpollet 1/13/2009 16:59'!
sizeCollection

	^ self collection! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 14:08'!
smallerIndex
	^ firstIndex -1! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/27/2009 15:20'!
sortedInAscendingOrderCollection
	^sortedInAscendingOrderCollection .
	! !

!DOArrayTest methodsFor: 'test - iterate' stamp: 'pmaer 4/27/2012 13:59'!
speciesClass
	
	^ DOArray! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/3/2009 11:35'!
subCollectionNotIn

	^subCollectionNotIn ! !

!DOArrayTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/17/2009 15:26'!
test0CopyTest
	self 
		shouldnt: self empty
		raise: Error.
	self assert: self empty size = 0.
	self 
		shouldnt: self nonEmpty
		raise: Error.
	self assert: (self nonEmpty size = 0) not.
	self 
		shouldnt: self collectionWithElementsToRemove
		raise: Error.
	self assert: (self collectionWithElementsToRemove size = 0) not.
	self 
		shouldnt: self elementToAdd
		raise: Error! !

!DOArrayTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/15/2009 14:37'!
test0FixtureIncludeTest
	| elementIn |
	self 
		shouldnt: [ self nonEmpty ]
		raise: Error.
	self deny: self nonEmpty isEmpty.
	self 
		shouldnt: [ self elementNotIn ]
		raise: Error.
	elementIn := true.
	self nonEmpty 
		detect: [ :each | each = self elementNotIn ]
		ifNone: [ elementIn := false ].
	self assert: elementIn = false.
	self 
		shouldnt: [ self anotherElementNotIn ]
		raise: Error.
	elementIn := true.
	self nonEmpty 
		detect: [ :each | each = self anotherElementNotIn ]
		ifNone: [ elementIn := false ].
	self assert: elementIn = false.
	self 
		shouldnt: [ self collection ]
		raise: Error.
	"self shouldnt: [self collectionInForIncluding  ] raise: Error."
	"collectionIn:=false.
	index:=1.
	1 to: self nonEmpty size do:
		[:i|
		collectionIn = false
			ifTrue:[(self nonEmpty at:i)=(self collectionInForIncluding at:index)
				ifTrue:[
					index=self collectionInForIncluding 
						ifTrue:[collectionIn := true].					
					index:=index+1.]
				ifFalse:[index:=1].			
				]
		].
	self assert: collectionIn=true."
	self 
		shouldnt: [ self empty ]
		raise: Error.
	self assert: self empty isEmpty.
	self 
		shouldnt: [ self collectionOfFloat ]
		raise: Error.
	self collectionOfFloat do: [ :each | self assert: each class = Float ].
	self 
		shouldnt: [ self elementInForIncludesTest ]
		raise: Error.
	elementIn := true.
	self nonEmpty 
		detect: [ :each | each = self elementInForIncludesTest ]
		ifNone: [ elementIn := false ].
	self assert: elementIn = true! !

!DOArrayTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/2/2009 11:53'!
test0FixtureOccurrencesTest
	self 
		shouldnt: self empty
		raise: Error.
	self assert: self empty isEmpty.
	self 
		shouldnt: self nonEmpty
		raise: Error.
	self deny: self nonEmpty isEmpty.
	self 
		shouldnt: self elementInForOccurrences
		raise: Error.
	self assert: (self nonEmpty includes: self elementInForOccurrences).
	self 
		shouldnt: self elementNotInForOccurrences
		raise: Error.
	self deny: (self nonEmpty includes: self elementNotInForOccurrences)! !

!DOArrayTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/14/2009 11:50'!
test0FixtureSequencedConcatenationTest
	self 
		shouldnt: self empty
		raise: Exception.
	self assert: self empty isEmpty.
	self 
		shouldnt: self firstCollection
		raise: Exception.
	self 
		shouldnt: self secondCollection
		raise: Exception! !

!DOArrayTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/28/2009 14:11'!
test0FixtureTConvertAsSetForMultiplinessTest
	"a collection ofFloat with equal elements:"
	| res |
	self 
		shouldnt: [ self withEqualElements ]
		raise: Error.
	self 
		shouldnt: 
			[ self withEqualElements do: [ :each | self assert: each class = Float ] ]
		raise: Error.
	res := true.
	self withEqualElements 
		detect: [ :each | (self withEqualElements occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = true.

	"a collection of Float without equal elements:"
	self 
		shouldnt: [ self elementsCopyNonIdenticalWithoutEqualElements ]
		raise: Error.
	self 
		shouldnt: 
			[ self elementsCopyNonIdenticalWithoutEqualElements do: [ :each | self assert: each class = Float ] ]
		raise: Error.
	res := true.
	self elementsCopyNonIdenticalWithoutEqualElements 
		detect: 
			[ :each | 
			(self elementsCopyNonIdenticalWithoutEqualElements occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = false! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testAllButFirstDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  allButFirstDo: [:each | result add: each].
	
	1 to: (result size) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:(i +1))=(result at:i)].
	
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testAllButLastDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  allButLastDo: [:each | result add: each].
	
	1 to: (result size) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:(i ))=(result at:i)].
	
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOArrayTest methodsFor: 'test - iterate' stamp: 'damienpollet 1/13/2009 16:28'!
testAnySatisfy

	self assert: ( self collection anySatisfy: [:each | each = -2]).
	self deny: (self collection anySatisfy: [:each | each isString]).! !

!DOArrayTest methodsFor: 'tests - converting' stamp: 'pmaer 4/27/2012 13:59'!
testAsArray
	"self debug: #testAsArray3"
	self 
		assertSameContents: self collectionWithoutEqualElements
		whenConvertedTo: DOArray! !

!DOArrayTest methodsFor: 'tests - converting' stamp: 'pmaer 4/27/2012 14:02'!
testAsOrderedCollection
	
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: DOOrderedCollection! !

!DOArrayTest methodsFor: 'tests - as sorted collection' stamp: 'pmaer 5/7/2012 01:14'!
testAsSortedArray
	| result collection |
	collection := self collectionWithSortableElements .
	result := collection  asArray sort.
	self assert: (result class includesBehavior: DOArray).
	self assert: result isSorted.
	self assert: result size = collection size! !

!DOArrayTest methodsFor: 'tests - accessing' stamp: 'delaunay 4/10/2009 16:19'!
testAtWrap2
	| tabTest |
	tabTest := #(5 6 8 ).
	self assert: (tabTest atWrap: 2) = 6.
	self assert: (tabTest atWrap: 7) = 5.
	self assert: (tabTest atWrap: 5) = 6.
	self assert: (tabTest atWrap: 0) = 8.
	self assert: (tabTest atWrap: 1) = 5.
	self assert: (tabTest atWrap: -2) = 5! !

!DOArrayTest methodsFor: 'testing' stamp: 'pmaer 5/7/2012 15:25'!
testComplexIsSelfEvaluating
	"self run: #testComplexIsSelfEvaluating"
	<broken>
	"Compiler evaluate:  creates an Array, not a DOArray"

	| complexArray restoredArray |
	complexArray := {1. true. false. nil. #a. 'a'. $a. Float pi. Float halfPi. 4/5. Float infinity negated. Color red. RunArray new: 5 withAll: #bold. 1@2. (0@0 extent: 1@1) -> 0. Object. Object class}.
	complexArray := complexArray copyWith: complexArray.
	
	self assert: complexArray isSelfEvaluating.
	self shouldnt: [restoredArray := Compiler evaluate: complexArray printString] raise: Error.
	self assert: restoredArray = complexArray! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWith
	"self debug: #testCopyWith"
	| res |
	res := self empty copyWith: self elementToAdd.
	self assert: res size = (self empty size + 1).
	self assert: (res includes: self elementToAdd)! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWithout
	"self debug: #testCopyEmptyWithout"
	| res |
	res := self empty copyWithout: self elementToAdd.
	self assert: res size = self empty size.
	self deny: (res includes: self elementToAdd)! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyEmptyWithoutAll
	"self debug: #testCopyEmptyWithoutAll"
	| res |
	res := self empty copyWithoutAll: self collectionWithElementsToRemove.
	self assert: res size = self empty size.
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ]! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWith
	"self debug: #testCopyNonEmptyWith"
	| res |
	res := self nonEmpty copyWith: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self assert: (res includes: self elementToAdd).
	self nonEmpty do: [ :each | res includes: each ]! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyNonEmptyWithoutAll
	"self debug: #testCopyNonEmptyWithoutAll"
	| res |
	res := self nonEmpty copyWithoutAll: self collectionWithElementsToRemove.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ].
	self nonEmpty do: 
		[ :each | 
		(self collectionWithElementsToRemove includes: each) ifFalse: [ self assert: (res includes: each) ] ]! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 3/30/2009 10:33'!
testCopyNonEmptyWithoutAllNotIncluded
	! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWithoutNotIncluded
	"self debug: #testCopyNonEmptyWithoutNotIncluded"
	| res |
	res := self nonEmpty copyWithout: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self nonEmpty do: [ :each | self assert: (res includes: each) ]! !

!DOArrayTest methodsFor: 'test - iterate' stamp: 'pmaer 5/7/2012 01:16'!
testDo

	| res |
	res := DOOrderedCollection new.  
	self collection do: [:each | res add: each class].
	self assert: res asArray = self result.! !

!DOArrayTest methodsFor: 'test - iterate' stamp: 'pmaer 4/27/2012 14:02'!
testDo2

	| res |
	res := DOOrderedCollection new.  
	self collection do: [:each | res add: each class].
	self assert: res asArray = self result. ! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testFromToDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  from: 1 to: (self nonEmptyMoreThan1Element  size -1) do: [:each | result add: each].
	
	1 to: (self nonEmptyMoreThan1Element  size -1) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:i )=(result at:i)].
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOArrayTest methodsFor: 'tests - includes' stamp: 'delaunay 4/28/2009 10:22'!
testIdentityIncludes
	" test the comportement in presence of elements 'includes' but not 'identityIncludes' "
	" can not be used by collections that can't include elements for wich copy doesn't return another instance "
	| collection element |
	self 
		shouldnt: [ self collectionWithCopyNonIdentical ]
		raise: Error.
	collection := self collectionWithCopyNonIdentical.
	element := collection anyOne copy.
	"self assert: (collection includes: element)."
	self deny: (collection identityIncludes: element)! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/15/2009 14:22'!
testIdentityIndexOf
	"self debug: #testIdentityIndexOf"
	| collection element |
	element := self elementInCollectionOfFloat copy.
	self deny: self elementInCollectionOfFloat == element.
	collection := self collectionOfFloat copyWith: element.
	self assert: (collection identityIndexOf: element) = collection size! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/15/2009 14:22'!
testIdentityIndexOfIAbsent
	"self debug: #testIdentityIndexOfIfAbsent"
	| collection element |
	element := self elementInCollectionOfFloat copy.
	self deny: self elementInCollectionOfFloat == element.
	collection := self collectionOfFloat copyWith: element.
	self assert: (collection 
			identityIndexOf: element
			ifAbsent: [ 0 ]) = collection size.
	self assert: (self collectionOfFloat 
			identityIndexOf: element
			ifAbsent: [ 55 ]) = 55! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOf
	"self debug: #testIndexOf"
	| tmp index collection |
	collection := self collectionMoreThan1NoDuplicates.
	tmp := collection size.
	collection reverseDo: 
		[ :each | 
		each = self elementInForIndexAccessing ifTrue: [ index := tmp ].
		tmp := tmp - 1 ].
	self assert: (collection indexOf: self elementInForIndexAccessing) = index! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| collection |
	collection := self collectionMoreThan1NoDuplicates.
	self assert: (collection 
			indexOf: collection first
			ifAbsent: [ 33 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 33 ]) = 33! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfStartingAt
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			indexOf: element
			startingAt: 2
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			indexOf: element
			startingAt: 1
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			startingAt: 1
			ifAbsent: [ 99 ]) = 99! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfSubCollectionStartingAt
	"self debug: #testIndexOfIfAbsent"
	| subcollection index collection |
	collection := self collectionMoreThan1NoDuplicates.
	subcollection := self collectionMoreThan1NoDuplicates.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 1.
	self assert: index = 1.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 2.
	self assert: index = 0! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfSubCollectionStartingAtIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| index absent subcollection collection |
	collection := self collectionMoreThan1NoDuplicates.
	subcollection := self collectionMoreThan1NoDuplicates.
	absent := false.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 1
		ifAbsent: [ absent := true ].
	self assert: absent = false.
	absent := false.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 2
		ifAbsent: [ absent := true ].
	self assert: absent = true! !

!DOArrayTest methodsFor: 'testing' stamp: 'zz 12/5/2005 17:12'!
testIsArray
	
	self assert: example1 isArray! !

!DOArrayTest methodsFor: 'testing' stamp: 'nice 11/3/2009 21:28'!
testIsLiteral
	"We work with a copy of literalArray, to avoid corrupting the code."
	
	| aLiteralArray |
	aLiteralArray := literalArray copy.
	self assert: aLiteralArray isLiteral.
	aLiteralArray at: 1 put: self class.
	self deny: aLiteralArray isLiteral.
	self deny: (literalArray as: WeakArray) isLiteral description: 'instances of Array subclasses are not literal'.! !

!DOArrayTest methodsFor: 'testing' stamp: 'zz 12/5/2005 17:18'!
testIsSelfEvaluating

	self assert: example1 isSelfEvaluating.
	example1 at: 1 put: Bag new.
	self deny: example1 isSelfEvaluating.
	example1 at: 1 put: 1.! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testKeysAndValuesDo
	"| result |
	result:= OrderedCollection new.
	
	self nonEmptyMoreThan1Element  keysAndValuesDo: 
		[:i :value|
		result add: (value+i)].
	
	1 to: result size do:
		[:i|
		self assert: (result at:i)=((self nonEmptyMoreThan1Element at:i)+i)]"
	|  indexes elements |
	indexes:= DOOrderedCollection new.
	elements := DOOrderedCollection new.
	
	self nonEmptyMoreThan1Element  keysAndValuesDo: 
		[:i :value|
		indexes  add: (i).
		elements add: value].
	
	(1 to: self nonEmptyMoreThan1Element size )do:
		[ :i |
		self assert: (indexes at: i) = i.
		self assert: (elements at: i) = (self nonEmptyMoreThan1Element at: i).	
		].
	
	self assert: indexes size = elements size. 
	self assert: indexes size = self nonEmptyMoreThan1Element size . 
	
	! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testKeysAndValuesDoEmpty
	| result |
	result:= DOOrderedCollection new.
	
	self empty  keysAndValuesDo: 
		[:i :value|
		result add: (value+i)].
	
	self assert: result isEmpty .! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOf
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection lastIndexOf: element) = 1.
	self assert: (collection lastIndexOf: self elementNotInForIndexAccessing) = 0! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOfIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			lastIndexOf: element
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			lastIndexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 99 ]) = 99! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOfStartingAt
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection last.
	self assert: (collection 
			lastIndexOf: element
			startingAt: collection size
			ifAbsent: [ 99 ]) = collection size.
	self assert: (collection 
			lastIndexOf: element
			startingAt: collection size - 1
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			lastIndexOf: self elementNotInForIndexAccessing
			startingAt: collection size
			ifAbsent: [ 99 ]) = 99! !

!DOArrayTest methodsFor: 'testing' stamp: 'StephaneDucasse 1/16/2010 10:07'!
testLiteralEqual

	self deny: (example1 literalEqual: example1 asIntegerArray)! !

!DOArrayTest methodsFor: 'testing' stamp: 'pmaer 4/27/2012 13:59'!
testNewWithSize
	|array|
	array := DOArray new: 5.
	self assert: array size = 5.
	1 to: 5 do: [:index | self assert: (array at: index) isNil]! !

!DOArrayTest methodsFor: 'tests - occurrencesOf' stamp: 'delaunay 4/2/2009 11:52'!
testOccurrencesOf
	| result expected |
	result := self nonEmpty occurrencesOf: self elementInForOccurrences.
	expected := 0.
	self nonEmpty do: [ :each | self elementInForOccurrences = each ifTrue: [ expected := expected + 1 ] ].
	self assert: result = expected! !

!DOArrayTest methodsFor: 'tests - occurrencesOf' stamp: 'delaunay 4/2/2009 11:52'!
testOccurrencesOfEmpty
	| result |
	result := self empty occurrencesOf: self elementInForOccurrences.
	self assert: result = 0! !

!DOArrayTest methodsFor: 'tests - occurrencesOf' stamp: 'delaunay 4/2/2009 11:53'!
testOccurrencesOfNotIn
	| result |
	result := self empty occurrencesOf: self elementNotInForOccurrences.
	self assert: result = 0! !

!DOArrayTest methodsFor: 'testing' stamp: 'pmaer 5/7/2012 15:25'!
testPrinting
	<broken>
	"Compiler evaluate:  creates an Array, not a DOArray"
	self assert: literalArray printString = '#(1 true 3 #four)'.
	self assert: (literalArray = (Compiler evaluate: literalArray printString)).
	self assert: (selfEvaluatingArray = (Compiler evaluate: selfEvaluatingArray printString)).
	self assert: nonSEArray1 printString =  'an Array(1 a Set(1))'.
	self assert: nonSEarray2 printString = '{(#DOArray->DOArray)}'
! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testReverseDo
	| result |
	result:= DOOrderedCollection new.
	self nonEmpty reverseDo: [: each | result add: each].
	
	1 to: result size do:
		[:i|
		self assert: (result at: i)=(self nonEmpty at:(self nonEmpty size-i+1))].! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testReverseDoEmpty
	| result |
	result:= DOOrderedCollection new.
	self empty reverseDo: [: each | result add: each].
	
	self assert: result isEmpty .! !

!DOArrayTest methodsFor: 'tests - puting with indexes' stamp: 'Anonymous 5/24/2010 14:30'!
testSwapWith
	"self debug: #testSwapWith"
	| result index |
	index := self indexArray anyOne.
	result:= self nonEmpty copy .
	result swap: index with: 1.
	self assert: (result at: index) = (self nonEmpty at:1).
	self assert: (result at: 1) = (self nonEmpty at: index).
	! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testWithIndexDo
	
	"| result |
	result:=Array new: self nonEmptyMoreThan1Element size.
	self nonEmptyMoreThan1Element  withIndexDo: [:each :i | result at:i put:(each+i)].
	
	1 to: result size do:[: i | self assert: (result at:i)= ((self nonEmptyMoreThan1Element at: i) + i)]"
	|  indexes elements |
	indexes:= DOOrderedCollection new.
	elements := DOOrderedCollection new.
	
	self nonEmptyMoreThan1Element  withIndexDo: 
		[:value :i  |
		indexes  add: (i).
		elements add: value].
	
	(1 to: self nonEmptyMoreThan1Element size )do:
		[ :i |
		self assert: (indexes at: i) = i.
		self assert: (elements at: i) = (self nonEmptyMoreThan1Element at: i).	
		].
	
	self assert: indexes size = elements size. 
	self assert: indexes size = self nonEmptyMoreThan1Element size . 
	! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/27/2009 15:20'!
unsortedCollection
	^unsortedCollection .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 13:59'!
valueArray
" return a collection (with the same size than 'indexArray' )of values to be put in 'nonEmpty'  at indexes in 'indexArray' "
	| result |
	result := DOArray new: self indexArray size.
	1 to: result size do:
		[:i |
		result at:i put: (self aValue ).
		].
	^ result.! !

!DOArrayTest methodsFor: 'parameters' stamp: 'stephane.ducasse 10/9/2008 18:49'!
valuePutIn
	"the value that we will put in the non empty collection"
	
	^ 2! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 14:11'!
withEqualElements
	" return a collection of float including equal elements (classic equality)"
	^ collectionOfFloatWithEqualElements! !

CollectionRootTest subclass: #DOOrderedCollectionTest
	uses: TEmptySequenceableTest + TAddTest + TSequencedElementAccessTest + TIncludesWithIdentityCheckTest + TCloneTest + TSetArithmetic + TRemoveForMultiplenessTest + TCreationWithTest + TCopyTest + TPutBasicTest + TIterateSequencedReadableTest + TSubCollectionAccess + TIndexAccess + TCopySequenceableWithReplacement + TCopyPartOfSequenceable + TCopySequenceableSameContents + TCopySequenceableWithOrWithoutSpecificElements - {#testForceToPaddingWith. #testForceToPaddingStartWith} + TPrintOnSequencedTest + TAsStringCommaAndDelimiterSequenceableTest + TConvertTest + TConvertAsSetForMultiplinessIdentityTest + TSequencedConcatenationTest + TBeginsEndsWith + TReplacementSequencedTest + TIndexAccessForMultipliness + TCopyPartOfSequenceableForMultipliness + TConvertAsSortedTest + TPutTest + TSequencedStructuralEqualityTest + TOccurrencesForMultiplinessTest
	instanceVariableNames: 'empty nonEmpty collectResult emptyButAllocatedWith20 otherCollection indexCollection elementExistsTwice collectionWithElement collectionOfFloat elementNotIn indexArray withoutEqualElements floatCollectionWithSameBeginingEnd duplicateElement collectionWithDuplicateElement collection5Elements collectionWith4Elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-AdaptedClasses'!

!DOOrderedCollectionTest commentStamp: 'BG 1/10/2004 22:07' prior: 0!
These test cases demonstrate addition of items into an OrderedCollection as well as item removal.

Some of the assertions are quite complicated and use a lot of collection protocol. Such methods do not test one single method, but protocol in general.!

DOOrderedCollectionTest class
	uses: TEmptySequenceableTest classTrait + TAddTest classTrait + TSequencedElementAccessTest classTrait + TCloneTest classTrait + TCopyTest classTrait + TSetArithmetic classTrait + TCreationWithTest classTrait + TRemoveForMultiplenessTest classTrait + TPutBasicTest classTrait + TIterateSequencedReadableTest classTrait + TSubCollectionAccess classTrait + TIndexAccess classTrait + TCopySequenceableWithReplacement classTrait + TCopyPartOfSequenceable classTrait + TCopySequenceableSameContents classTrait + TCopySequenceableWithOrWithoutSpecificElements classTrait + TPrintOnSequencedTest classTrait + TAsStringCommaAndDelimiterSequenceableTest classTrait + TConvertTest classTrait + TSequencedConcatenationTest classTrait + TBeginsEndsWith classTrait + TReplacementSequencedTest classTrait + TIndexAccessForMultipliness classTrait + TCopyPartOfSequenceableForMultipliness classTrait + TConvertAsSortedTest classTrait + TPutTest classTrait + TIncludesWithIdentityCheckTest classTrait + TConvertAsSetForMultiplinessIdentityTest classTrait + TSequencedStructuralEqualityTest classTrait + TOccurrencesForMultiplinessTest classTrait
	instanceVariableNames: ''!

!DOOrderedCollectionTest class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:02'!
compilerClass
	^DOTestsCompiler! !

!DOOrderedCollectionTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:13'!
aValue

	^ 33! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'stephane.ducasse 10/30/2008 19:03'!
accessCollection

	^ indexCollection! !

!DOOrderedCollectionTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:13'!
anIndex

	^ 2! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'stephane.ducasse 11/21/2008 14:57'!
anotherElementNotIn
	^ 42! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:04'!
anotherElementOrAssociationIn
	" return an element (or an association for Dictionary ) present  in 'collection' "
	^ self collection  anyOne! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:04'!
anotherElementOrAssociationNotIn
	" return an element (or an association for Dictionary )not present  in 'collection' "
	^ elementNotIn ! !

!DOOrderedCollectionTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:19'!
anotherValue

	^ 66! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'cyrille.delaunay 12/18/2009 13:03'!
collection

	^ collectionWith4Elements! !

!DOOrderedCollectionTest methodsFor: 'test - creation' stamp: 'pmaer 4/27/2012 14:02'!
collectionClass 
	
	^ DOOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:00'!
collectionInForIncluding
	^ self nonEmpty copyWithoutFirst.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 15:16'!
collectionMoreThan1NoDuplicates
	" return a collection of size 5 without equal elements"
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 5/14/2009 13:59'!
collectionMoreThan5Elements
" return a collection including at least 5 elements"
	
	^collection5Elements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 14:02'!
collectionNotIncluded
	^ DOOrderedCollection new add: elementNotIn ; add: elementNotIn ; yourself.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 10:56'!
collectionOfFloat
	^ collectionOfFloat ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 14:02'!
collectionWith1TimeSubcollection
" return a collection including 'oldSubCollection'  only one time "
	^ ((DOOrderedCollection new add: elementNotIn; yourself),self oldSubCollection) add: elementNotIn;yourself   ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 14:02'!
collectionWith2TimeSubcollection
" return a collection including 'oldSubCollection'  two or many time "
	^ (((DOOrderedCollection new add: elementNotIn; yourself),self oldSubCollection ) add: elementNotIn;yourself),self  oldSubCollection! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/22/2009 10:21'!
collectionWith5Elements
" return a collection of size 5 including 5 elements"
^ indexCollection ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 14:02'!
collectionWithCopy
	"return a collection of type 'self collectionWIithoutEqualsElements clas' containing no elements equals ( with identity equality)
	but  2 elements only equals with classic equality"
	| result collection |
	collection := DOOrderedCollection withAll: self elementsCopyNonIdenticalWithoutEqualElements.
	collection add: collection first copy.
	result := self elementsCopyNonIdenticalWithoutEqualElements class withAll: collection.
	^ result! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 10:22'!
collectionWithCopyNonIdentical
	" return a collection that include elements for which 'copy' return a different object (this is not the case of SmallInteger)"
	^ collectionOfFloat! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'sd 1/28/2009 16:29'!
collectionWithElement
	"Returns a collection that already includes what is returned by #element."
	^ collectionWithElement! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:22'!
collectionWithElementsToRemove
	^ nonEmpty copyWithoutFirst.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 16:10'!
collectionWithEqualElements
" return a collecition including atLeast two elements equal"

^collectionWithDuplicateElement ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 14:02'!
collectionWithIdentical
	"return a collection of type : 'self collectionWIithoutEqualsElements class containing two elements equals ( with identity equality)"
	| result collection element |
	collection := DOOrderedCollection withAll: self elementsCopyNonIdenticalWithoutEqualElements.
	element := collection first.
	collection add: element.
	result := self elementsCopyNonIdenticalWithoutEqualElements class withAll: collection.
	^ result! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:16'!
collectionWithNonIdentitySameAtEndAndBegining
	" return a collection with elements at end and begining equals only with classic equality (they are not the same object).
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingEnd ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/22/2009 11:14'!
collectionWithSameAtEndAndBegining
" return a collection with elements at end and begining equals .
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingEnd ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 10:24'!
collectionWithSortableElements
" return a collection elements that can be sorte ( understanding message ' < '  or ' > ')"
	^ collectionOfFloat ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:00'!
collectionWithoutEqualElements
" return a collection without equal elements"
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:35'!
collectionWithoutEqualsElements

" return a collection not including equal elements "
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 11:17'!
collectionWithoutNilElements
" return a collection that doesn't includes a nil element  and that doesn't includes equal elements'"
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'StephaneDucasse 5/15/2011 17:27'!
element
	"Returns an object that can be added to the collection returned by #collection."
	^ 3! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:03'!
elementInCollectionOfFloat
	^ collectionOfFloat anyOne.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:42'!
elementInForElementAccessing
" return an element inculded in 'accessCollection '"
	^ self accessCollection anyOne! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:03'!
elementInForIncludesTest
" return an element included in nonEmpty "
	^ self nonEmpty anyOne! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 13:27'!
elementInForIndexAccessing

^ self accessCollection  anyOne.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:02'!
elementNotIn
	^ elementNotIn ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:42'!
elementNotInForElementAccessing
" return an element not included in 'accessCollection' "
	^ elementNotIn ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:32'!
elementNotInForIndexAccessing

	^ elementNotIn ! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
elementNotInForOccurrences
	^ 666! !

!DOOrderedCollectionTest methodsFor: 'test - copy' stamp: 'delaunay 4/17/2009 15:26'!
elementToAdd
	^ 55! !

!DOOrderedCollectionTest methodsFor: 'test - remove' stamp: 'damienpollet 1/30/2009 17:16'!
elementTwiceIn
	^ super elementTwiceIn! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 16:10'!
elementTwiceInForOccurrences
" return an element included exactly two time in # collectionWithEqualElements"
^ duplicateElement ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 13:46'!
elementsCopyNonIdenticalWithoutEqualElements
	" return a collection that does niot incllude equal elements ( classic equality )"
	^ collectionOfFloat! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'stephane.ducasse 10/5/2008 12:10'!
empty
	
	^ empty! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'stephane.ducasse 10/6/2008 16:29'!
emptyButAllocatedWith20 

	^ emptyButAllocatedWith20! !

!DOOrderedCollectionTest methodsFor: 'test - iterate' stamp: 'luc.fabresse 11/29/2008 23:09'!
expectedSizeAfterReject
	^1! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:12'!
firstCollection
" return a collection that will be the first part of the concatenation"
	^ nonEmpty 	! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:41'!
firstIndex
" return an index between 'nonEmpty' bounds that is < to 'second index' "
	^1! !

!DOOrderedCollectionTest methodsFor: 'tests - copying with replacement' stamp: 'pmaer 4/27/2012 14:02'!
firstIndexesOf: subCollection in: collection
" return an OrderedCollection with the first indexes of the occurrences of subCollection in  collection "
	| tmp result currentIndex |
	tmp:= collection.
	result:= DOOrderedCollection new.
	currentIndex := 1.
	
	[tmp isEmpty ]whileFalse:
		[
		(tmp beginsWith: subCollection)
			ifTrue: [ 	
				result add: currentIndex.
				1 to: subCollection size do: 
					[:i | 
					tmp := tmp copyWithoutFirst.
					currentIndex := currentIndex + 1]
				]
			ifFalse: [
				tmp := tmp copyWithoutFirst.
				currentIndex := currentIndex +1.
				]
		 ].
	
	^ result.
	! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/21/2009 13:48'!
floatCollectionWithSameAtEndAndBegining
" return a collection with elements at end and begining equals only with classic equality (they are not the same object).
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingEnd ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:49'!
indexArray
	^ indexArray .! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:35'!
indexInForCollectionWithoutDuplicates
" return an index between 'collectionWithoutEqualsElements'  bounds"
	^ 2! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:44'!
indexInNonEmpty
" return an index between bounds of 'nonEmpty' "

	^ 2! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:37'!
integerCollection
" return a collection only including SmallInteger elements"
	^ indexCollection ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:01'!
integerCollectionWithoutEqualElements
" return a collection of integer without equal elements"
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:52'!
moreThan3Elements
	" return a collection including atLeast 3 elements"
	^ indexCollection ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:52'!
moreThan4Elements

" return a collection including at leat 4 elements"
	^ indexCollection ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:42'!
newElement
"return an element that will be put in the collection in place of another"
	^999! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'stephane.ducasse 10/5/2008 12:10'!
nonEmpty
	
	^ nonEmpty! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 14:02'!
nonEmpty1Element
" return a collection of size 1 including one element"
	^ DOOrderedCollection new add:( self nonEmpty anyOne); yourself.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 14:05'!
nonEmptyMoreThan1Element
" return a collection with more than one element"
	^ withoutEqualElements  .! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 11:29'!
nonEmptyWithoutEqualElements
" return a collection without equal elements "
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 13:38'!
oldSubCollection
" return a subCollection included in collectionWith1TimeSubcollection .
ex :   subCollection := #( 2 3 4) and collectionWith1TimeSubcollection := #(1 2 3 4 5)"
	^ nonEmpty ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'stephane.ducasse 10/8/2008 16:04'!
otherCollection
	^ otherCollection! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:09'!
replacementCollection
" return a collection that will be used to replace 'oldSubcollection' in ' collectionWith1TimeSubcollection'  " 
	^ collectionWith4Elements! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 14:02'!
replacementCollectionSameSize
" return a collection of size (secondIndex - firstIndex + 1)"

| res |
res := DOOrderedCollection new.
1 to: (self secondIndex - self firstIndex + 1) do:
	[
	:i |
	res add: 99.
	].
	^res.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 12:05'!
result

^ collectResult ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:11'!
secondCollection
" return a collection that will be the second part of the concatenation"
	^ collectionWith4Elements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:42'!
secondIndex
" return an index between 'nonEmpty' bounds that is > to 'second index' "
	^2! !

!DOOrderedCollectionTest methodsFor: 'parameters' stamp: 'stephane.ducasse 10/5/2008 12:38'!
selectorToAccessValuePutIn
	"return the selector of the method that should be invoked to access an element"
	
	^ #first! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'pmaer 4/27/2012 14:02'!
setUp

	
	nonEmpty := DOOrderedCollection new  add: self valuePutIn; add: self elementTwiceIn; add: self elementTwiceIn; yourself.
	empty := DOOrderedCollection new. 
	elementNotIn := 99.
	collectionWith4Elements := DOOrderedCollection new add: 1; add: -2; add: 3; add: 1; yourself.
	indexArray := { 3. 1.}.
	indexCollection := DOOrderedCollection new add: 1; add: 2;add: 3; add: 4; add:5;  yourself.
	otherCollection := DOOrderedCollection new add: 1;add: 20; add: 30; yourself.
	withoutEqualElements := DOOrderedCollection new add: 1;add: 20; add: 30; yourself.
	collectResult := DOOrderedCollection new add: SmallInteger; add: SmallInteger; add: SmallInteger; yourself.
	emptyButAllocatedWith20 := DOOrderedCollection new: 20. 
	collectionWithElement := DOOrderedCollection new add: self element; yourself.
	collectionOfFloat := DOOrderedCollection new add: 4.1; add: 7.2; add: 2.5; yourself.
	floatCollectionWithSameBeginingEnd := DOOrderedCollection new add: 4.1; add: 7.2; add: 4.1 copy ; yourself.
	duplicateElement := 2.
	collectionWithDuplicateElement := DOOrderedCollection new add: duplicateElement ; add: duplicateElement ; add:4 ; yourself.	

	collection5Elements := DOOrderedCollection new add: 1; add: 2;  add: 3;  add: 4;  add: 5; yourself.! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'cyrille.delaunay 12/18/2009 13:09'!
sizeCollection

	^ collectionWith4Elements! !

!DOOrderedCollectionTest methodsFor: 'test - iterate' stamp: 'pmaer 4/27/2012 14:02'!
speciesClass
	
	^ DOOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:02'!
subCollectionNotIn

	^ self collectionNotIncluded .! !

!DOOrderedCollectionTest methodsFor: 'tests - fixture' stamp: 'pmaer 4/27/2012 14:02'!
test0FixtureOccurrencesTest
	| tmp |
	self shouldnt: [self empty ]raise: Error.
	self assert: self empty isEmpty.

	self shouldnt: [ self collectionWithoutEqualElements ] raise: Error.
	self deny: self collectionWithoutEqualElements isEmpty.
	
	tmp := DOOrderedCollection new.
	self collectionWithoutEqualElements do: [ 
		:each |
		self deny: (tmp includes: each).
		tmp add: each.
		 ].
	
	
	self shouldnt: [ self elementNotInForOccurrences ] raise: Error.
	self deny: (self collectionWithoutEqualElements includes: self elementNotInForOccurrences)! !

!DOOrderedCollectionTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/28/2009 14:11'!
test0FixtureTConvertAsSetForMultiplinessTest
	"a collection ofFloat with equal elements:"
	| res |
	self 
		shouldnt: [ self withEqualElements ]
		raise: Error.
	self 
		shouldnt: 
			[ self withEqualElements do: [ :each | self assert: each class = Float ] ]
		raise: Error.
	res := true.
	self withEqualElements 
		detect: [ :each | (self withEqualElements occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = true.

	"a collection of Float without equal elements:"
	self 
		shouldnt: [ self elementsCopyNonIdenticalWithoutEqualElements ]
		raise: Error.
	self 
		shouldnt: 
			[ self elementsCopyNonIdenticalWithoutEqualElements do: [ :each | self assert: each class = Float ] ]
		raise: Error.
	res := true.
	self elementsCopyNonIdenticalWithoutEqualElements 
		detect: 
			[ :each | 
			(self elementsCopyNonIdenticalWithoutEqualElements occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = false! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 19:00'!
testAdd
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 88.
	self assert: (l =  #(1 2 3 4 88) asOrderedCollection).
	l add: 99.
	self assert: (l =  #(1 2 3 4 88 99) asOrderedCollection). 

! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 18:52'!
testAddAfter

	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 88 after: 1.
	self assert: (l =  #(1 88 2 3 4) asOrderedCollection).
	l add: 99 after: 2.
	self assert: (l =  #(1 88 2 99 3 4) asOrderedCollection). 

! !

!DOOrderedCollectionTest methodsFor: 'testing-public methods' stamp: 'StephaneDucasse 3/22/2010 21:18'!
testAddAfterIndex
	"self run: #testAddAfterIndex"
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 77 afterIndex: 0.
	self assert: (l =  #(77 1 2 3 4) asOrderedCollection).
	l add: 88 afterIndex: 2.
	self assert: (l =  #(77 1 88 2 3 4) asOrderedCollection). 
	l add: 99 afterIndex: l size.
	self assert: (l =  #(77 1 88 2 3 4 99) asOrderedCollection). 
	self should:[l add: 666 afterIndex: -1] raise: Error.
	self should:[l add: 666 afterIndex: l size+1] raise: Error.
	
	"Now make room by removing first two and last two elements,
	and see if the illegal bounds test still fails"
	(l first: 2) , (l last: 2) reversed do: [:e | l remove: e].
	self should: [l add: 666 afterIndex: -1] raise: Error.
	self should: [l add: 666 afterIndex: l size+1] raise: Error.! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 3/21/2006 22:36'!
testAddAll
	"Allows one to add each element of an orderedCollection at the end of another
	orderedCollection "
	"self run:#testAddAll" 
	
	| c1 c2 |
	c1 := #(1 2 3 4 ) asOrderedCollection.
	c2 := #(5 6 7 8 9 ) asOrderedCollection.
	c1 addAll: c2.
	self assert: c1 = #(1 2 3 4 5 6 7 8 9) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 3/21/2006 22:36'!
testAddAllFirst
	"Allows one to add each element of an orderedCollection at the beginning of another
	orderedCollection "
	"self run:#testAddAllFirst" 
	
	| c1 c2 |
	c1 := #(1 2 3 4 ) asOrderedCollection.
	c2 := #(5 6 7 8 9 ) asOrderedCollection.
	c2 addAllFirst: c1.
	self assert: c2 = #(1 2 3 4 5 6 7 8 9) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 3/21/2006 22:36'!
testAddAllFirstUnlessAlreadyPresent
	"Allows one to add each element of an orderedCollection at the beginning of
	another orderedCollection preserving the order but no duplicate element"
	"self run:#testAddAllFirstUnlessAlreadyPresent" 
	
	| c1 c2 c3 |
	c1 := #(1 2 3 4 ) asOrderedCollection.
	c2 := #(5 6 7 8 9 ) asOrderedCollection.
	c3 := #(0 1 ) asOrderedCollection.
	c2 addAllFirstUnlessAlreadyPresent: c1.
	self assert: c2 = #(1 2 3 4 5 6 7 8 9 ) asOrderedCollection.
	c1 addAllFirstUnlessAlreadyPresent: c3.
	self deny: c1 = #(0 1 1 2 3 4 ) asOrderedCollection.
	self assert: c1 = #(0 1 2 3 4 ) asOrderedCollection.
	! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 3/21/2006 22:36'!
testAddAllLast
	"Allows one to add each element of an orderedCollection at the beginning of another
	orderedCollection "
	"self run:#testAddAllLast" 
	
	| c1 c2 |
	c1 := #(1 2 3 4 ) asOrderedCollection.
	c2 := #(5 6 7 8 9 ) asOrderedCollection.
	c1 addAllLast: c2.
	self assert: c1 = #(1 2 3 4 5 6 7 8 9) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 18:57'!
testAddBefore

	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 88 before: 1.
	self assert: (l =  #(88 1 2 3 4) asOrderedCollection).
	l add: 99 before: 2.
	self assert: (l =  #(88 1 99 2 3 4) asOrderedCollection). 

! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 13:42'!
testAddBeforeAndRemove

	| l initialCollection |
	l := #(1 2 3 4) asOrderedCollection.
	initialCollection := l shallowCopy.
	l add: 88 before: 1.
	self assert: (l =  #(88 1 2 3 4) asOrderedCollection).
	l add: 99 before: 2.
	self assert: (l =  #(88 1 99 2 3 4) asOrderedCollection). 
	l remove: 99.
	l remove: 88.
	self assert: l = initialCollection.

! !

!DOOrderedCollectionTest methodsFor: 'testing-public methods' stamp: 'StephaneDucasse 3/22/2010 21:17'!
testAddBeforeIndex
	"self run: #testAddBeforeIndex"
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 77 beforeIndex: 1.
	self assert: (l =  #(77 1 2 3 4) asOrderedCollection).
	l add: 88 beforeIndex: 3.
	self assert: (l =  #(77 1 88 2 3 4) asOrderedCollection). 
	l add: 99 beforeIndex: l size+1.
	self assert: (l =  #(77 1 88 2 3 4 99) asOrderedCollection). 
	self should:[l add: 666 beforeIndex: 0] raise: Error.
	self should:[l add: 666 beforeIndex: l size+2] raise: Error.
	
	"Now make room by removing first two and last two elements,
	and see if the illegal bounds test still fails"
	(l first: 2) , (l last: 2) reversed do: [:e | l remove: e].
	self should:[l add: 666 beforeIndex: 0] raise: Error.
	self should:[l add: 666 beforeIndex: l size+2] raise: Error.

! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 13:43'!
testAddDuplicateItem1
	| collection |
	collection := #('Jim' 'Mary' 'John' 'Andrew' ) asOrderedCollection.
	collection add: 'John' before: 'John'.
	self
		assert: ((collection asBag occurrencesOf: 'John')
					= 2
				and: [(collection at: (collection indexOf: 'John')
							+ 1)
						= (collection
								at: (collection indexOf: 'John'))])! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 18:58'!
testAddFirst
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l addFirst: 88.
	self assert: (l =  #(88 1 2 3 4) asOrderedCollection).
	l addFirst: 99.
	self assert: (l =  #(99 88 1 2 3 4) asOrderedCollection). 

! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 6/5/2005 09:21'!
testAddItem1

   | collection size |
   collection := #('Jim' 'Mary' 'John' 'Andrew' ) asOrderedCollection.
   size := collection size.
   collection add: 'James' before: 'Jim'.
   collection add: 'Margaret' before: 'Andrew'.
   self assert: size + 2 = collection size.
! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 19:07'!
testAddItem2
	| collection |
	collection := #('Jim' 'Mary' 'John' 'Andrew' ) asOrderedCollection.
	collection add: 'James' before: 'Jim'.
	collection add: 'Margaret' before: 'Andrew'.
	self assert: (collection indexOf: 'James')
			+ 1
			= (collection indexOf: 'Jim').
	self assert: (collection indexOf: 'Margaret')
			+ 1
			= (collection indexOf: 'Andrew')! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 18:59'!
testAddLast
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l addLast: 88.
	self assert: (l =  #(1 2 3 4 88) asOrderedCollection).
	l addLast: 99.
	self assert: (l =  #(1 2 3 4 88 99) asOrderedCollection). 

! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testAllButFirstDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  allButFirstDo: [:each | result add: each].
	
	1 to: (result size) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:(i +1))=(result at:i)].
	
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testAllButLastDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  allButLastDo: [:each | result add: each].
	
	1 to: (result size) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:(i ))=(result at:i)].
	
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOOrderedCollectionTest methodsFor: 'tests - converting' stamp: 'pmaer 4/27/2012 14:00'!
testAsArray
	"self debug: #testAsArray3"
	self 
		assertSameContents: self collectionWithoutEqualElements
		whenConvertedTo: DOArray! !

!DOOrderedCollectionTest methodsFor: 'tests - converting' stamp: 'pmaer 4/27/2012 14:02'!
testAsOrderedCollection
	
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: DOOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - as sorted collection' stamp: 'pmaer 4/27/2012 14:00'!
testAsSortedArray
	| result collection |
	collection := self collectionWithSortableElements .
	result := collection  asArray sort.
	self assert: (result class includesBehavior: DOArray).
	self assert: result isSorted.
	self assert: result size = collection size! !

!DOOrderedCollectionTest methodsFor: 'tests - accessing' stamp: 'zz 12/7/2005 18:50'!
testAt
	| collection |
	collection := #('Jim' 'Mary' 'John' 'Andrew' ) asOrderedCollection.
	self assert: (collection at:1) = 'Jim'.
	self assert: (collection at:2) = 'Mary'! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 3/21/2006 22:37'!
testAtIfAbsentPut
	"Allows one to add an element at an index if no element exist at this index"
	"self run:#testAtIfAbsentPut" 
	
	| c |
	c := #(1 2 3 4 ) asOrderedCollection.
	self
		shouldnt: [c at: 2 ifAbsentPut: [5]]
		raise: Error.
	self assert: c = #(1 2 3 4 ) asOrderedCollection.
	c at: 5 ifAbsentPut: [5].
	self assert: c = #(1 2 3 4 5 ) asOrderedCollection.
	c at: 7 ifAbsentPut: [7].
	self assert: c = #(1 2 3 4 5 nil 7 ) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - accessing' stamp: 'sd 3/21/2006 22:38'!
testAtPut
	"Allows one to replace an element but not at an off range index"
	"self run:#testAtPut"
	| c |
	c := #(1 2 3 4 ) asOrderedCollection.
	c at: 2 put: 5.
	self assert: c = #(1 5 3 4 ) asOrderedCollection.
	self
		should: [c at: 5 put: 8]
		raise: Error.
	self deny: c = #(1 5 3 4 8 ) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests begin ' stamp: 'pmaer 4/27/2012 14:02'!
testBeginsWithAnyOf
	"We can't test SequenceableCollection directly. However, we can test a sampling of its descendants."
	"self debug: #testBeginsWithAnyOf"
	
	| la oc |
	la := #(1 2 3 4 5 6).
	oc := DOOrderedCollection new.
	oc add: 1; add: 2; add: 3.
	
	self assert: (la beginsWithAnyOf: #((17) (1) (42))).
	self assert: (la beginsWithAnyOf: #((17) (1 2) (42))).
	self assert: (la beginsWithAnyOf: #((17) (1 2 3) (42))).
	self deny: (la beginsWithAnyOf: #()).
	self deny: (la beginsWithAnyOf: #(())).
	self deny: (la beginsWithAnyOf: #((42))).! !

!DOOrderedCollectionTest methodsFor: 'tests - accessing' stamp: 'pmaer 4/27/2012 14:02'!
testCapacityFromAsOrderedCollection
	"Allows one to check the current capacity of an Ordered collection"
	"self run:#testCapacityFromAsOrderedCollection"
	
	| c1 c2 c3 |
	c1 := #(1 2 ) asOrderedCollection.
	self assert: (c1 capacity =  2).
	c2 := DOOrderedCollection new: 10.
	c2 add: 3.
	self assert: (c2 capacity = 10).	
	c3 := DOOrderedCollection new.
	self deny: (c3 capacity =  0).
	! !

!DOOrderedCollectionTest methodsFor: 'tests - enumerating' stamp: 'sd 3/21/2006 22:41'!
testCollect
	"Allows one to collect some element of a collection into another collection"
	"self run: #testCollect"
	 
	| c1 c2 res |
	c1 := #(-1 2 -3 4) asOrderedCollection.
	c2 := #(1 2 3 4) asOrderedCollection.
	res := c1 collect: [:each | each abs].
	self assert: (c2 = res).! !

!DOOrderedCollectionTest methodsFor: 'tests - enumerating' stamp: 'cm 3/8/2006 09:09'!
testCollectFromTo
	"Allows one to collect some element of a collection into another collection between a first index and an end index for the collect"
	"self run: #testCollectFromTo"
	
	| c1 res |
	c1 := #(-1 2 -3 4 -5 6 -7 8) asOrderedCollection.
	res := c1 collect: [:each | each abs] from: 1 to: 3.
	self assert: (res = #(1 2 3) asOrderedCollection).
	self should: [c1 collect: [:each | each abs] from: 10 to: 13] raise: Error.
	self should: [c1 collect: [:each | each abs] from: 5 to: 2] raise: Error.! !

!DOOrderedCollectionTest methodsFor: 'tests - copying' stamp: 'stephane.ducasse 1/12/2009 15:02'!
testCopyEmptyOld
	"Allows one to create a copy of the receiver that contains no elements"
	"self run:#testCopyEmpty"
	
	| c1 c2 |
	c1 := #(1 2 3 4 ) asOrderedCollection.
	c2 := c1 copyEmpty.
	self assert: (c2 size = 0).! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWith
	"self debug: #testCopyWith"
	| res |
	res := self empty copyWith: self elementToAdd.
	self assert: res size = (self empty size + 1).
	self assert: (res includes: self elementToAdd)! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWithout
	"self debug: #testCopyEmptyWithout"
	| res |
	res := self empty copyWithout: self elementToAdd.
	self assert: res size = self empty size.
	self deny: (res includes: self elementToAdd)! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyEmptyWithoutAll
	"self debug: #testCopyEmptyWithoutAll"
	| res |
	res := self empty copyWithoutAll: self collectionWithElementsToRemove.
	self assert: res size = self empty size.
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ]! !

!DOOrderedCollectionTest methodsFor: 'tests - copying' stamp: 'sd 3/21/2006 22:41'!
testCopyFromTo
	"Allows one to create a copy of the receiver that contains elements from position start to end"
	"self run: #testCopyFromTo"
	
	| c1 c2 c3 | 
	c1 := #(1 2 3 4) asOrderedCollection.
	c2 := (c1 copyFrom: 1 to: 2).
	self assert: c2 = #(1 2) asOrderedCollection.
	self should: [c1 copyFrom: 10 to: 20] raise: Error.
	
	c3 := c1 copyFrom: 4 to: 2.
	self assert: c3 isEmpty.
	
	self should: [c1 copyFrom: 4 to: 5 ] raise: Error.
	
	
	
! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWith
	"self debug: #testCopyNonEmptyWith"
	| res |
	res := self nonEmpty copyWith: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self assert: (res includes: self elementToAdd).
	self nonEmpty do: [ :each | res includes: each ]! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyNonEmptyWithoutAll
	"self debug: #testCopyNonEmptyWithoutAll"
	| res |
	res := self nonEmpty copyWithoutAll: self collectionWithElementsToRemove.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ].
	self nonEmpty do: 
		[ :each | 
		(self collectionWithElementsToRemove includes: each) ifFalse: [ self assert: (res includes: each) ] ]! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 3/30/2009 10:33'!
testCopyNonEmptyWithoutAllNotIncluded
	! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWithoutNotIncluded
	"self debug: #testCopyNonEmptyWithoutNotIncluded"
	| res |
	res := self nonEmpty copyWithout: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self nonEmpty do: [ :each | self assert: (res includes: each) ]! !

!DOOrderedCollectionTest methodsFor: 'tests - copying' stamp: 'sd 3/21/2006 22:41'!
testCopyReplaceFromToWith
	"Allows one to create a copy from the receiver which elements between start and end of the 	receiver being replace by 	element of the collection after with:"
	"self run:#testCopyReplaceFromToWith"

	| c1 c2 c3 c4 |
	c1 := #(1 2 3 4) asOrderedCollection.
	c2 := #(5 6 7 8 9) asOrderedCollection.
	c3 := (c2 copyReplaceFrom: 1 to: 2 with: c1).
	self assert: c3 = #(1 2 3 4 7 8 9) asOrderedCollection.
	self should: [c2 copyReplaceFrom: 3 to: 1 with: c1] raise: Error.
	
	c4 := (c2 copyReplaceFrom: 10 to: 25 with: c1).
	self assert: c4 = #(5 6 7 8 9 1 2 3 4) asOrderedCollection.
	
	! !

!DOOrderedCollectionTest methodsFor: 'tests - copying' stamp: 'sd 3/21/2006 22:41'!
testCopyWith
	"Allows one to create a copy of the receiver that contains the new element at the end"
	"self run: #testCopyWith"
	
	| c1 | 
	c1 := #(1 2 3 4) asOrderedCollection.
	c1 := c1 copyWith: 6.
	self assert: c1 = #(1 2 3 4 6) asOrderedCollection.
	
	

	
	
	
! !

!DOOrderedCollectionTest methodsFor: 'tests begin ' stamp: 'pmaer 4/27/2012 14:02'!
testEndsWithAnyOf
	"We can't test SequenceableCollection directly. However, we can test a sampling of its descendants."
	"self debug: #testEndsWithAnyOf"
	| la oc |
	la := #(6 5 4 3 2 1).
	oc := DOOrderedCollection new.
	oc add: 3; add: 2; add: 1.
	
	self assert: (la endsWithAnyOf: #((17) (1) (42))).
	self assert: (la endsWithAnyOf: #((17) (2 1) (42))).
	self assert: (la endsWithAnyOf: #((17) (3 2 1) (42))).
	self deny: (la endsWithAnyOf: #()).
	self deny: (la endsWithAnyOf: #(())).
	self deny: (la endsWithAnyOf: #((42))).! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testFromToDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  from: 1 to: (self nonEmptyMoreThan1Element  size -1) do: [:each | result add: each].
	
	1 to: (self nonEmptyMoreThan1Element  size -1) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:i )=(result at:i)].
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/28/2009 10:22'!
testIdentityIncludes
	" test the comportement in presence of elements 'includes' but not 'identityIncludes' "
	" can not be used by collections that can't include elements for wich copy doesn't return another instance "
	| collection element |
	self 
		shouldnt: [ self collectionWithCopyNonIdentical ]
		raise: Error.
	collection := self collectionWithCopyNonIdentical.
	element := collection anyOne copy.
	"self assert: (collection includes: element)."
	self deny: (collection identityIncludes: element)! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIdentityIndexOf
	"self debug: #testIdentityIndexOf"
	| collection element |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection identityIndexOf: element) = (collection indexOf: element)! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIdentityIndexOfIAbsent
	| collection element |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			identityIndexOf: element
			ifAbsent: [ 0 ]) = 1.
	self assert: (collection 
			identityIndexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 55 ]) = 55! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesAllOfNoneThere
	"self debug: #testIncludesAllOfNoneThere'"
	self deny: (self empty includesAllOf: self collection).
	self deny: (self nonEmpty includesAllOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesAnyOfNoneThere
	"self debug: #testIncludesAnyOfNoneThere'"
	self deny: (self nonEmpty includesAnyOf: self empty).
	self deny: (self nonEmpty includesAnyOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesElementIsNotThere
	"self debug: #testIncludesElementIsNotThere"
	self deny: (self nonEmpty includes: self elementNotInForOccurrences).
	self assert: (self nonEmpty includes: self nonEmpty anyOne).
	self deny: (self empty includes: self elementNotInForOccurrences)! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/9/2009 10:44'!
testIncludesSubstringAnywhere
	"self debug: #testIncludesSubstringAnywher'"
	self assert: (self empty includesAllOf: self empty).
	self assert: (self nonEmpty includesAllOf: {  (self nonEmpty anyOne)  }).
	self assert: (self nonEmpty includesAllOf: self nonEmpty)! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOf
	"self debug: #testIndexOf"
	| tmp index collection |
	collection := self collectionMoreThan1NoDuplicates.
	tmp := collection size.
	collection reverseDo: 
		[ :each | 
		each = self elementInForIndexAccessing ifTrue: [ index := tmp ].
		tmp := tmp - 1 ].
	self assert: (collection indexOf: self elementInForIndexAccessing) = index! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| collection |
	collection := self collectionMoreThan1NoDuplicates.
	self assert: (collection 
			indexOf: collection first
			ifAbsent: [ 33 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 33 ]) = 33! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfStartingAt
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			indexOf: element
			startingAt: 2
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			indexOf: element
			startingAt: 1
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			startingAt: 1
			ifAbsent: [ 99 ]) = 99! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfSubCollectionStartingAt
	"self debug: #testIndexOfIfAbsent"
	| subcollection index collection |
	collection := self collectionMoreThan1NoDuplicates.
	subcollection := self collectionMoreThan1NoDuplicates.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 1.
	self assert: index = 1.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 2.
	self assert: index = 0! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfSubCollectionStartingAtIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| index absent subcollection collection |
	collection := self collectionMoreThan1NoDuplicates.
	subcollection := self collectionMoreThan1NoDuplicates.
	absent := false.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 1
		ifAbsent: [ absent := true ].
	self assert: absent = false.
	absent := false.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 2
		ifAbsent: [ absent := true ].
	self assert: absent = true! !

!DOOrderedCollectionTest methodsFor: 'tests - enumerating' stamp: 'sd 6/5/2005 09:21'!
testIndexOfWithDuplicates

   | collection indices bagOfIndices |
   collection := #('Jim' 'Mary' 'John' 'Andrew' 'Mary' 'John' 'Jim' 'Micheal') asOrderedCollection.
   indices := collection collect: [:item | collection indexOf: item].
   self assert: indices asSet size = collection asSet size.
   bagOfIndices := indices asBag.
   self assert: (indices asSet 
                    allSatisfy: [:index | (bagOfIndices occurrencesOf: index)
	                                       = (collection occurrencesOf: (collection at: index))]).

  "  indexOf:  returns the index of the first occurrence of an item.
     For an item with n occurrences, the index of its first occurrence
     is found  n  times. "! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testKeysAndValuesDo
	"| result |
	result:= OrderedCollection new.
	
	self nonEmptyMoreThan1Element  keysAndValuesDo: 
		[:i :value|
		result add: (value+i)].
	
	1 to: result size do:
		[:i|
		self assert: (result at:i)=((self nonEmptyMoreThan1Element at:i)+i)]"
	|  indexes elements |
	indexes:= DOOrderedCollection new.
	elements := DOOrderedCollection new.
	
	self nonEmptyMoreThan1Element  keysAndValuesDo: 
		[:i :value|
		indexes  add: (i).
		elements add: value].
	
	(1 to: self nonEmptyMoreThan1Element size )do:
		[ :i |
		self assert: (indexes at: i) = i.
		self assert: (elements at: i) = (self nonEmptyMoreThan1Element at: i).	
		].
	
	self assert: indexes size = elements size. 
	self assert: indexes size = self nonEmptyMoreThan1Element size . 
	
	! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testKeysAndValuesDoEmpty
	| result |
	result:= DOOrderedCollection new.
	
	self empty  keysAndValuesDo: 
		[:i :value|
		result add: (value+i)].
	
	self assert: result isEmpty .! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOf
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection lastIndexOf: element) = 1.
	self assert: (collection lastIndexOf: self elementNotInForIndexAccessing) = 0! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOfIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			lastIndexOf: element
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			lastIndexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 99 ]) = 99! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOfStartingAt
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection last.
	self assert: (collection 
			lastIndexOf: element
			startingAt: collection size
			ifAbsent: [ 99 ]) = collection size.
	self assert: (collection 
			lastIndexOf: element
			startingAt: collection size - 1
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			lastIndexOf: self elementNotInForIndexAccessing
			startingAt: collection size
			ifAbsent: [ 99 ]) = 99! !

!DOOrderedCollectionTest methodsFor: 'testsRemoving' stamp: 'nice 9/14/2009 20:57'!
testRemoveAll
	"Allows one to remove all elements of a collection" 
	
	| c1 c2 s2 |
	c1 := #(2 3 4 6) asOrderedCollection.
	c1 addAll: (1 to: 200).
	c2 := c1 copy.
	s2 := c2 size.
	
	c1 removeAll.
	
	self assert: c1 size = 0.
	self assert: c2 size = s2 description: 'the copy has not been modified'
	! !

!DOOrderedCollectionTest methodsFor: 'tests - remove' stamp: 'nice 1/5/2010 15:59'!
testRemoveAllError
	"self debug: #testRemoveElementThatExists"
	| el subCollection |
	el := self elementNotIn.
	subCollection := self nonEmptyWithoutEqualElements copyWith: el.
	self 
		should: [ | res | res := self nonEmptyWithoutEqualElements removeAll: subCollection ]
		raise: Error! !

!DOOrderedCollectionTest methodsFor: 'tests - remove' stamp: 'nice 1/5/2010 15:59'!
testRemoveAllFoundIn
	"self debug: #testRemoveElementThatExists"
	| el subCollection |
	el := self nonEmptyWithoutEqualElements anyOne.
	subCollection := (self nonEmptyWithoutEqualElements copyWithout: el) copyWith: self elementNotIn.
	self 
		shouldnt: 
			[ | res | res := self nonEmptyWithoutEqualElements removeAllFoundIn: subCollection ]
		raise: Error.
	self assert: self nonEmptyWithoutEqualElements size = 1.
	self nonEmptyWithoutEqualElements do: [ :each | self assert: each = el ]! !

!DOOrderedCollectionTest methodsFor: 'tests - removing' stamp: 'zz 12/7/2005 19:05'!
testRemoveAllSuchThat
	| collection |
	collection := (1 to: 10) asOrderedCollection.
	collection
		removeAllSuchThat: [:e | e even].
	self assert: collection = (1 to: 10 by: 2) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - removing' stamp: 'sd 3/21/2006 22:39'!
testRemoveAt
	"Allows one to remove an element from a collection at an index"
	"self run:#testRemoveAt" 
	
	| c1 |
	c1 := #(2 3 4 6) asOrderedCollection.
	c1 removeAt: 2.
	self assert: (c1 = #(2 4 6) asOrderedCollection).
	self should: [c1 removeAt: 10] raise: Error.
	self should: [c1 removeAt: -1] raise: Error.
	! !

!DOOrderedCollectionTest methodsFor: 'tests - removing' stamp: 'sd 3/21/2006 22:39'!
testRemoveFirst
	"Allows one to remove n element of a collection at the first"
	"self run:#testRemoveFirst" 
	
	| c1 |
	c1 := #(2 3 4 6) asOrderedCollection.
	c1 removeFirst: 1.
	self assert: (c1 = #(3 4 6) asOrderedCollection).
	c1 removeFirst: 2.
	self assert: (c1 = #(6) asOrderedCollection).
	self should: [c1 removeFirst: 10] raise: Error.
	
	! !

!DOOrderedCollectionTest methodsFor: 'tests - removing' stamp: 'pmaer 5/7/2012 15:06'!
testRemoveIfAbsent
	"Allows one to remove an element from a collection and to copy it in another collection."
	"If the element isn't in the first collection, the second collection copy the element after ifAbsent"
	"self run:#testRemoveIfAbsent"
	
	| c1 c2 |
	c1 := #(1 2 3 4) asDOOrderedCollection.
	c2 := DOOrderedCollection new.
	
	c2 add: (c1 remove: 2 ifAbsent: [6]).
	self assert: (c1 = #(1 3 4) asDOOrderedCollection).
	self assert: (c2 = #(2) asOrderedCollection).
	
	c2 add: (c1 remove: 18 ifAbsent: [6]).
	self assert: (c1 = #(1 3 4) asDOOrderedCollection).
	self assert: (c2 = #(2 6) asDOOrderedCollection).! !

!DOOrderedCollectionTest methodsFor: 'tests - removing' stamp: 'sd 3/21/2006 22:39'!
testRemoveLast
	"Allows one to remove n element of a collection at the end"
	"self run:#testRemoveLast" 
	
	| c1 |
	c1 := #(2 3 4 6) asOrderedCollection.
	c1 removeLast: 1.
	self assert: (c1 = #(2 3 4) asOrderedCollection).
	c1 removeLast: 2.
	self assert: (c1 = #(2) asOrderedCollection).
	self should: [c1 removeLast: 10] raise: Error.! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testReverseDo
	| result |
	result:= DOOrderedCollection new.
	self nonEmpty reverseDo: [: each | result add: each].
	
	1 to: result size do:
		[:i|
		self assert: (result at: i)=(self nonEmpty at:(self nonEmpty size-i+1))].! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testReverseDoEmpty
	| result |
	result:= DOOrderedCollection new.
	self empty reverseDo: [: each | result add: each].
	
	self assert: result isEmpty .! !

!DOOrderedCollectionTest methodsFor: 'tests - copying' stamp: 'zz 12/7/2005 13:47'!
testReversed
	| collection1 collection2 |
	collection1 := #('Jim' 'Mary' 'John' 'Andrew' ) asOrderedCollection.
	collection2 := collection1 reversed.
	self assert: collection2 first = 'Andrew'.
	self assert: collection2 last = 'Jim'! !

!DOOrderedCollectionTest methodsFor: 'tests' stamp: 'pmaer 4/27/2012 14:02'!
testSort
	"self run: #testSort"
	
	| ord |
	ord := DOOrderedCollection new addAll: #(2 1 3 6 7 10 6); yourself.
	self assert: ord sort asArray = #(1 2 3 6 6 7 10). 
	self assert: ord sort = (DOOrderedCollection new addAll:#(1 2 3 6 6 7 10); yourself). 
	self assert: (ord sort: [:a :b | a > b]) asArray = #(10 7 6 6 3 2 1).
	ord := DOOrderedCollection new.
	self assert: ord sort asArray = #(). 
! !

!DOOrderedCollectionTest methodsFor: 'tests - puting with indexes' stamp: 'GuillermoPolito 5/24/2010 14:31'!
testSwapWith
	"self debug: #testSwapWith"
	| result index |
	index := self indexArray anyOne.
	result:= self nonEmpty copy .
	result swap: index with: 1.
	self assert: (result at: index) = (self nonEmpty at:1).
	self assert: (result at: 1) = (self nonEmpty at: index).
	! !

!DOOrderedCollectionTest methodsFor: 'tests - enumerating' stamp: 'cm 3/8/2006 10:02'!
testWithCollect
	"Allows one to collect some element of two collections into another collection with element corresponding to the condition in the blocks"
	"self run: #testWithCollect"
	
	| c1 c2 res |
	c1 := #(-1 2 -3 4 -5 6 -7 8) asOrderedCollection.
	c2 := #(-9 10 -11 12 -13 14 -15 16) asOrderedCollection.
	res := c1 with: c2 collect: [:each1 :each2 | each1 < each2
		ifTrue: [each1]
		ifFalse: [each2]].
	self assert: (res = #(-9 2 -11 4 -13 6 -15 8) asOrderedCollection).
	! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 4/27/2012 14:02'!
testWithIndexDo
	
	"| result |
	result:=Array new: self nonEmptyMoreThan1Element size.
	self nonEmptyMoreThan1Element  withIndexDo: [:each :i | result at:i put:(each+i)].
	
	1 to: result size do:[: i | self assert: (result at:i)= ((self nonEmptyMoreThan1Element at: i) + i)]"
	|  indexes elements |
	indexes:= DOOrderedCollection new.
	elements := DOOrderedCollection new.
	
	self nonEmptyMoreThan1Element  withIndexDo: 
		[:value :i  |
		indexes  add: (i).
		elements add: value].
	
	(1 to: self nonEmptyMoreThan1Element size )do:
		[ :i |
		self assert: (indexes at: i) = i.
		self assert: (elements at: i) = (self nonEmptyMoreThan1Element at: i).	
		].
	
	self assert: indexes size = elements size. 
	self assert: indexes size = self nonEmptyMoreThan1Element size . 
	! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 4/27/2012 14:00'!
valueArray
" return a collection (with the same size than 'indexArray' )of values to be put in 'nonEmpty'  at indexes in 'indexArray' "
	| result |
	result := DOArray new: self indexArray size.
	1 to: result size do:
		[:i |
		result at:i put: (self aValue ).
		].
	^ result.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 14:11'!
withEqualElements
	" return a collection of float including equal elements (classic equality)"
	^ collectionOfFloat , collectionOfFloat! !

RBBlockNode subclass: #RBOwnershipBlockNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!RBOwnershipBlockNode methodsFor: 'as yet unclassified' stamp: 'pmaer 11/28/2011 18:58'!
isOwnershipBlockNode 
	^ true! !

Error subclass: #CrossingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

CrossingError subclass: #OwnershipViolation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Traits'!

Error subclass: #MessageFiltered
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!MessageFiltered class methodsFor: 'as yet unclassified' stamp: 'ewe 4/24/2012 16:32'!
signal: selector
	super signal: ( 'Message ', selector,' was filtered out').! !

Error subclass: #TransferError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!RBMethodNode methodsFor: '*dynamicownership' stamp: 'ewe 4/25/2012 13:15'!
isOwernshipMeta
	^ ( self pragmas collect: [ :pragma | pragma selector ] ) includes: #meta! !

!RBMessageNode methodsFor: '*dynamicownership' stamp: 'ewe 4/25/2012 12:12'!
needsOwnershipRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	^ ((self selector = #checkValidSend3:message:block:arguments: ) or: [(self parent parent isOwnershipBlockNode)] ) not! !

RBCompiler subclass: #DOTestsCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!DOTestsCompiler methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:01'!
translate: aProgramNode
DOTestsCompilerMessageVisitor new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.! !

RBCompiler subclass: #DebugCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!DebugCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2011 11:41'!
translate: aProgramNode
DebugCompilerVisitor new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel'!

!OwnershipCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 11/15/2011 11:35'!
translate: aProgramNode
OwnershipCompilerVisitor new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler2_1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

!OwnershipCompiler2_1 methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
translate: aProgramNode
OwnershipCompilerMessageVisitor2_1 new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler2_2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

!OwnershipCompiler2_2 methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:20'!
translate: aProgramNode
OwnershipCompilerMessageVisitor2_2 new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!OwnershipCompiler3 methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:20'!
translate: aProgramNode
OwnershipCompilerMessageVisitor3 new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

!OrderedCollection methodsFor: '*dynamicownership' stamp: 'ewe 4/27/2012 12:13'!
removeAllIfPresent: aCollection 
	^ self select: [ :each | ( aCollection includes: each ) not ].! !

!Collection methodsFor: '*dynamicownership' stamp: 'ewe 5/1/2012 13:46'!
isOverlapping: aCollection
	^( self intersection: aCollection ) size > 0 ! !

!Collection methodsFor: '*dynamicownership' stamp: 'ewe 5/1/2012 13:50'!
matches: interface
	^( self includes: #all ) or: [ self isOverlapping: interface ].
	! !

RBLiteralArrayNode subclass: #RBOwnershipLiteralArrayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!RBOwnershipLiteralArrayNode methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 13:44'!
isByteArray: flag
	isByteArray:= flag.! !

!RBOwnershipLiteralArrayNode methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 11:51'!
isOwnershipLiteralArrayNode 
	^ true! !

!Metaclass methodsFor: '*dynamicownership' stamp: 'pmaer 4/20/2012 16:41'!
compilerClass	
	(self theNonMetaClass isOwnershipAware) ifTrue: [ ^OwnershipCompiler3 ]
	ifFalse: [ ^super compilerClass ].! !

RBArrayNode subclass: #RBOwnershipArrayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!RBOwnershipArrayNode methodsFor: 'as yet unclassified' stamp: 'pmaer 4/20/2012 13:48'!
isOwnershipArrayNode 
	^ true! !

!RBProgramNode methodsFor: '*dynamicownership' stamp: 'pmaer 4/20/2012 13:48'!
isOwnershipArrayNode
	^false! !

!RBProgramNode methodsFor: '*dynamicownership' stamp: 'pmaer 11/28/2011 18:59'!
isOwnershipBlockNode
	^false! !

!RBProgramNode methodsFor: '*dynamicownership' stamp: 'pmaer 5/7/2012 11:54'!
isOwnershipLiteralArrayNode
	^false! !

RBProgramNodeVisitor subclass: #DOTestsCompilerMessageVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!DOTestsCompilerMessageVisitor methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:00'!
acceptArrayNode: arrayNode 

	| newArrayNode newMessageNode |
	(arrayNode isOwnershipArrayNode) ifFalse: [
	
		newArrayNode:= RBOwnershipArrayNode statements: arrayNode statements.
	
		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).
	
		arrayNode replaceWith: newMessageNode.	
		
		^ super visitNode: newMessageNode.
	
	].
	
	^ super acceptArrayNode: arrayNode.! !

!DOTestsCompilerMessageVisitor methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:00'!
acceptLiteralArrayNode: literalArrayNode 
	| newArrayNode newMessageNode |

	(literalArrayNode isOwnershipLiteralArrayNode) ifFalse: [

		newArrayNode:= RBOwnershipArrayNode statements: literalArrayNode contents.

		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).

		literalArrayNode replaceWith: newMessageNode.
		
		^ super visitNode: newMessageNode.
	
	].
	^ super acceptLiteralArrayNode: literalArrayNode.! !

!DOTestsCompilerMessageVisitor methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:00'!
buildVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBVariableNode identifierToken: literal.! !

RBProgramNodeVisitor subclass: #DebugCompilerVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!DebugCompilerVisitor methodsFor: 'as yet unclassified' stamp: 'pmaer 11/30/2011 19:23'!
acceptMessageNode: methodNode 
	| newSequenceNode ownershipCheckNode |
	Transcript show: methodNode selector ; cr. 	
	self halt. 
	^ super acceptMessageNode: methodNode.
	
! !

RBProgramNodeVisitor subclass: #OwnershipCompilerMessageVisitor2_1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

!OwnershipCompilerMessageVisitor2_1 methodsFor: 'as yet unclassified' stamp: 'pmaer 2/3/2012 17:03'!
acceptMessageNode: messageNode 
	"Transcript show: messageNode; cr."
	
	( messageNode selector = #checkValidSend:message:block:  or: [ messageNode parent parent 	isOwnershipBlockNode ]) ifFalse: [
		| block statements collStatements newMessageNode newBlockMessageNode rLitToken1 rVarNode1 rLitToken2 rVarNode2 selectorLitNode selectorLitToken receiver selfVarNode selfLitToken variableValue |
		
		"exclude self and super sends"
		[
			(messageNode receiver isVariable and: [messageNode receiver token isIdentifier and: 
				(messageNode receiver token value = 'super' or: messageNode receiver token value = 'self')])
			
					ifTrue: [ ^super acceptMessageNode: messageNode. ].
		] on: Error do: [ :ex | Transcript show: ex message ].
	
		"exclude printOn"
		[
			(messageNode parent parent selector = #printOn:) ifTrue: [
					^super acceptMessageNode: messageNode.
			].
		] on: Error do: [ :ex | Transcript show: ex message ].

	
		variableValue := 'r', (VariableNameCounter counter asString).

		VariableNameCounter increment.
		
		rLitToken1 := RBLiteralToken value: variableValue.
		rVarNode1 := RBVariableNode identifierToken: rLitToken1.
		
		newBlockMessageNode := RBMessageNode receiver: rVarNode1
			selector: messageNode selector
			arguments: messageNode arguments.
		
		collStatements := OrderedCollection new.
		collStatements add: newBlockMessageNode.
		statements := RBSequenceNode statements: collStatements.
		
		rLitToken2 := RBLiteralToken value: variableValue.
		rVarNode2:= RBVariableNode identifierToken: rLitToken2.
		
		block := RBOwnershipBlockNode arguments: { rVarNode2 }
			body: statements. 
		
		selectorLitToken := RBLiteralToken value: messageNode selector.
		selectorLitNode := RBLiteralValueNode literalToken: selectorLitToken.

		selfLitToken := RBLiteralToken value: 'self'.
		selfVarNode := RBVariableNode identifierToken: selfLitToken.
		
		newMessageNode:= RBMessageNode receiver:  selfVarNode
		 	selector: #checkValidSend:message:block: 
			arguments: { messageNode receiver. selectorLitNode. block }.
		
		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].
	^ super acceptMessageNode: messageNode.! !

RBProgramNodeVisitor subclass: #OwnershipCompilerMessageVisitor2_2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

!OwnershipCompilerMessageVisitor2_2 methodsFor: 'as yet unclassified' stamp: 'pmaer 4/20/2012 15:30'!
acceptMessageNode: messageNode 
	"Transcript show: messageNode; cr."
	( messageNode selector = #checkValidSend:message:block:  or: [ messageNode parent parent 	isOwnershipBlockNode ]) ifFalse: [
		| block statements collStatements newMessageNode newBlockMessageNode rLitToken1 rVarNode1 rLitToken2 rVarNode2 selectorLitNode selectorLitToken receiver selfVarNode selfLitToken variableValue temp |
		
		"exclude self and super sends"
		[
			(messageNode receiver isVariable and: [messageNode receiver token isIdentifier and: 
				(messageNode receiver token value = 'super' or: messageNode receiver token value = 'self')])
			
					ifTrue: [ ^super acceptMessageNode: messageNode. ].
		] on: Error do: [ :ex | Transcript show: ex message ].
	
		"exclude printOn"
		[
			temp := messageNode receiver.
			[ temp isMethod or: temp = nil ] whileFalse: [ temp := temp parent ].
		
			Transcript show: temp selectorParts;cr.
			(temp selector = #printOn:) ifTrue: [
					^super acceptMessageNode: messageNode.
			].
		] on: Error do: [ :ex | Transcript show: ex message ].

	
		variableValue := 'r', (VariableNameCounter counter asString).

		VariableNameCounter increment.
		
		rLitToken1 := RBLiteralToken value: variableValue.
		rVarNode1 := RBVariableNode identifierToken: rLitToken1.
		
		newBlockMessageNode := RBMessageNode receiver: rVarNode1
			selector: messageNode selector
			arguments: messageNode arguments.
		
		collStatements := OrderedCollection new.
		collStatements add: newBlockMessageNode.
		statements := RBSequenceNode statements: collStatements.
		
		rLitToken2 := RBLiteralToken value: variableValue.
		rVarNode2:= RBVariableNode identifierToken: rLitToken2.
		
		block := RBOwnershipBlockNode arguments: { rVarNode2 }
			body: statements. 
		
		selectorLitToken := RBLiteralToken value: messageNode selector.
		selectorLitNode := RBLiteralValueNode literalToken: selectorLitToken.

		selfLitToken := RBLiteralToken value: 'self'.
		selfVarNode := RBVariableNode identifierToken: selfLitToken.
		
		newMessageNode:= RBMessageNode receiver:  messageNode receiver
		 	selector: #checkValidSend:message:block: 
			arguments: { selfVarNode. selectorLitNode. block }.

		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].
	^ super acceptMessageNode: messageNode.! !

RBProgramNodeVisitor subclass: #OwnershipCompilerMessageVisitor3
	instanceVariableNames: 'skip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 13:39'!
acceptArrayNode: arrayNode 

	| newArrayNode newMessageNode |
	(arrayNode isOwnershipArrayNode) ifFalse: [
	
		newArrayNode:= RBOwnershipArrayNode statements: arrayNode statements.
	
		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).
	
		arrayNode replaceWith: newMessageNode.	
		
		^ super visitNode: newMessageNode.
	
	].
	
	^ super acceptArrayNode: arrayNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 14:29'!
acceptLiteralArrayNode: literalArrayNode 
	| newArrayNode newMessageNode |

	(literalArrayNode isOwnershipLiteralArrayNode) ifFalse: [

		newArrayNode:= RBOwnershipArrayNode statements: literalArrayNode contents.

		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).

		literalArrayNode replaceWith: newMessageNode.
		
		^ super visitNode: newMessageNode.
	
	].
	^ super acceptLiteralArrayNode: literalArrayNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 09:47'!
acceptMessageNode: messageNode 

	"Excluse certain methods (see acceptMethodNode)"
	skip ifTrue: [ ^super acceptMessageNode: messageNode. ].
	
	"Exclude self and super sends"
	(messageNode isSelfSend or: [ messageNode isSuperSend ] ) 
		ifTrue: [ ^super acceptMessageNode: messageNode. ].
				
	(messageNode needsOwnershipRewrite) ifTrue: [
		| block selector sender arguments newMessageNode |
			
		"TODO momentary hack "
		block := self buildVariableNode: 'self'. "self buildSyntheticBlock: messageNode ."
		selector := self buildLiteralNode: messageNode selector. 
		sender := self buildVariableNode: 'self'.
		arguments := RBOwnershipArrayNode statements: messageNode arguments.
				
		newMessageNode:= RBMessageNode receiver:  messageNode receiver
		 	selector: #checkValidSend3:message:block:arguments:
			arguments: { sender. selector. block. arguments}.
		
		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].
	^ super acceptMessageNode: messageNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 13:09'!
acceptMethodNode: aMethod

	skip := (aMethod selector = #printOn: or: [ aMethod isOwernshipMeta ]).
	^ super acceptMethodNode: aMethod.
	! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:58'!
buildLiteralNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBLiteralValueNode literalToken: literal.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:33'!
buildSyntheticBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiverName := self nextVariableName.
		blockBodyReceiver := self buildVariableNode: blockBodyReceiverName. 
		blockBodyMessageArguments:= OrderedCollection new.
		blockArguments := OrderedCollection new.
		messageNode arguments size timesRepeat: [ 
			| argName |
			argName := self nextVariableName .
			blockBodyMessageArguments addLast: ( self buildVariableNode: argName ).
			blockArguments addLast: ( self buildVariableNode: argName ).
		].
		blockBodyMessage := RBMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		blockFirstArg := self buildVariableNode: blockBodyReceiverName. 
		blockArguments addFirst: blockFirstArg.
		
		block := RBOwnershipBlockNode 
			arguments: blockArguments
			body: blockBody. 
			
		^ block
		! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:30'!
buildVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBVariableNode identifierToken: literal.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:29'!
nextVariableName
	^ VariableNameCounter nextVariableName 
	! !

RBProgramNodeVisitor subclass: #OwnershipCompilerVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel'!

!OwnershipCompilerVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 4/3/2012 10:54'!
acceptMessageNode: messageNode 
	Transcript show: messageNode; cr.
	"self halt."
	
	"TODO: message sends to self don't need to be rewritten"
	( messageNode selector = #checkValidSend:message:block:  or: [ messageNode parent parent 	isOwnershipBlockNode ]) ifFalse: [
		| block statements collStatements newMessageNode newBlockMessageNode rLitToken1 rVarNode1 rLitToken2 rVarNode2 selectorLitNode selectorLitToken receiver selfVarNode selfLitToken variableValue |
		
		variableValue := 'r', (VariableNameCounter counter asString).
		Transcript show: VariableNameCounter counter.
		VariableNameCounter increment.
		
		rLitToken1 := RBLiteralToken value: variableValue.
		rVarNode1 := RBVariableNode identifierToken: rLitToken1.
		
		newBlockMessageNode := RBMessageNode receiver: rVarNode1
			selector: messageNode selector
			arguments: messageNode arguments.
		
		collStatements := OrderedCollection new.
		collStatements add: newBlockMessageNode.
		statements := RBSequenceNode statements: collStatements.
		
		rLitToken2 := RBLiteralToken value: variableValue.
		rVarNode2:= RBVariableNode identifierToken: rLitToken2.
		
		block := RBOwnershipBlockNode arguments: { rVarNode2 }
			body: statements. 
		
		selectorLitToken := RBLiteralToken value: messageNode selector.
		selectorLitNode := RBLiteralValueNode literalToken: selectorLitToken.

		selfLitToken := RBLiteralToken value: 'self'.
		selfVarNode := RBVariableNode identifierToken: selfLitToken.
		
		newMessageNode:= RBMessageNode receiver:  selfVarNode
		 	selector: #checkValidSend:message:block: 
			arguments: { messageNode receiver. selectorLitNode. block }.
		
		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].
	^ super acceptMessageNode: messageNode.! !

TestCase subclass: #BasicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:09'!
testDefaultOwner

	| tester |
	tester := BasicTester new. 
	self assert: ( tester testDefaultOwner = tester ). 
! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'pmaer 4/16/2012 15:56'!
testWorldOwner

	| a b |
	a:= Object new.
	b:= OrderedCollection new.
	
	self assert: (a owner = WorldOwner getInstance).
	self assert: (b owner = WorldOwner getInstance).
	self assert: (a owner = b owner).
	
	b owner: a.
	self assert: (b owner = a).
	self assert: (b owner owner = WorldOwner getInstance).! !

TestCase subclass: #HotelTest
	uses: TExceptionAssertion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

HotelTest class
	uses: TExceptionAssertion classTrait
	instanceVariableNames: ''!

!HotelTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: OwnershipViolation ! !

!HotelTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: OwnershipViolation ! !

!HotelTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:11'!
testInFilters
	| tester |
	
	tester := HotelTester new. 
	self assertMessagePass: [ tester testStatus  ].
	self assertMessageFilter: [ tester testContent ]! !

TestCase subclass: #LessSecureBankCustomerTest
	uses: TExceptionAssertion
	instanceVariableNames: 'bankCS bankUBS customerCS customerUBS'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

LessSecureBankCustomerTest class
	uses: TExceptionAssertion classTrait
	instanceVariableNames: ''!

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: OwnershipViolation ! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: OwnershipViolation ! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:59'!
performTest
	Transcript show: '* Test ' ; show: testSelector asSymbol ; cr.
	super performTest. ! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:02'!
setUp

	Transcript  show: '------' ; cr ; show: 'Set up start.' ; cr.

	Object resetOwners .

	bankCS := LessSecureBank new acronym: #CS.
	bankUBS := LessSecureBank new acronym: #UBS. 
		
	customerCS := bankCS newCustomer identifier: #EWE ; firstname: 'Erwann' ; lastname: 'Wernli' .
	customerUBS := bankUBS newCustomer identifier: #PMA ; firstname: 'Paskal' ; lastname: 'Maerki' .
	customerCS partner: customerUBS. 
	customerUBS partner: customerCS. 
	
	Transcript show: 'Set up completed.' ; cr ;  show: '------' ; cr. ! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:03'!
testBankSize
	
	self assertBoundaryCrossed: [ bankCS hasMoreCustomerThan: bankUBS. ]
	"self assert: ( bankCS customers size = 2 )"
		! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 14:46'!
testCustomerToBank

	self assertMessagePass: [ customerCS promoteFrom: bankCS ].
	self assertMessageFilter: [ customerCS promoteFrom: bankUBS  ] .
	! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:59'!
testTransfer

	customerUBS amount: 100.
	customerCS amount: 100.
	
	bankCS transferFrom: customerCS to: customerUBS. 
	self assertMessageFilter: [ 	bankUBS transferFrom: customerCS to: customerUBS ].
	customerUBS amount: 100.
	customerCS amount: 100. 
	
	bankCS transferToPartnerOf: customerCS. 
	self assertMessageFilter: [ bankUBS transferToPartnerOf: customerCS. ]! !

TestCase subclass: #MetaclassHierarchyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!MetaclassHierarchyTest commentStamp: 'on 3/19/2006 11:33' prior: 0!
Demonstrate the relationship between classes and metaclasses!

!MetaclassHierarchyTest methodsFor: 'running' stamp: 'on 10/28/2007 15:49'!
testHierarchy
	"The class hierarchy"
	self assert: SnakeSquare superclass = BoardSquare.
	self assert: BoardSquare superclass = Object.
	self assert: Object superclass superclass = nil.
	"The parallel metaclass hierarchy"
	self assert: SnakeSquare class name = 'SnakeSquare class'.
	self assert: SnakeSquare class superclass = BoardSquare class.
	self assert: BoardSquare class superclass = Object class.
	self assert: Object class superclass superclass = Class.
	self assert: Class superclass = ClassDescription.
	self assert: ClassDescription superclass = Behavior.
	self assert: Behavior superclass = Object.
	"The Metaclass hierarchy"
	self assert: SnakeSquare class class = Metaclass.
	self assert: BoardSquare class class = Metaclass.
	self assert: Object class class = Metaclass.
	self assert: Class class class = Metaclass.
	self assert: ClassDescription class class = Metaclass.
	self assert: Behavior class class = Metaclass.
	self assert: Metaclass superclass = ClassDescription.
	"The fixpoint"
	self assert: Metaclass class class = Metaclass! !

TestCase subclass: #OComponentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!OComponentTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:40'!
testNestedReturnCopy
	<broken>
	"Test that mutliple non-crossable nested boundaries are correctly handled"! !

!OComponentTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:40'!
testParamCopy
	<broken>
	"Test that params are also subject to non-crossable boundaries"! !

!OComponentTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:35'!
testReturnCopy
	| tester |
	tester :=  OComponentTester newOwned: WorldOwner getInstance .
	self assert: ( tester testReturnCopy not )! !

TestCase subclass: #OLinkedListTest
	uses: TExceptionAssertion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OLinkedListTest class
	uses: TExceptionAssertion classTrait
	instanceVariableNames: ''!

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: OwnershipViolation ! !

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: OwnershipViolation ! !

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:21'!
testAddRemoveFirst
	self assert: ( OLinkedListTester new testAddRemoveFirst = #1). 
	! !

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:22'!
testIterator
	self assert: ( OLinkedListTester new testIterator = #1). ! !

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:33'!
testLeakAddRemoveFirst
	self assertBoundaryCrossed: [ OLinkedListTester new testLeakAddRemoveFirst  ]! !

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:36'!
testLeakIterator
	self assertMessageFilter: [ OLinkedListTester new testLeakIterator ]! !

TestCase subclass: #OTreeTest
	uses: TExceptionAssertion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OTreeTest class
	uses: TExceptionAssertion classTrait
	instanceVariableNames: ''!

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: OwnershipViolation ! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: OwnershipViolation ! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:46'!
testCreation
	self assertMessagePass: [ OTreeTester new testCreation ].! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:28'!
testCreationFreeze
	self assertMessageFilter: [ OTreeTester new testCreationFreeze ]. ! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:16'!
testSandboxCreation
	self assertMessagePass: [ OTreeTester new testSandboxCreation ].! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:25'!
testSandboxMutation
	self assertMessageFilter: [ OTreeTester new testSandboxMutation ].! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:20'!
testSandboxTraversal
	self assertMessagePass: [ OTreeTester new testSandboxTraversal ].! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:44'!
testSecureCreationBorrow 
	self assertMessagePass: [ OTreeTester new testSecureCreationBorrow ]! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:44'!
testSecureCreationFail
	self assertMessageFilter: [ OTreeTester new testSecureCreationFail ].! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:44'!
testSecureCreationImpersonate
	self assertMessageFilter: [ OTreeTester new testSecureCreationImpersonate  ].! !

TestCase subclass: #OwnedObject2Test
	instanceVariableNames: 'student studentOwner externalObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel-Test'!

!OwnedObject2Test methodsFor: 'as yet unclassified' stamp: 'pmaer 1/16/2012 23:21'!
setUp
	student := ObjectWithReadWriteInterface  new.
	student internalInterface: #readWrite.
	student externalInterface: #read.
	
	studentOwner := OwnedObject2 new.
	
	student owner: studentOwner.
	
	externalObject := OwnedObject2 new.! !

!OwnedObject2Test methodsFor: 'as yet unclassified' stamp: 'pmaer 1/16/2012 23:43'!
testInterfaceChange
	"test interface change"

	"try to access a method with a different interface"
	studentOwner checkValidSend: student message: #studentNumberSetterWithDifferentInterface: block: [:t | t studentNumberSetterWithDifferentInterface: 'tom'].
	self deny: ( student studentName = 'tom' ).
	
	self deny: ( (studentOwner checkValidSend: student message: #studentNumberGetterWithDifferentInterface block: [:t | t studentNumberGetterWithDifferentInterface]) = 'john' ).
	
	
	"change interfaces on student and try again"
	student internalInterface: #somethingDifferent.
	student externalInterface: #somethingDifferent.
	
	studentOwner checkValidSend: student message: #studentNumberSetterWithDifferentInterface: block: [:t | t studentNumberSetterWithDifferentInterface: 'tom'].
	self deny: ( student studentName = 'tom' ).
	
	self deny: ( (studentOwner checkValidSend: student message: #studentNumberGetterWithDifferentInterface block: [:t | t studentNumberGetterWithDifferentInterface]) = 'john' ).
	
	! !

!OwnedObject2Test methodsFor: 'as yet unclassified' stamp: 'pmaer 1/16/2012 23:43'!
testValidSendWithInterfaces


	"owner tries to access readWrite method"
	studentOwner checkValidSend: student message: #studentName: block: [:t | t studentName: 'john'].
	self assert: ( student studentName = 'john' ).
	
	"externalObject tries to access readWrite method, should fail"
	externalObject checkValidSend: student message: #studentName: block: [:t | t studentName: 'jim'].
	self deny: ( student studentName = 'jim' ).
	
	"externalObject tries to access read method"
	self assert: ( (externalObject checkValidSend: student message: #studentName block: [:t | t studentName]) = 'john' ).
	
	! !

TestCase subclass: #OwnedObjectTest
	instanceVariableNames: 'ownedObjectA ownedObjectB ownedObjectC ownedObjectD ownedObjectE root studentList lectureList studentA studentB studentC lectureA lectureB addressA addressB addressC'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel-Test'!

OwnedObjectTest class
	instanceVariableNames: 'ownedObjectA ownedObjectB ownedObjectC ownedObjectD ownedObjectE'!

OwnedObjectTest class
	instanceVariableNames: 'ownedObjectA ownedObjectB ownedObjectC ownedObjectD ownedObjectE'!

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/8/2011 11:21'!
exampleReflection
	| o aMessageName |
	o := Object new. 
	aMessageName := #name .
	o name "implicit message send" .
	o perform: aMessageName "explicit message send" .
	( Object >> aMessageName ) valueWithReceiver: o arguments: #().
! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:14'!
setUp
	"setUp simple ownership tree
	
	A->B, A->C
	B->D
	D->E"

	ownedObjectA:= OwnedObject new.
	ownedObjectB:= OwnedObject new.
	ownedObjectC:= OwnedObject new.
	ownedObjectD:= OwnedObject new.
	ownedObjectE:= OwnedObject new.
	
	ownedObjectB owner: ownedObjectA.
	ownedObjectC owner: ownedObjectA.
	ownedObjectD owner: ownedObjectB.
	ownedObjectE owner: ownedObjectD.
	

	"root -> studentList, lectureList
	root -> studentA, studentB, studentC, lectureA, lectureB
	
	studentA -> addressA
	studentB -> addressB
	studentC -> adressC
	
	may want to expand test so that studentList and lectureList are actual lists"
	

	root:= OwnedObjectWithPragmas new. 
	studentList:= OwnedObjectWithPragmas new.
	lectureList:= OwnedObjectWithPragmas new.
	
	studentA:= OwnedObjectWithPragmas new.
	studentB:= OwnedObjectWithPragmas new.
	studentC:= OwnedObjectWithPragmas new.
	lectureA:= OwnedObjectWithPragmas new.
	lectureB:= OwnedObjectWithPragmas new.
	
	addressA:= OwnedObjectWithPragmas new.
	addressB:= OwnedObjectWithPragmas new.
	addressC:= OwnedObjectWithPragmas new.
	

	studentList owner: root.
	lectureList owner: root.
	
	studentA owner: root.
	studentB owner: root.
	studentC owner: root.
	lectureA owner: root.
	lectureB owner: root.
	
	addressA owner: studentA.
	addressB owner: studentB.
	addressC owner: studentC.! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:04'!
testValidSendAboveInTree
	"test sends to self and owned objects"

	self deny: ( (addressA checkValidSend: addressA message: #normalMethod block: [:r |^true]) ).
	self assert: ( (addressA checkValidSend: studentA message: #pureMethod block: [:r |^true]) ).
	self assert: ( (addressA checkValidSend: studentA message: #oneWayMethod block: [:r |^true]) ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:04'!
testValidSendBelowInTree
	"test message send to objects below in the tree (not owned)"

	self deny: ( (root checkValidSend: addressA message: #normalMethod block: [:r |^true]) ).
	self deny: ( (root checkValidSend: addressA message: #pureMethod block: [:r |^true]) ).
	self deny: ( (root checkValidSend: addressA message: #oneWayMethod block: [:r |^true]) ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:04'!
testValidSendObjectsInOtherEncapsulationBoundary
	"tests sends to objects in another encabsulation boundary"

	self deny: ( (lectureA checkValidSend: addressA message: #normalMethod block: [:r |^true]) ).
	self deny: ( (lectureA checkValidSend: addressA message: #pureMethod block: [:r |^true]) ).
	self deny: ( (lectureA checkValidSend: addressA message: #oneWayMethod block: [:r |^true]) ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:03'!
testValidSendSelfandChildren
	"test sends to self and owned objects"

	self assert: ( (root checkValidSend: root message: #normalMethod block: [:r |^true]) ).
	self assert: ( (root checkValidSend: root message: #pureMethod block: [:r |^true]) ).
	self assert: ( (root checkValidSend: root message: #oneWayMethod block: [:r |^true]) ).
	

	self assert: ( (root checkValidSend: studentA message: #normalMethod block: [:r |^true]) ).
	self assert: ( (root checkValidSend: studentA message: #pureMethod block: [:r |^true]) ).
	self assert: ( (root checkValidSend: studentA message: #oneWayMethod block: [:r |^true]) ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:14'!
testValidSendSiblings
	"tests message sends to siblings"

	self deny: ( (lectureA checkValidSend: lectureB message: #normalMethod block: [:r |^true]) ).
	self assert: ( (lectureA checkValidSend: lectureB message: #pureMethod block: [:r |^true]) ).
	self assert: ( (lectureA checkValidSend: lectureB message: #oneWayMethod block: [:r |^true]) ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 18:40'!
testVisibilityAboveInTree
	"tests if an object above in the tree is visible"

	self assert: ( ownedObjectB checkVisibility: ownedObjectA ).
	self assert: ( ownedObjectC checkVisibility: ownedObjectA ).
	self assert: ( ownedObjectD checkVisibility: ownedObjectB ).
	self assert: ( ownedObjectE checkVisibility: ownedObjectD ).
	
	self assert: ( ownedObjectD checkVisibility: ownedObjectA ).
	self assert: ( ownedObjectE checkVisibility: ownedObjectB ).
	
	self assert: ( ownedObjectE checkVisibility: ownedObjectA ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 18:41'!
testVisibilityBelowInTree
	"tests if objects below in the tree (except children) are not visible"

	self deny: ( ownedObjectA checkVisibility: ownedObjectD ).
	self deny: ( ownedObjectA checkVisibility: ownedObjectE ).
	
	self deny: ( ownedObjectB checkVisibility: ownedObjectE ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 18:42'!
testVisibilityChildren
	"tests if children are visible"
	
	self assert: ( ownedObjectA checkVisibility: ownedObjectB ).
	self assert: ( ownedObjectA checkVisibility: ownedObjectC ).
	self assert: ( ownedObjectB checkVisibility: ownedObjectD ).
	self assert: ( ownedObjectD checkVisibility: ownedObjectE ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 18:41'!
testVisibilityObjectsInOtherEncapsulationBoundary
	"tests that an object in another encabsulation boundary is not visible"

	self deny: ( ownedObjectD checkVisibility: ownedObjectC ).
	self deny: ( ownedObjectE checkVisibility: ownedObjectC ).
	
	self deny: ( ownedObjectC checkVisibility: ownedObjectD ).
	self deny: ( ownedObjectC checkVisibility: ownedObjectE ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 18:42'!
testVisibilitySelf
	"check if self is visible"

	self assert: ( ownedObjectA checkVisibility:  ownedObjectA ).
	self assert: ( ownedObjectB checkVisibility:  ownedObjectB ).
	self assert: ( ownedObjectC checkVisibility:  ownedObjectC ).
	self assert: ( ownedObjectD checkVisibility:  ownedObjectD ).
	self assert: ( ownedObjectE checkVisibility:  ownedObjectE ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 20:51'!
testVisibilitySiblings
	"tests if siblings are visible"

	self assert: ( ownedObjectB checkVisibility: ownedObjectC ).
	self assert: ( ownedObjectC checkVisibility: ownedObjectB ).
	! !

TestCase subclass: #OwnershipCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 16:27'!
assertException: aBlock
 	self should: aBlock raise: Exception ! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 14:21'!
testArray
	| tester |
	tester := OwnershipCompilerTester new.
	self assert: ( tester testArray class name = #DOArray )! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 14:21'!
testArrayAndLiteralArray
	| tester c1 c2 |
	tester := OwnershipCompilerTester new.
	
	"{1. 2+3. #(2+3 {3+4}). 4}"
	
	c1:= DOArray withAll: #(2+3 {3+4}).
	c2:= DOArray withAll: {1. 2+3. c1. 4}.
	self assert: ( (tester testArrayAndLiteralArray) = c2).! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 14:21'!
testArrayRecursion
	| tester |
	tester := OwnershipCompilerTester new.
	
	"{ 1. 1+2. 3. {5. 1 } }. "
	self assert: ( (tester testArrayRecursion) = (DOArray withAll: { 1. 1+2. 3. DOArray withAll: {5. 1 } })).! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testCascade
	OwnershipCompilerTester new testCascade .! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testException

	self assertException: [ OwnershipCompilerTester new testException .]! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testExceptionSignal 
	self assertException: [ OwnershipCompilerTester new testExceptionSignal ]! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testExperssionAsArguments 
	| tester |
	tester := OwnershipCompilerTester new .
	 tester testExperssionAsArguments 
	! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 14:21'!
testLiteralArray
	| tester |
	tester := OwnershipCompilerTester new.
	self assert: ( tester testLiteralArray class name = #DOArray )! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 14:21'!
testLiteralArrayRecursion
	| tester c1 c2 c3 c4 |
	tester := OwnershipCompilerTester new.
	
	"#(1 2 (3 4) 5 #(6 7))."
	c1:= DOArray withAll: #(3 4).
	c2:= DOArray withAll: #(6 7).
	c3:= DOArray withAll: {1. 2. c1. 5. c2}.	
	self assert: ( (tester testLiteralArrayRecursion) = c3).! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testObjectAsArguments 
	| tester |
	tester := OwnershipCompilerTester new .
	self assert: ( tester testObjectAsArguments = 3 ) 
	! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testOrderOfEvaluation
	| tester |
	tester := OwnershipCompilerTester new.
	"if order is wrong, or if evaluated multiple time, result will not be 6"
	self assert: ( tester testOrderOfEvaluation = 6).
	! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testOrderOfEvaluation2
	| tester |
	tester := OwnershipCompilerTester new.
	"if order is wrong, or if evaluated multiple time, result will not be 6"
	self assert: ( tester testOrderOfEvaluation2 = 6)
	! !

TestCase subclass: #ReturnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel-Test'!

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:27'!
testException
	
	[ 
		self useBlock:  [ Error signal: 'Error!!' ].
	] on: Error do: [ :ex | Transcript show:  ex messageText ].

	[ 
		self useBlockWithEnsure:  [ Error signal: 'Error!!' ].
	] on: Error do: [ :ex | Transcript show:  ex messageText ].! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:06'!
testNonLocalReturn
	| b v |
	b := [ Transcript show: 'Within the block'. 
		    ^ 42. ].
	v := self useBlock: b. 
	Transcript show: v. ! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:26'!
testNonLocalReturnEnsure
	| b v |
	b := [ Transcript show: 'Within the block'. 
		    ^ 42. ].
	v := self useBlockWithEnsure: b. 
	Transcript show: v. ! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:26'!
testOuter

	| v |
	v := self testNonLocalReturn.
	Transcript show: ('Value from outer ', v asString  ).
	
	v := self testNonLocalReturnEnsure.
	Transcript show: ('Value from outer ', v asString  ).! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:04'!
useBlock: aBlock
 
    aBlock value.
   Transcript show: 'Block was used'.! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:25'!
useBlockWithEnsure: aBlock
  [     aBlock value.
   ] ensure: [ Transcript show: 'Block was used'. ]! !

TestCase subclass: #SecureBankCustomerTest
	uses: TExceptionAssertion
	instanceVariableNames: 'bankCS bankUBS customerCS customerUBS'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

SecureBankCustomerTest class
	uses: TExceptionAssertion classTrait
	instanceVariableNames: ''!

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: OwnershipViolation ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: OwnershipViolation ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 08:55'!
performTest
	Transcript show: '* Test ' ; show: testSelector asSymbol ; cr.
	super performTest. ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:41'!
setUp

	Transcript  show: '------' ; cr ; show: 'Set up start.' ; cr.

	Object resetOwners .

	bankCS := SecureBank new acronym: #CS.
	bankUBS := SecureBank new acronym: #UBS.
		
	customerCS := bankCS newCustomer identifier: #EWE ; firstname: 'Erwann' ; lastname: 'Wernli' .
	customerUBS := bankUBS newCustomer identifier: #PMA ; firstname: 'Paskal' ; lastname: 'Maerki' .
	customerCS partner: customerUBS. 
	customerUBS partner: customerCS. 
	
	Transcript show: 'Set up completed.' ; cr ;  show: '------' ; cr. ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/24/2012 16:53'!
testBankSize
	
	self assertBoundaryCrossed: [ bankCS hasMoreCustomerThan: bankUBS. ]
	"self assert: ( bankCS customers size = 2 )"
		! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 12:05'!
testBankToCustomer

	self assertMessagePass: [ bankCS amountOf: customerCS ].
	self assertMessagePass: [ bankCS identifierOf: customerCS ].
	
	self assertMessageFilter: [ bankCS amountOf: customerUBS  ] .
	self assertMessagePass: [ bankCS identifierOf: customerUBS ].
	! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/23/2012 14:43'!
testCustomerAccessBank

	self assertBoundaryOk:  [ customerCS isCustomerOf: bankCS ].
	self assertBoundaryCrossed:  [ customerCS isCustomerOf: bankUBS ].
	! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 14:46'!
testCustomerToBank

	self assertMessagePass: [ customerCS promoteFrom: bankCS ].
	self assertBoundaryCrossed: [ customerCS promoteFrom: bankUBS  ] .
	! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:19'!
testCustomerToCustomer
	<broken>
	self assert: ( customerCS canSend: #identifier to: customerCS ).
	self assert: ( customerCS canSend: #identifier to: customerUBS ).
	
	self assert: ( customerCS canSend: #credit: to: customerCS ).
	self assert: ( customerCS canSend: #credit: to: customerUBS ).
	
	self assert: ( customerCS canSend: #amount to: customerCS ).
	self assert: ( customerCS canNotSend: #amount to: customerUBS ).
	
	self assert: ( customerCS canSend: #withdraw: to: customerCS ).
	self assert: ( customerCS canNotSend: #withdraw: to: customerUBS ).
	! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 17:32'!
testPrimitive
	self assert: ( bankCS checkVisibility: #premium )  .
	self assert: ( customerCS checkVisibility: #premium ) not ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 16:57'!
testSetUp

	self assert: bankCS customers size = 1.
	self assert: bankUBS customers size = 1.
	self assert: customerCS identifier = #EWE. 
	self assert: customerUBS identifier = #PMA. ! !

TestCase subclass: #SnakesAndLaddersTest
	instanceVariableNames: 'eg loadedDie jack jill'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!SnakesAndLaddersTest commentStamp: 'on 3/15/2006 13:24' prior: 0!
Play a rigged game and check the results.!

!SnakesAndLaddersTest methodsFor: 'running' stamp: 'on 3/16/2006 09:58'!
example
	^ SnakesAndLadders example! !

!SnakesAndLaddersTest methodsFor: 'running' stamp: 'on 3/16/2006 09:58'!
setUp
	eg := self example.
	loadedDie := LoadedDie new.
	eg setDie: loadedDie.
	jack := eg players first.
	jill := eg players last.! !

!SnakesAndLaddersTest methodsFor: 'running' stamp: 'on 3/23/2006 09:06'!
testExample
	self assert: eg currentPlayer = jack.
	loadedDie roll: 1.
	eg playOneMove.
	self assert: jack position = 6.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 5.
	eg playOneMove.
	self assert: jill position = 1.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 5.
	eg playOneMove.
	self assert: jack position = 5.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 4.
	eg playOneMove.
	self assert: jill position = 1.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 6.
	eg playOneMove.
	self assert: jack position = 5.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 6.
	eg playOneMove.
	self assert: jill position = 9.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 5.
	eg playOneMove.
	self assert: jack position = 10.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 5.
	eg playOneMove.
	self assert: jill position = 1.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 2.
	eg playOneMove.
	self assert: jack position = 12.
	self assert: eg isOver! !

!SnakesAndLaddersTest methodsFor: 'running' stamp: 'pmaer 2/14/2012 01:28'!
testStartPosition
	self assert: eg lastPosition = 12.
	self assert: eg isNotOver.
	self assert: eg currentPlayer = jack.
	self assert: eg firstSquare isFirstSquare.
	self assert: eg firstSquare isLastSquare not.
	self assert: eg firstSquare position = 1.
	self assert: eg firstSquare isOccupied.
	self assert: (eg at: eg lastPosition) isFirstSquare not.
	self assert: (eg at: eg lastPosition) isLastSquare.
	self assert: (eg at: eg lastPosition) position = 12.
	self assert: (eg at: eg lastPosition) isOccupied not.
	self assert: jack name = 'Jack'.
	self assert: jill name = 'Jill'.
	self assert: jack position = 1.
	self assert: jill position = 1! !

SnakesAndLaddersTest subclass: #SnakesAndLaddersTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!SnakesAndLaddersTest2 commentStamp: 'on 3/17/2006 10:50' prior: 0!
Some tests for a second example.!

!SnakesAndLaddersTest2 methodsFor: 'running' stamp: 'on 3/16/2006 09:59'!
example
	^ SnakesAndLadders example2! !

!SnakesAndLaddersTest2 methodsFor: 'running' stamp: 'on 3/18/2006 15:04'!
testExample
	self assert: jack name = 'Jack'.
	self assert: jill name = 'Jill'.
	self assert: jack position = 1.
	self assert: jill position = 1.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 1.
	eg playOneMove.
	self assert: jack position = 2.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 2.
	eg playOneMove.
	self assert: jill position = 7.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 3.
	eg playOneMove.
	self assert: jack position = 5.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 1.
	eg playOneMove.
	self assert: jill position = 7.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 2.
	eg playOneMove.
	self assert: jack position = 1.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 5.
	eg playOneMove.
	self assert: jill position = 12.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 6.
	eg playOneMove.
	self assert: jack position = 7.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 1.
	eg playOneMove.
	self assert: jill position = 13.
	self assert: eg isOver! !

Object subclass: #AllTouchedClassesCollector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Util'!

!AllTouchedClassesCollector methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 16:31'!
addAllClassNames: classToCheck set: nameSet checkedSet: checkedNameSet 


| methodDict  |

methodDict := classToCheck methodDictionary.

methodDict do: [ :each | 
	
	| literals |
	
	literals := each allLiterals.
	
	literals do: [ :eachLiteral |
		
			| objectName eachLiteralValue |
			objectName := ''.
			
			[
			eachLiteralValue := eachLiteral asString.
			((eachLiteralValue asString) at: 2) isUppercase ifTrue: [
					| n |
					n := 2.
					
					[ n <= ((eachLiteralValue asString) byteSize) and: ((eachLiteralValue at: n) isLetter ) ]
						whileTrue: [ 
							objectName := objectName, ((eachLiteralValue asString) at: n) asString.
							
							n := (n + 1).
							 ].
					
					[
						(Smalltalk at: objectName asSymbol) methodDictionary.
					
						nameSet add: objectName.
					] on: Error do: [].
			]
			] on: Error do: [ ].
		
	]

].
	checkedNameSet add: classToCheck asString.
  ! !

!AllTouchedClassesCollector methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 16:34'!
collectAllUsedClasses: classToCheck

	| nameSet checkedNameSet |
	nameSet := Set new.
	checkedNameSet := Set new.

	nameSet add: classToCheck asString.
	self addAllClassNames: classToCheck set: nameSet checkedSet: checkedNameSet.
	
	[ nameSet size = checkedNameSet size ] whileFalse: [
	
		nameSet do: [ :each | ((checkedNameSet like: each) = nil) ifTrue: [
					| anotherClassToCheck |
				
					"Transcript show: 'before checking -----------'; cr.
					Transcript show: nameSet; cr.
					Transcript show: checkedNameSet; cr."
			
				
					anotherClassToCheck := Smalltalk at: (each asSymbol).
					self addAllClassNames: anotherClassToCheck set: nameSet checkedSet: checkedNameSet.
			
					"	
					Transcript show: 'after checking -----------'; cr.
					Transcript show: nameSet; cr.
					Transcript show: checkedNameSet; cr."
			
			]	] 	].
		
	Transcript show: nameSet.! !

Object subclass: #BoardSquare
	instanceVariableNames: 'position player board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!BoardSquare commentStamp: 'on 3/14/2006 19:27' prior: 0!
Responsibilities:
- Remember position in the board
- Keep track of any players on this square
- Send on any players passing through
- Displays itself with its position and any player who might be on it, e.g., [7 Jack]!

!BoardSquare class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/15/2006 15:26'!
backwardBy: squares 
	^ squares = 0 
		ifTrue: [self destination]
		ifFalse: 
			[self isFirstSquare 
				ifTrue: [self nextSquare forwardBy: squares - 1]
				ifFalse: [self previousSquare backwardBy: squares - 1]]! !

!BoardSquare methodsFor: 'printing' stamp: 'on 3/14/2006 17:18'!
contents
	^ self isOccupied
		ifTrue: [ ' ', player asString ]
		ifFalse: [ '' ]! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/15/2006 15:26'!
destination
	^ self! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/18/2006 11:43'!
forwardBy: squares
	self assert: self invariant.
	^ squares = 0 
		ifTrue: [self destination]
		ifFalse: 
			[self isLastSquare 
				ifFalse: [self nextSquare forwardBy: squares - 1]
				ifTrue: [self previousSquare backwardBy: squares - 1]]! !

!BoardSquare methodsFor: 'initialize-release' stamp: 'pmaer 2/27/2012 12:12'!
invariant
	^ board notNil
		and: [[ position notNil ]
		and: [[ position >= 0 ]
		and: [[ position <= board lastPosition]]]]! !

!BoardSquare methodsFor: 'testing' stamp: 'on 3/14/2006 16:12'!
isFirstSquare
	^ position = 1! !

!BoardSquare methodsFor: 'testing' stamp: 'on 3/20/2006 10:17'!
isLastSquare
	^ position = board lastPosition! !

!BoardSquare methodsFor: 'testing' stamp: 'on 3/14/2006 16:40'!
isOccupied
	^ player notNil! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/15/2006 15:43'!
landHere: aPlayer
	^ self isOccupied
		ifTrue: [ board firstSquare landHere: aPlayer ]
		ifFalse: [ player := aPlayer. self ]! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/14/2006 16:32'!
nextSquare
	self assert: self isLastSquare not.
	^ board at: position + 1! !

!BoardSquare methodsFor: 'testing' stamp: 'on 3/14/2006 17:03'!
position
	^ position! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/14/2006 16:32'!
previousSquare
	self assert: self isFirstSquare not.
	^ board at: position - 1! !

!BoardSquare methodsFor: 'printing' stamp: 'on 3/14/2006 16:08'!
printOn: aStream
	aStream nextPutAll: '[', position printString, self contents, ']'.! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/14/2006 16:14'!
remove: aPlayer
	self assert: player = aPlayer.
	player := nil.! !

!BoardSquare methodsFor: 'initialize-release' stamp: 'on 3/18/2006 15:13'!
setPosition: aNumber board: aBoard 
	position := aNumber.
	board := aBoard! !

BoardSquare subclass: #FirstSquare
	instanceVariableNames: 'players'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!FirstSquare commentStamp: 'on 3/14/2006 19:06' prior: 0!
Responsibilities:
- Allows multiple players to be added or removed [normal squares can only hold a single player]!

!FirstSquare class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!FirstSquare methodsFor: 'printing' stamp: 'on 3/14/2006 15:35'!
contents
	^ players inject: '' into:
			[ :list :each | list , ' ', each asString ]! !

!FirstSquare methodsFor: 'initialize-release' stamp: 'pmaer 2/27/2012 12:12'!
initialize
	players := OrderedCollection new.! !

!FirstSquare methodsFor: 'testing' stamp: 'pmaer 2/14/2012 01:36'!
isOccupied
	^ players size > 0! !

!FirstSquare methodsFor: 'initialize-release' stamp: 'on 3/15/2006 15:29'!
landHere: aPlayer
	players add: aPlayer.! !

!FirstSquare methodsFor: 'playing' stamp: 'on 3/14/2006 16:15'!
remove: aPlayer
	self assert: (players includes: aPlayer).
	players remove: aPlayer.! !

BoardSquare subclass: #LadderSquare
	instanceVariableNames: 'forward'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!LadderSquare commentStamp: 'on 3/17/2006 10:36' prior: 0!
Responsibilities:
- If a player lands here, send him or her up the ladder (forward # squares)
- Displays itself as a square with a positive offset, e.g., [6]3+>!

!LadderSquare class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!LadderSquare class methodsFor: 'instance creation' stamp: 'on 3/18/2006 12:50'!
forward: number
	^ self new setForward: number! !

!LadderSquare methodsFor: 'playing' stamp: 'on 3/15/2006 15:26'!
destination
	^ self forwardBy: forward! !

!LadderSquare methodsFor: 'printing' stamp: 'on 3/16/2006 14:35'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: forward asString, '+>'.! !

!LadderSquare methodsFor: 'initialize-release' stamp: 'on 3/18/2006 12:49'!
setForward: aNumber
	forward := aNumber.! !

BoardSquare subclass: #SnakeSquare
	instanceVariableNames: 'back'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!SnakeSquare commentStamp: 'on 3/20/2006 09:14' prior: 0!
Responsibilities:
- If a player lands here, send him or her backwards (back # squares)
- Displays itself as a square with a negative offset, e.g., <-3[5]!

!SnakeSquare class methodsFor: 'instance creation' stamp: 'on 3/18/2006 12:50'!
back: number
	^ self new setBack: number! !

!SnakeSquare class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!SnakeSquare methodsFor: 'playing' stamp: 'on 3/15/2006 15:26'!
destination
	^ self backwardBy: back! !

!SnakeSquare methodsFor: 'printing' stamp: 'on 3/16/2006 14:35'!
printOn: aStream
	aStream nextPutAll: '<-', back asString.
	super printOn: aStream.! !

!SnakeSquare methodsFor: 'initialize-release' stamp: 'on 3/18/2006 12:50'!
setBack: aNumber
	back := aNumber.! !

Object subclass: #ClassWithPragmas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel-Test'!

!ClassWithPragmas methodsFor: 'as yet unclassified' stamp: 'PascalMaerki 11/14/2011 22:54'!
andMoreStuff
	"empty method with a pragma"

	<anotherPragma>! !

!ClassWithPragmas methodsFor: 'as yet unclassified' stamp: 'PascalMaerki 11/14/2011 22:54'!
doStuff
	"empty method with two pragmas"

	<hello>
	<world>! !

!ClassWithPragmas methodsFor: 'as yet unclassified' stamp: 'PascalMaerki 11/14/2011 22:54'!
moreStuff
	"empty method with a pragma"

	<bye>! !

Object subclass: #CollectPragmas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!CollectPragmas methodsFor: 'as yet unclassified' stamp: 'PascalMaerki 11/14/2011 22:49'!
collectAllPragmas: aClass
	"collects all Pragmas in aClass and returns them in an orderedCollection"

	| pragmaCollection |

	pragmaCollection:= OrderedCollection new.

	(aClass methodDict do: [:each | pragmaCollection addAll: each pragmas]).
	
	^pragmaCollection.! !

Object subclass: #DOCollection
	instanceVariableNames: ''
	classVariableNames: 'MutexForPicking RandomForPicking'
	poolDictionaries: ''
	category: 'DynamicOwnership-AdaptedClasses'!

!DOCollection commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all classes that represent a group of elements.!

!DOCollection class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/23/2012 15:23'!
compilerClass
	^OwnershipCompiler3 ! !

!DOCollection class methodsFor: 'private' stamp: 'lr 11/4/2003 12:07'!
initialize
	"Set up a Random number generator to be used by atRandom when the 
	user does not feel like creating his own Random generator."

	RandomForPicking := Random new.
	MutexForPicking := Semaphore forMutualExclusion! !

!DOCollection class methodsFor: 'private' stamp: 'lr 11/4/2003 12:08'!
mutexForPicking
	^ MutexForPicking! !

!DOCollection class methodsFor: 'private' stamp: 'sma 5/12/2000 12:31'!
randomForPicking
	^ RandomForPicking! !

!DOCollection class methodsFor: 'instance creation' stamp: 'sma 5/6/2000 19:58'!
with: anObject 
	"Answer an instance of me containing anObject."

	^ self new
		add: anObject;
		yourself! !

!DOCollection class methodsFor: 'instance creation' stamp: 'sma 5/6/2000 20:01'!
with: firstObject with: secondObject 
	"Answer an instance of me containing the two arguments as elements."

	^ self new
		add: firstObject;
		add: secondObject;
		yourself! !

!DOCollection class methodsFor: 'instance creation' stamp: 'sma 5/6/2000 20:03'!
with: firstObject with: secondObject with: thirdObject 
	"Answer an instance of me containing the three arguments as elements."

	^ self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		yourself! !

!DOCollection class methodsFor: 'instance creation' stamp: 'sma 5/6/2000 20:06'!
with: firstObject with: secondObject with: thirdObject with: fourthObject 
	"Answer an instance of me, containing the four arguments as the elements."

	^ self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		yourself! !

!DOCollection class methodsFor: 'instance creation' stamp: 'sma 5/6/2000 20:06'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject
	"Answer an instance of me, containing the five arguments as the elements."

	^ self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		add: fifthObject;
		yourself! !

!DOCollection class methodsFor: 'instance creation' stamp: 'sma 5/6/2000 20:06'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject with: sixthObject
	"Answer an instance of me, containing the six arguments as the elements."

	^ self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		add: fifthObject;
		add: sixthObject;
		yourself! !

!DOCollection class methodsFor: 'instance creation' stamp: 'sma 5/6/2000 20:07'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size)
		addAll: aCollection;
		yourself! !

!DOCollection methodsFor: 'copying' stamp: 'al 12/12/2003 14:31'!
, aCollection
	^self copy addAll: aCollection; yourself! !

!DOCollection methodsFor: 'adapting' stamp: 'di 11/6/1998 13:34'!
adaptToCollection: rcvr andSend: selector
	"If I am involved in arithmetic with another Collection, return a Collection of
	the results of each element combined with the scalar in that expression."

	rcvr isSequenceable & self isSequenceable ifFalse:
		[self error: 'Only sequenceable collections may be combined arithmetically'].
	^ rcvr with: self collect:
		[:rcvrElement :myElement | rcvrElement perform: selector with: myElement]! !

!DOCollection methodsFor: 'adapting' stamp: 'di 11/9/1998 12:16'!
adaptToNumber: rcvr andSend: selector
	"If I am involved in arithmetic with a scalar, return a Collection of
	the results of each element combined with the scalar in that expression."

	^ self collect: [:element | rcvr perform: selector with: element]! !

!DOCollection methodsFor: 'adapting' stamp: 'di 11/6/1998 13:37'!
adaptToPoint: rcvr andSend: selector
	"If I am involved in arithmetic with a scalar, return a Collection of
	the results of each element combined with the scalar in that expression."

	^ self collect: [:element | rcvr perform: selector with: element]! !

!DOCollection methodsFor: 'adapting' stamp: 'di 11/6/1998 13:37'!
adaptToString: rcvr andSend: selector
	"If I am involved in arithmetic with a String, convert it to a Number."
	^ rcvr asNumber perform: selector with: self! !

!DOCollection methodsFor: 'adding' stamp: ''!
add: newObject 
	"Include newObject as one of the receiver's elements. Answer newObject. 
	ArrayedCollections cannot respond to this message."

	self subclassResponsibility! !

!DOCollection methodsFor: 'adding' stamp: 'sma 5/12/2000 17:21'!
add: newObject withOccurrences: anInteger
	"Add newObject anInteger times to the receiver. Answer newObject."

	anInteger timesRepeat: [self add: newObject].
	^ newObject! !

!DOCollection methodsFor: 'adding' stamp: 'sma 5/12/2000 17:26'!
addAll: aCollection 
	"Include all the elements of aCollection as the receiver's elements. Answer 
	aCollection. Actually, any object responding to #do: can be used as argument."

	aCollection do: [:each | self add: each].
	^ aCollection! !

!DOCollection methodsFor: 'adding' stamp: 'sma 5/12/2000 17:23'!
addIfNotPresent: anObject
	"Include anObject as one of the receiver's elements, but only if there
	is no such element already. Anwser anObject."

	(self includes: anObject) ifFalse: [self add: anObject].
	^ anObject! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 4/30/2000 11:17'!
allSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for any element return false.
	Otherwise return true."

	self do: [:each | (aBlock value: each) ifFalse: [^ false]].
	^ true! !

!DOCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:33'!
anyOne
	"Answer a representative sample of the receiver. This method can
	be helpful when needing to preinfer the nature of the contents of 
	semi-homogeneous collections."

	self emptyCheck.
	self do: [:each | ^ each]! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 4/30/2000 11:17'!
anySatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns true for any element return true.
	Otherwise return false."

	self do: [:each | (aBlock value: each) ifTrue: [^ true]].
	^ false! !

!DOCollection methodsFor: 'converting' stamp: 'pmaer 4/27/2012 14:00'!
asArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| array index |
	array := DOArray new: self size.
	index := 0.
	self do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!DOCollection methodsFor: 'converting' stamp: 'sma 5/6/2000 20:10'!
asBag
	"Answer a Bag whose elements are the elements of the receiver."

	^ Bag withAll: self! !

!DOCollection methodsFor: 'converting' stamp: 'sma 5/6/2000 20:22'!
asByteArray
	"Answer a ByteArray whose elements are the elements of the receiver.
	Implementation note: Cannot use ''ByteArray withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| array index |
	array := ByteArray new: self size.
	index := 0.
	self do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!DOCollection methodsFor: 'converting' stamp: 'sma 5/6/2000 20:26'!
asCharacterSet
	"Answer a CharacterSet whose elements are the unique elements of the receiver.
	The reciever should only contain characters."

	^ CharacterSet newFrom: self! !

!DOCollection methodsFor: 'printing' stamp: 'gk 1/14/2005 08:19'!
asCommaString
	"Return collection printed as 'a, b, c' "

	^String streamContents: [:s | self asStringOn: s delimiter: ', ']
		! !

!DOCollection methodsFor: 'printing' stamp: 'gk 1/14/2005 08:20'!
asCommaStringAnd
	"Return collection printed as 'a, b and c' "

	^String streamContents: [:s | self asStringOn: s delimiter: ', ' last: ' and ']
		! !

!DOCollection methodsFor: 'converting' stamp: 'pmaer 5/7/2012 15:14'!
asDOArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| array index |
	array := DOArray new: self size.
	index := 0.
	self do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!DOCollection methodsFor: 'converting' stamp: 'pmaer 5/7/2012 00:37'!
asDOOrderedCollection
	"Answer an OrderedCollection whose elements are the elements of the
	receiver. The order in which elements are added depends on the order
	in which the receiver enumerates its elements. In the case of unordered
	collections, the ordering is not necessarily the same for multiple 
	requests for the conversion."

	^ self as: DOOrderedCollection! !

!DOCollection methodsFor: 'converting' stamp: 'MarcusDenker 11/28/2009 11:40'!
asDictionary

	^ self as: Dictionary! !

!DOCollection methodsFor: 'converting' stamp: 'ar 9/22/2000 10:12'!
asIdentitySet
	^(IdentitySet new: self size) addAll: self; yourself! !

!DOCollection methodsFor: 'converting' stamp: 'pmaer 4/27/2012 14:02'!
asOrderedCollection
	"Answer an OrderedCollection whose elements are the elements of the
	receiver. The order in which elements are added depends on the order
	in which the receiver enumerates its elements. In the case of unordered
	collections, the ordering is not necessarily the same for multiple 
	requests for the conversion."

	^ self as: DOOrderedCollection! !

!DOCollection methodsFor: 'converting' stamp: 'sma 5/6/2000 20:29'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!DOCollection methodsFor: 'converting' stamp: 'StephaneDucasse 3/28/2010 22:39'!
asSortedCollection
	"Answer a SortedCollection whose elements are the elements of the receiver. The sort order is the default less than or equal. Note that you should use #sorted: if you don't really need a SortedCollection, but a sorted collection."

	^ self as: SortedCollection! !

!DOCollection methodsFor: 'converting' stamp: 'StephaneDucasse 3/28/2010 22:41'!
asSortedCollection: aSortBlock 
	"Answer a SortedCollection whose elements are the elements of the receiver. The sort order is defined by the argument, aSortBlock. Note that this is better to use #sorted: if you don't really need a SortedCollection, but a sorted collection!!!!"

	| aSortedCollection |
	aSortedCollection := SortedCollection new: self size.
	aSortedCollection sortBlock: aSortBlock.
	aSortedCollection addAll: self.
	^ aSortedCollection! !

!DOCollection methodsFor: 'printing' stamp: 'gk 1/14/2005 08:27'!
asStringOn: aStream delimiter: delimString
	"Print elements on a stream separated
	with a delimiter String like: 'a, b, c'
	Uses #asString instead of #print:."

	self do: [:elem | aStream nextPutAll: elem asString]
		separatedBy: [aStream nextPutAll: delimString]! !

!DOCollection methodsFor: 'printing' stamp: 'gk 1/14/2005 08:27'!
asStringOn: aStream delimiter: delimString last: lastDelimString
	"Print elements on a stream separated
	with a delimiter between all the elements and with
	a special one before the last like: 'a, b and c'.
	Uses #asString instead of #print:

	Note: Feel free to improve the code to detect the last element."

	| n sz |
	n := 1.
	sz := self size.
	self do: [:elem |
		n := n + 1.
		aStream nextPutAll: elem asString]
	separatedBy: [
		aStream nextPutAll: (n = sz ifTrue: [lastDelimString] ifFalse: [delimString])]! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
associationsDo: aBlock
	"Evaluate aBlock for each of the receiver's elements (key/value 
	associations).  If any non-association is within, the error is not caught now,
	but later, when a key or value message is sent to it."

	self do: aBlock! !

!DOCollection methodsFor: 'accessing' stamp: 'sd 11/4/2003 22:05'!
atRandom
	"Answer a random element of the receiver.  Uses a shared random 
	number generator owned by class Collection.  If you use this a lot, 
	define your own instance of Random and use #atRandom:.  Causes 
	an error if self has no elements."

	^ self class mutexForPicking critical: [
		self atRandom: self class randomForPicking ]

"Examples:
	#('one' 'or' 'the' 'other') atRandom
	(1 to: 10) atRandom
	'Just pick one of these letters at random' atRandom
	#(3 7 4 9 21) asSet atRandom		(just to show it also works for Sets)
"! !

!DOCollection methodsFor: 'accessing' stamp: 'nice 4/19/2011 00:26'!
atRandom: aGenerator
	"Answer a random element of the receiver. Uses aGenerator which
should be kept by the user in a variable and used every time. Use
this instead of #atRandom for better uniformity of random numbers because 
	only you use the generator. Causes an error if self has no elements."
	| rand index |

	self emptyCheck.
	rand := aGenerator nextInt: self size.
	index := 1.
	self do: [:each |
		index = rand ifTrue: [^each].
		index := index + 1].
	^ self errorEmptyCollection
! !

!DOCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:41'!
capacity
	"Answer the current capacity of the receiver."

	^ self size! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:45'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!DOCollection methodsFor: 'enumerating' stamp: 'ul 11/21/2009 01:16'!
collect: aBlock as: aClass
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into an instance of aClass. Answer the resulting collection."

	^(aClass new: self size) fillFrom: self with: aBlock! !

!DOCollection methodsFor: 'enumerating' stamp: 'ul 11/21/2009 01:16'!
collect: aBlock into: aCollection
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into aCollection. Answer aCollection."

	^aCollection fillFrom: self with: aBlock! !

!DOCollection methodsFor: 'enumerating' stamp: 'dgd 9/13/2004 23:42'!
collect: collectBlock thenDo: doBlock 
	"Utility method to improve readability."
	^ (self collect: collectBlock) do: doBlock! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:51'!
collect: collectBlock thenSelect: selectBlock
	"Utility method to improve readability."

	^ (self collect: collectBlock) select: selectBlock! !

!DOCollection methodsFor: 'testing' stamp: ''!
contains: aBlock
	"VW compatibility"
	^self anySatisfy: aBlock! !

!DOCollection methodsFor: 'filter streaming' stamp: 'sma 5/12/2000 12:07'!
contents
	^ self! !

!DOCollection methodsFor: 'copying' stamp: 'sma 5/12/2000 14:41'!
copyWith: newElement
	"Answer a new collection with newElement added (as last
	element if sequenceable)."

	^ self copy
		add: newElement;
		yourself! !

!DOCollection methodsFor: 'copying' stamp: 'ar 2/11/2001 01:55'!
copyWithDependent: newElement
	"Answer a new collection with newElement added (as last
	element if sequenceable)."
	^self copyWith: newElement! !

!DOCollection methodsFor: 'copying' stamp: 'sma 5/12/2000 14:43'!
copyWithout: oldElement 
	"Answer a copy of the receiver that does not contain any
	elements equal to oldElement."

	^ self reject: [:each | each = oldElement]

"Examples:
	'fred the bear' copyWithout: $e
	#(2 3 4 5 5 6) copyWithout: 5
"! !

!DOCollection methodsFor: 'copying' stamp: 'sma 5/12/2000 18:08'!
copyWithoutAll: aCollection
	"Answer a copy of the receiver that does not contain any elements 
	equal to those in aCollection."

	^ self reject: [:each | aCollection includes: each]! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:52'!
count: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the number of elements that answered true."

	| sum |
	sum := 0.
	self do: [:each | (aBlock value: each) ifTrue: [sum := sum + 1]].
	^ sum! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:20'!
detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ self detect: aBlock ifNone: [self errorNotFound: aBlock]! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:52'!
detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self do: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value! !

!DOCollection methodsFor: 'enumerating' stamp: 'nice 1/5/2010 15:59'!
detectMax: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the highest magnitude.
	If collection empty, return nil.  This method might also be called elect:."

	| maxElement maxValue |
	self do: [:each | | val | 
		maxValue == nil
			ifFalse: [
				(val := aBlock value: each) > maxValue ifTrue: [
					maxElement := each.
					maxValue := val]]
			ifTrue: ["first element"
				maxElement := each.
				maxValue := aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ maxElement! !

!DOCollection methodsFor: 'enumerating' stamp: 'nice 1/5/2010 15:59'!
detectMin: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the lowest number.
	If collection empty, return nil."

	| minElement minValue |
	self do: [:each | | val | 
		minValue == nil
			ifFalse: [
				(val := aBlock value: each) < minValue ifTrue: [
					minElement := each.
					minValue := val]]
			ifTrue: ["first element"
				minElement := each.
				minValue := aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ minElement! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
detectSum: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Return the sum of the answers."
	| sum |
	sum := 0.
	self do: [:each | 
		sum := (aBlock value: each) + sum].  
	^ sum! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 17:52'!
difference: aCollection
	"Answer the set theoretic difference of two collections."

	^ self reject: [:each | aCollection includes: each]! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
do: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument."

	self subclassResponsibility! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 2/4/2010 15:34'!
do: aBlock displayingProgress: aStringOrBlock
	"Enumerate aBlock displaying progress information. 
	If the argument is a string, use a static label for the process. 
	If the argument is a block, evaluate it with the element to retrieve the label.
		Smalltalk allClasses 
			do:[:aClass| (Delay forMilliseconds: 1) wait]
			displayingProgress: 'Processing...'.
		Smalltalk allClasses 
			do:[:aClass| (Delay forMilliseconds: 1) wait]
			displayingProgress:[:aClass| 'Processing ', aClass name].
	"
	^self do: aBlock displayingProgress: aStringOrBlock every: 20! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 4/4/2010 16:14'!
do: aBlock displayingProgress: aStringOrBlock every: msecs
       "Enumerate aBlock displaying progress information.
       If the argument is a string, use a static label for the process.
       If the argument is a block, evaluate it with the element to retrieve the label.
       The msecs argument ensures that updates happen at most every msecs.
       Example:
               Smalltalk allClasses
                       do:[:aClass| (Delay forMilliseconds: 1) wait]
                       displayingProgress:[:aClass| 'Processing ', aClass name]
                       every: 0."

	| size labelBlock count oldLabel lastUpdate |
	labelBlock := aStringOrBlock isString
               ifTrue: [[:item| aStringOrBlock]]
               ifFalse: [aStringOrBlock].
	oldLabel := nil.
	count := lastUpdate := 0.
	size := self size.
	'' displayProgressAt: Sensor cursorPoint from: 0 to: size during: [:bar |
		self do: [:each| | newLabel |
				"Special handling for first and last element"
				(count = 0 or: [count+1 = size
					or: [(Time millisecondsSince: lastUpdate) >= msecs]]) 
						ifTrue:
							[bar value: count.
							oldLabel = (newLabel := (labelBlock value: each) ifNil: [oldLabel]) 
								ifFalse: [ProgressNotification signal: '' extra: (oldLabel := newLabel)].
				lastUpdate := Time millisecondClockValue ].
                       aBlock value: each.
                       count := count + 1]]! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:57'!
do: elementBlock separatedBy: separatorBlock
	"Evaluate the elementBlock for all elements in the receiver,
	and evaluate the separatorBlock between."

	| beforeFirst | 
	beforeFirst := true.
	self do:
		[:each |
		beforeFirst
			ifTrue: [beforeFirst := false]
			ifFalse: [separatorBlock value].
		elementBlock value: each]! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:59'!
do: aBlock without: anItem 
	"Enumerate all elements in the receiver. 
	Execute aBlock for those elements that are not equal to the given item"

	^ self do: [:each | anItem = each ifFalse: [aBlock value: each]]! !

!DOCollection methodsFor: 'private' stamp: ''!
emptyCheck

	self isEmpty ifTrue: [self errorEmptyCollection]! !

!DOCollection methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/18/2011 14:59'!
errorEmptyCollection
	"Signal a CollectionIsEmpty exception"

	CollectionIsEmpty signalWith: self! !

!DOCollection methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/18/2011 14:58'!
errorNoMatch
	"Signal a SizeMismatch exception"

	SizeMismatch signal! !

!DOCollection methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/18/2011 14:37'!
errorNotFound: anObject
	"Raise a NotFound exception."

	NotFound signalFor: anObject! !

!DOCollection methodsFor: 'private' stamp: 'yo 6/29/2004 13:14'!
errorNotKeyed

	self error: ('Instances of {1} do not respond to keyed accessing messages.' translated format: {self class name})
! !

!DOCollection methodsFor: 'private' stamp: 'ul 11/21/2009 01:14'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection do: [ :each |
		self add: (aBlock value: each) ]! !

!DOCollection methodsFor: 'enumerating' stamp: 'nice 12/9/2009 15:37'!
findFirstInByteString: aByteString startingAt: start
	"Find the index of first character starting at start in aByteString that is included in the receiver.
	Default is to use a naive algorithm.
	Subclasses might want to implement a more efficient scheme"

	start to: aByteString size do:
		[:index |
		(self includes: (aByteString at: index)) ifTrue: [^ index]].
	^ 0! !

!DOCollection methodsFor: 'filter streaming' stamp: 'sma 5/12/2000 12:08'!
flattenOnStream: aStream 
	^ aStream writeCollection: self! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 2/1/2011 07:34'!
fold: binaryBlock
	"Evaluate the block with the first two elements of the receiver,
	then with the result of the first evaluation and the next element,
	and so on.  Answer the result of the final evaluation. If the receiver
	is empty, raise an error. If the receiver has a single element, answer
	that element."
	"#('if' 'it' 'is' 'to' 'be' 'it' 'is' 'up' 'to' 'me') fold: [:a :b | a, ' ', b]"

	^self reduce: binaryBlock! !

!DOCollection methodsFor: 'enumerating' stamp: 'pmaer 4/27/2012 14:00'!
gather: aBlock
	^ DOArray streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 1/3/2010 20:15'!
groupBy: keyBlock having: selectBlock 
	"This message is deprecated. Please use groupedBy:having:. 
	But we let it right now without warning because we are not sure to 
	remove in the next iteration."

	^ self groupedBy: keyBlock having: selectBlock ! !

!DOCollection methodsFor: 'enumerating' stamp: 'pmaer 4/27/2012 14:02'!
groupedBy: aBlock
	"Answer a dictionary whose keys are the result of evaluating aBlock
	for all my elements, and the value for each key is the selection of 
	my elements that evaluated to that key. Uses species."
	| groups |
	groups := PluggableDictionary integerDictionary.
	self do: [ :each |
		(groups at: (aBlock value: each) ifAbsentPut: [ DOOrderedCollection new ]) add: each ].
	self species ~~ DOOrderedCollection ifTrue: [
		groups associationsDo: [ :association |
			association value: (self species withAll: association value) ]].
	^ groups
! !

!DOCollection methodsFor: 'enumerating' stamp: 'AdrianKuhn 12/30/2009 09:37'!
groupedBy: aBlock having: aSelectionBlock
	"Like in SQL operation - Split the recievers contents into collections of 
	elements for which keyBlock returns the same results, and return those 
	collections allowed by selectBlock."
	^ (self groupedBy: aBlock) select: aSelectionBlock
! !

!DOCollection methodsFor: 'comparing' stamp: 'SqR 8/3/2000 13:36'!
hash
	"Answer an integer hash value for the receiver such that,
	  -- the hash value of an unchanged object is constant over time, and
	  -- two equal objects have equal hash values"

	| hash |

	hash := self species hash.
	self size <= 10 ifTrue:
		[self do: [:elem | hash := hash bitXor: elem hash]].
	^hash bitXor: self size hash! !

!DOCollection methodsFor: 'testing' stamp: 'ls 3/27/2000 17:25'!
identityIncludes: anObject 
	"Answer whether anObject is one of the receiver's elements."

	self do: [:each | anObject == each ifTrue: [^true]].
	^false! !

!DOCollection methodsFor: 'testing' stamp: 'StephaneDucasse 7/3/2010 22:15'!
ifEmpty: aBlock
	"Evaluate the given block with the receiver as argument, answering its value if the receiver is empty, otherwise answer the receiver."
	
	"Note that the fact that this method returns its argument in case the receiver is not empty allows one to write expressions like the following ones: self classifyMethodAs: (myProtocol ifEmpty: ['As yet unclassified'])"

	^ self isEmpty 
		ifTrue: [ ^aBlock value ]
		ifFalse: [ self ]! !

!DOCollection methodsFor: 'testing' stamp: 'HenrikSperreJohansen 6/28/2010 12:13'!
ifEmpty: emptyBlock ifNotEmpty: notEmptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise"
	" If the notEmptyBlock has an argument, eval with the receiver as its argument"

	self isEmpty ifTrue: [ ^emptyBlock value ].
	^notEmptyBlock cull: self! !

!DOCollection methodsFor: 'testing' stamp: 'ul 11/11/2009 16:24'!
ifEmpty: emptyBlock ifNotEmptyDo: notEmptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise"
	"Evaluate the notEmptyBlock with the receiver as its argument"

	self isEmpty ifTrue: [ ^emptyBlock value ].
	^notEmptyBlock value: self! !

!DOCollection methodsFor: 'testing' stamp: 'StephaneDucasse 7/3/2010 22:10'!
ifNotEmpty: aBlock
	"Evaluate the given block with the receiver as argument, answering its value
      unless the receiver is empty, in which case answer the receiver

      If the block has an argument, eval with the receiver as its argument,
      but it might be better to use ifNotEmptyDo: to make the code easier to
      understand"
	"Note that the fact that this method returns its argument in case the receiver is empty
	allows one to write expressions like the following ones:
		self classifyMethodAs: (myProtocol ifEmpty: ['As yet unclassified']"
	
    ^self isEmpty
          ifTrue: [self]
          ifFalse: [aBlock cull: self]
! !

!DOCollection methodsFor: 'testing' stamp: 'HenrikSperreJohansen 6/28/2010 12:14'!
ifNotEmpty: notEmptyBlock ifEmpty: emptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise
	 If the notEmptyBlock has an argument, eval with the receiver as its argument"

	self isEmpty ifFalse: [ ^notEmptyBlock cull: self ].
	^emptyBlock value! !

!DOCollection methodsFor: 'testing' stamp: 'ar 11/21/2009 00:36'!
ifNotEmptyDo: aBlock
	"Evaluate the given block with the receiver as its argument."

	self isEmpty ifFalse: [^ aBlock value: self].
! !

!DOCollection methodsFor: 'testing' stamp: 'ul 11/11/2009 16:25'!
ifNotEmptyDo: notEmptyBlock ifEmpty: emptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise
	Evaluate the notEmptyBlock with the receiver as its argument"

	self isEmpty ifFalse: [ ^notEmptyBlock value: self ].
	^emptyBlock value! !

!DOCollection methodsFor: 'testing' stamp: 'sma 5/12/2000 14:07'!
includes: anObject 
	"Answer whether anObject is one of the receiver's elements."

	^ self anySatisfy: [:each | each = anObject]! !

!DOCollection methodsFor: 'testing' stamp: ''!
includesAllOf: aCollection 
	"Answer whether all the elements of aCollection are in the receiver."
	aCollection do: [:elem | (self includes: elem) ifFalse: [^ false]].
	^ true! !

!DOCollection methodsFor: 'testing' stamp: ''!
includesAnyOf: aCollection 
	"Answer whether any element of aCollection is one of the receiver's elements."
	aCollection do: [:elem | (self includes: elem) ifTrue: [^ true]].
	^ false! !

!DOCollection methodsFor: 'testing' stamp: 'nk 8/30/2004 07:49'!
includesSubstringAnywhere: testString
	"Answer whether the receiver includes, anywhere in its nested structure, a string that has testString as a substring"
	self do:
		[:element |
			(element isString)
				ifTrue:
					[(element includesSubString: testString) ifTrue: [^ true]].
			(element isCollection)
				ifTrue:
					[(element includesSubstringAnywhere: testString) ifTrue: [^ true]]].
	^ false

"#(first (second third) ((allSentMessages ('Elvis' includes:)))) includesSubstringAnywhere:  'lvi'"! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
inject: thisValue into: binaryBlock 
	"Accumulate a running value associated with evaluating the argument, 
	binaryBlock, with the current value of the argument, thisValue, and the 
	receiver as block arguments. For instance, to sum the numeric elements 
	of a collection, aCollection inject: 0 into: [:subTotal :next | subTotal + 
	next]."

	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each].
	^nextValue! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 17:52'!
intersection: aCollection
	"Answer the set theoretic intersection of two collections."

	^ self select: [:each | aCollection includes: each]! !

!DOCollection methodsFor: 'testing' stamp: 'ar 8/17/1999 19:43'!
isCollection
	"Return true if the receiver is some sort of Collection and responds to basic collection messages such as #size and #do:"
	^true! !

!DOCollection methodsFor: 'testing' stamp: ''!
isEmpty
	"Answer whether the receiver contains any elements."

	^self size = 0! !

!DOCollection methodsFor: 'testing' stamp: 'bf 3/10/2000 09:29'!
isEmptyOrNil
	"Answer whether the receiver contains any elements, or is nil.  Useful in numerous situations where one wishes the same reaction to an empty collection or to nil"

	^ self isEmpty! !

!DOCollection methodsFor: 'testing' stamp: 'di 11/6/1998 09:16'!
isSequenceable
	^ false! !

!DOCollection methodsFor: 'math functions' stamp: 'TAG 11/6/1998 16:00'!
median
	^ self asSortedCollection median! !

!DOCollection methodsFor: 'enumerating' stamp: 'gh 9/18/2001 15:59'!
noneSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for all elements return true.
	Otherwise return false"

	self do: [:item | (aBlock value: item) ifTrue: [^ false]].
	^ true! !

!DOCollection methodsFor: 'testing' stamp: 'sma 5/12/2000 17:49'!
notEmpty
	"Answer whether the receiver contains any elements."

	^ self isEmpty not! !

!DOCollection methodsFor: 'testing' stamp: ''!
occurrencesOf: anObject 
	"Answer how many of the receiver's elements are equal to anObject."

	| tally |
	tally := 0.
	self do: [:each | anObject = each ifTrue: [tally := tally + 1]].
	^tally! !

!DOCollection methodsFor: 'printing' stamp: 'apb 4/21/2006 09:37'!
printElementsOn: aStream
	"The original code used #skip:, but some streams do not support that,
	 and we don't really need it."

	aStream nextPut: $(.
	self do: [:element | aStream print: element] separatedBy: [aStream space].
	aStream nextPut: $)! !

!DOCollection methodsFor: 'printing' stamp: 'sma 6/1/2000 09:41'!
printNameOn: aStream
	super printOn: aStream! !

!DOCollection methodsFor: 'printing' stamp: 'sma 6/1/2000 09:41'!
printOn: aStream 
	"Append a sequence of characters that identify the receiver to aStream."

	self printNameOn: aStream.
	self printElementsOn: aStream! !

!DOCollection methodsFor: 'printing' stamp: 'gk 1/14/2005 08:01'!
printOn: aStream delimiter: delimString
	"Print elements on a stream separated
	with a delimiter String like: 'a, b, c' "

	self do: [:elem | aStream print: elem] separatedBy: [aStream print: delimString]
		! !

!DOCollection methodsFor: 'printing' stamp: 'fbs 1/14/2005 10:54'!
printOn: aStream delimiter: delimString last: lastDelimString
	"Print elements on a stream separated
	with a delimiter between all the elements and with
	a special one before the last like: 'a, b and c'

	Note: Feel free to improve the code to detect the last element."

	| n sz |
	n := 1.
	sz := self size.
	self do: [:elem |
		n := n + 1.
		aStream print: elem]
	separatedBy: [
		n = sz
			ifTrue: [aStream print: lastDelimString]
			ifFalse: [aStream print: delimString]]! !

!DOCollection methodsFor: 'enumerating' stamp: 'ThomasHolzer 4/15/2011 14:52'!
reduce: aBlock
	"Convert the collection to an ordered collection (sequenceable collection)"
	^self asOrderedCollection reduce: aBlock! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
reject: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver only those elements for 
	which aBlock evaluates to false. Answer the new collection."

	^self select: [:element | (aBlock value: element) == false]! !

!DOCollection methodsFor: 'enumerating' stamp: 'dgd 9/13/2004 23:42'!
reject: rejectBlock thenDo: doBlock 
	"Utility method to improve readability."
	^ (self reject: rejectBlock) do: doBlock! !

!DOCollection methodsFor: 'removing' stamp: 'sma 5/12/2000 11:22'!
remove: oldObject 
	"Remove oldObject from the receiver's elements. Answer oldObject 
	unless no element is equal to oldObject, in which case, raise an error.
	ArrayedCollections cannot respond to this message."

	^ self remove: oldObject ifAbsent: [self errorNotFound: oldObject]! !

!DOCollection methodsFor: 'removing' stamp: 'sma 5/12/2000 11:14'!
remove: oldObject ifAbsent: anExceptionBlock 
	"Remove oldObject from the receiver's elements. If several of the 
	elements are equal to oldObject, only one is removed. If no element is 
	equal to oldObject, answer the result of evaluating anExceptionBlock. 
	Otherwise, answer the argument, oldObject. ArrayedCollections cannot 
	respond to this message."

	self subclassResponsibility! !

!DOCollection methodsFor: 'removing' stamp: 'nice 9/14/2009 20:30'!
removeAll
	"Remove each element from the receiver and leave it empty.
	ArrayedCollections cannot respond to this message.
	There are two good reasons why a subclass should override this message:
	1) the subclass does not support being modified while being iterated
	2) the subclass provides a much faster way than iterating through each element"

	self do: [:each | self remove: each].! !

!DOCollection methodsFor: 'removing' stamp: 'nice 1/10/2009 00:01'!
removeAll: aCollection 
	"Remove each element of aCollection from the receiver. If successful for 
	each, answer aCollection. Otherwise create an error notification.
	ArrayedCollections cannot respond to this message."

	aCollection == self ifTrue: [^self removeAll].
	aCollection do: [:each | self remove: each].
	^ aCollection! !

!DOCollection methodsFor: 'removing' stamp: 'sma 5/12/2000 11:16'!
removeAllFoundIn: aCollection 
	"Remove each element of aCollection which is present in the receiver 
	from the receiver. Answer aCollection. No error is raised if an element
	isn't found. ArrayedCollections cannot respond to this message."

	aCollection do: [:each | self remove: each ifAbsent: []].
	^ aCollection! !

!DOCollection methodsFor: 'removing' stamp: 'sma 5/12/2000 11:19'!
removeAllSuchThat: aBlock 
	"Evaluate aBlock for each element and remove all that elements from
	the receiver for that aBlock evaluates to true.  Use a copy to enumerate 
	collections whose order changes when an element is removed (i.e. Sets)."

	self copy do: [:each | (aBlock value: each) ifTrue: [self remove: each]]! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:59'!
select: selectBlock thenCollect: collectBlock
	"Utility method to improve readability."

	^ (self select: selectBlock) collect: collectBlock! !

!DOCollection methodsFor: 'enumerating' stamp: 'hfm 2/12/2009 13:38'!
select: selectBlock thenDo: doBlock
    "Utility method to improve readability.
	Do not create the intermediate collection."

    self do: [: each |
        ( selectBlock value: each ) 
			ifTrue: [ doBlock value: each ]
    ].! !

!DOCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:34'!
size
	"Answer how many elements the receiver contains."

	| tally |
	tally := 0.
	self do: [:each | tally := tally + 1].
	^ tally! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 3/28/2010 22:44'!
sorted
	"Return a new sequenceable collection which contains the same elements as self but its 
elements are sorted in ascending order using the #'<=' operator."
	
	^self sorted: nil! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 3/28/2010 22:42'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its 
elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if 
the first element should preceed the second one. If aSortBlock is nil then <= is used for 
comparison."
	
	^self asArray sort: aSortBlockOrNil! !

!DOCollection methodsFor: 'math functions' stamp: 'MarcusDenker 8/15/2010 11:01'!
stdev
	| avg sample sum |
	avg := self average. 
	"see comment in self sum"
	sample := self anyOne.
	sum := self inject: sample into: [:accum :each | accum + (each - avg) squared].
	sum := sum - sample.
	^ (sum / (self size - 1)) sqrt! !

!DOCollection methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	"Refer to the comment in Object|storeOn:."

	| noneYet |
	aStream nextPutAll: '(('.
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' new)'.
	noneYet := true.
	self do: 
		[:each | 
		noneYet
			ifTrue: [noneYet := false]
			ifFalse: [aStream nextPut: $;].
		aStream nextPutAll: ' add: '.
		aStream store: each].
	noneYet ifFalse: [aStream nextPutAll: '; yourself'].
	aStream nextPut: $)! !

!DOCollection methodsFor: 'math functions' stamp: 'JuanVuletich 10/11/2010 20:15'!
sum: aBlock
	"This is implemented using a variant of the normal inject:into: pattern. 
	The reason for this is that it is not known whether we're in the normal 
	number line, i.e. whether 0 is a good initial value for the sum. 
	Consider a collection of measurement objects, 0 would be the unitless 
	value and would not be appropriate to add with the unit-ed objects."
	| sum sample |
	sample := aBlock value: self anyOne.
	sum := self inject: sample into: [ :previousValue :each |  previousValue + (aBlock value: each) ].
	^ sum - sample! !

!DOCollection methodsFor: 'private' stamp: ''!
toBraceStack: itsSize 
	"Push receiver's elements onto the stack of thisContext sender.  Error if receiver does
	 not have itsSize elements or if receiver is unordered.
	 Do not call directly: this is called by {a. b} := ... constructs."

	self size ~= itsSize ifTrue:
		[self error: 'Trying to store ', self size printString,
					' values into ', itsSize printString, ' variables.'].
	thisContext sender push: itsSize fromIndexable: self! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 17:54'!
union: aCollection
	"Answer the set theoretic union of two collections."

	^ self asSet addAll: aCollection; yourself! !

!DOCollection methodsFor: 'filter streaming' stamp: 'sma 5/12/2000 12:07'!
write: anObject 
	^ self add: anObject! !

DOCollection subclass: #DOSequenceableCollection
	uses: TSortable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-AdaptedClasses'!

!DOSequenceableCollection commentStamp: '<historical>' prior: 0!
I am an abstract superclass for collections that have a well-defined order associated with their elements. Thus each element is externally-named by integers referred to as indices.!

DOSequenceableCollection class
	uses: TSortable classTrait
	instanceVariableNames: ''!

DOSequenceableCollection subclass: #DOArrayedCollection
	uses: TSortable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-AdaptedClasses'!

!DOArrayedCollection commentStamp: '<historical>' prior: 0!
I am an abstract collection of elements with a fixed range of integers (from 1 to n>=0) as external keys.!

DOArrayedCollection class
	uses: TSortable classTrait
	instanceVariableNames: ''!

DOArrayedCollection variableSubclass: #DOArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'DynamicOwnership-AdaptedClasses'!

!DOArray commentStamp: '<historical>' prior: 0!
I present an ArrayedCollection whose elements are objects.!

!DOArray class methodsFor: 'brace support' stamp: 'di 11/18/1999 22:53'!
braceStream: nElements
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ WriteStream basicNew braceArray: (self new: nElements)
! !

!DOArray class methodsFor: 'brace support' stamp: 'di 11/19/1999 08:16'!
braceWith: a
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 1.
	array at: 1 put: a.
	^ array! !

!DOArray class methodsFor: 'brace support' stamp: 'di 11/19/1999 08:15'!
braceWith: a with: b 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 2.
	array at: 1 put: a.
	array at: 2 put: b.
	^ array! !

!DOArray class methodsFor: 'brace support' stamp: 'di 11/19/1999 08:17'!
braceWith: a with: b with: c 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 3.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	^ array! !

!DOArray class methodsFor: 'brace support' stamp: 'di 11/19/1999 08:17'!
braceWith: a with: b with: c with: d
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 4.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	array at: 4 put: d.
	^ array! !

!DOArray class methodsFor: 'brace support' stamp: 'di 11/19/1999 08:16'!
braceWithNone
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ self new: 0! !

!DOArray class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/23/2012 15:23'!
compilerClass
	^OwnershipCompiler3 ! !

!DOArray class methodsFor: 'instance creation' stamp: 'StephaneDucasse 2/13/2010 12:18'!
empty
	"A canonicalized empty Array instance."
	^ #()! !

!DOArray class methodsFor: 'instance creation' stamp: 'md 7/19/2004 12:34'!
new: sizeRequested 
	"Answer an instance of this class with the number of indexable
	variables specified by the argument, sizeRequested.
	
	This is a shortcut (direct call of primitive, no #initialize, for performance"

	<primitive: 71>  "This method runs primitively if successful"
	^ self basicNew: sizeRequested  "Exceptional conditions will be handled in basicNew:"
! !

!DOArray methodsFor: 'converting' stamp: 'sma 5/12/2000 17:32'!
asArray
	"Answer with the receiver itself."

	^ self! !

!DOArray methodsFor: 'accessing' stamp: 'ar 8/26/2001 22:02'!
atWrap: index 
	"Optimized to go through the primitive if possible"
	<primitive: 60>
	^ self at: index - 1 \\ self size + 1! !

!DOArray methodsFor: 'accessing' stamp: 'ar 8/26/2001 22:03'!
atWrap: index put: anObject
	"Optimized to go through the primitive if possible"
	<primitive: 61>
	^ self at: index - 1 \\ self size + 1 put: anObject! !

!DOArray methodsFor: 'copying' stamp: 'ar 2/11/2001 01:55'!
copyWithDependent: newElement
	self size = 0 ifTrue:[^DependentsArray with: newElement].
	^self copyWith: newElement! !

!DOArray methodsFor: 'converting' stamp: 'pmaer 4/27/2012 13:59'!
elementsExchangeIdentityWith: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  At the same time, all pointers to the elements of otherArray are replaced by pointers to the corresponding elements of this array.  The identityHashes remain with the pointers rather than with the objects so that objects in hashed structures should still be properly indexed after the mutation."

	<primitive: 128>
	otherArray class == DOArray ifFalse: [^ self error: 'arg must be array'].
	self size = otherArray size ifFalse: [^ self error: 'arrays must be same size'].
	(self anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	(otherArray anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	self with: otherArray do:[:a :b| a == b ifTrue:[^self error:'can''t become yourself']].

	"Must have failed because not enough space in forwarding table (see ObjectMemory-prepareForwardingTableForBecoming:with:twoWay:).  Do GC and try again only once"
	(Smalltalk bytesLeft: true) = Smalltalk primitiveGarbageCollect
		ifTrue: [^ self primitiveFailed].
	^ self elementsExchangeIdentityWith: otherArray! !

!DOArray methodsFor: 'converting' stamp: 'di 3/28/1999 10:23'!
elementsForwardIdentityTo: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 72>
	self primitiveFailed! !

!DOArray methodsFor: 'converting' stamp: 'brp 9/26/2003 08:09'!
elementsForwardIdentityTo: otherArray copyHash: copyHash
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 249>
	self primitiveFailed! !

!DOArray methodsFor: 'private' stamp: 'pmaer 4/27/2012 13:59'!
hasLiteral: literal
	"Answer true if literal is identical to any literal in this array, even 
	if imbedded in further array structure. This method is only intended 
	for private use by CompiledMethod hasLiteralSymbol:"

	1 to: self size do: [:index |  
		| lit |
		(lit := self at: index) == literal ifTrue: [^ true].
		(lit class == DOArray and: [lit hasLiteral: literal]) ifTrue: [^ true]].
	^ false! !

!DOArray methodsFor: 'private' stamp: 'md 3/1/2006 21:09'!
hasLiteralSuchThat: testBlock
	"Answer true if testBlock returns true for any literal in this array, even if imbedded in 	further Arrays or CompiledMethods.  This method is only intended for private use by 	CompiledMethod 	hasLiteralSuchThat:"
	| lit |
	1 to: self size do: [:index |
		(testBlock value: (lit := self at: index)) ifTrue: [^ true].
		(lit hasLiteralSuchThat: testBlock) ifTrue: [^ true]].
	^ false! !

!DOArray methodsFor: 'testing' stamp: 'eem 5/8/2008 11:13'!
isArray
	^true! !

!DOArray methodsFor: 'testing' stamp: 'pmaer 4/27/2012 13:59'!
isLiteral
	^self class == DOArray and: [self allSatisfy: [:each | each isLiteral]]! !

!DOArray methodsFor: 'self evaluating' stamp: 'pmaer 4/27/2012 13:59'!
isSelfEvaluating
	^ (self allSatisfy: [:each | each isSelfEvaluating]) and: [self class == DOArray]! !

!DOArray methodsFor: 'comparing' stamp: 'ajh 2/2/2002 15:03'!
literalEqual: other

	self class == other class ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	self with: other do: [:e1 :e2 |
		(e1 literalEqual: e2) ifFalse: [^ false]].
	^ true! !

!DOArray methodsFor: 'self evaluating' stamp: 'sd 7/31/2005 21:44'!
printAsLiteralFormOn: aStream
	aStream nextPut: $#.
	self printElementsOn: aStream
! !

!DOArray methodsFor: 'self evaluating' stamp: 'nice 11/1/2009 21:48'!
printAsSelfEvaluatingFormOn: aStream

	aStream nextPut: ${.
	self do: [:el | el storeOn: aStream] separatedBy: [ aStream nextPutAll: '. '].
	aStream nextPut: $}! !

!DOArray methodsFor: 'printing' stamp: 'sd 7/31/2005 21:44'!
printOn: aStream
	self isLiteral ifTrue: [self printAsLiteralFormOn: aStream. ^ self].
	self isSelfEvaluating ifTrue: [self printAsSelfEvaluatingFormOn: aStream. ^ self].

	super printOn: aStream! !

!DOArray methodsFor: 'private' stamp: 'G.C 10/22/2008 09:59'!
refersToLiteral: literal 
	"Answer true if literal is identical to any literal in this array, even if imbedded in further array structures or closure methods"
	1 
		to: self size
		do: 
			[ :index | 
			| lit |
			(lit := self at: index) == literal ifTrue: [ ^ true ].
			(lit refersToLiteral: literal) ifTrue: [ ^ true ] ].
	^ false! !

!DOArray methodsFor: 'private' stamp: ''!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!DOArray methodsFor: 'converting' stamp: 'StephaneDucasse 3/28/2010 22:44'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its 
elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if 
the first element should preceed the second one. If aSortBlock is nil then <= is used for 
comparison."
	
	^self copy sort: aSortBlockOrNil! !

!DOArray methodsFor: 'printing' stamp: 'nice 10/31/2009 17:23'!
storeOn: aStream 
	"Use the literal form if possible."

	self isLiteral
		ifTrue: 
			[aStream nextPut: $#; nextPut: $(.
			self do: 
				[:element | 
				element storeOn: aStream.
				aStream space].
			aStream nextPut: $)]
		ifFalse: [super storeOn: aStream]! !

!DOArrayedCollection class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/23/2012 15:23'!
compilerClass
	^OwnershipCompiler3 ! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: ''!
new
	"Answer a new instance of me, with size = 0."

	^self new: 0! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: ''!
new: size withAll: value 
	"Answer an instance of me, with number of elements equal to size, each 
	of which refers to the argument, value."

	^(self new: size) atAllPut: value! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: ''!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	| newArray |
	newArray := self new: aCollection size.
	1 to: aCollection size do: [:i | newArray at: i put: (aCollection at: i)].
	^ newArray

"	Array newFrom: {1. 2. 3}
	{1. 2. 3} as: Array
	{1. 2. 3} as: ByteArray
	{$c. $h. $r} as: String
	{$c. $h. $r} as: Text
"! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'ar 5/17/2001 19:50'!
newFromStream: s
	"Only meant for my subclasses that are raw bits and word-like.  For quick unpack form the disk."
	| len |

	self isPointers | self isWords not ifTrue: [^ super newFromStream: s].
		"super may cause an error, but will not be called."

	s next = 16r80 ifTrue:
		["A compressed format.  Could copy what BitMap does, or use a 
		special sound compression format.  Callers normally compress their own way."
		^ self error: 'not implemented'].
	s skip: -1.
	len := s nextInt32.
	^ s nextWordsInto: (self basicNew: len)! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: ''!
with: anObject 
	"Answer a new instance of me, containing only anObject."

	| newCollection |
	newCollection := self new: 1.
	newCollection at: 1 put: anObject.
	^newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: ''!
with: firstObject with: secondObject 
	"Answer a new instance of me, containing firstObject and secondObject."

	| newCollection |
	newCollection := self new: 2.
	newCollection at: 1 put: firstObject.
	newCollection at: 2 put: secondObject.
	^newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: ''!
with: firstObject with: secondObject with: thirdObject 
	"Answer a new instance of me, containing only the three arguments as
	elements."

	| newCollection |
	newCollection := self new: 3.
	newCollection at: 1 put: firstObject.
	newCollection at: 2 put: secondObject.
	newCollection at: 3 put: thirdObject.
	^newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: ''!
with: firstObject with: secondObject with: thirdObject with: fourthObject 
	"Answer a new instance of me, containing only the three arguments as
	elements."

	| newCollection |
	newCollection := self new: 4.
	newCollection at: 1 put: firstObject.
	newCollection at: 2 put: secondObject.
	newCollection at: 3 put: thirdObject.
	newCollection at: 4 put: fourthObject.
	^newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: ''!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject
	"Answer a new instance of me, containing only the five arguments as
	elements."

	| newCollection |
	newCollection := self new: 5.
	newCollection at: 1 put: firstObject.
	newCollection at: 2 put: secondObject.
	newCollection at: 3 put: thirdObject.
	newCollection at: 4 put: fourthObject.
	newCollection at: 5 put: fifthObject.
	^newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'sw 10/24/1998 22:22'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject with: sixthObject
	"Answer a new instance of me, containing only the 6 arguments as elements."

	| newCollection |
	newCollection := self new: 6.
	newCollection at: 1 put: firstObject.
	newCollection at: 2 put: secondObject.
	newCollection at: 3 put: thirdObject.
	newCollection at: 4 put: fourthObject.
	newCollection at: 5 put: fifthObject.
	newCollection at: 6 put: sixthObject.
	^ newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'sma 5/12/2000 17:37'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size) replaceFrom: 1 to: aCollection size with: aCollection! !

!DOArrayedCollection methodsFor: 'adding' stamp: 'sma 5/12/2000 14:09'!
add: newObject
	self shouldNotImplement! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'nk 3/17/2004 15:22'!
byteSize
	^self basicSize * self bytesPerBasicElement
! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'nk 3/17/2004 16:28'!
bytesPerBasicElement
	"Answer the number of bytes that each of my basic elements requires.
	In other words:
		self basicSize * self bytesPerBasicElement
	should equal the space required on disk by my variable sized representation."
	^self class isBytes ifTrue: [ 1 ] ifFalse: [ 4 ]! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'nk 3/17/2004 18:51'!
bytesPerElement
	^self class isBytes ifTrue: [ 1 ] ifFalse: [ 4 ].
! !

!DOArrayedCollection methodsFor: 'private' stamp: ''!
defaultElement

	^nil! !

!DOArrayedCollection methodsFor: 'private' stamp: 'ul 11/21/2009 01:15'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	| index |
	index := 0.
	aCollection do: [ :each |
		self at: (index := index + 1) put: (aBlock value: each) ]! !

!DOArrayedCollection methodsFor: 'filter streaming' stamp: 'sma 5/12/2000 14:20'!
flattenOnStream: aStream 
	aStream writeArrayedCollection: self! !

!DOArrayedCollection methodsFor: 'sorting' stamp: 'StephaneDucasse 4/23/2010 16:29'!
mergeFirst: first middle: middle last: last into: dst by: aBlock
	"Private. Merge the sorted ranges [first..middle] and [middle+1..last] 
	of the receiver into the range [first..last] of dst."

	| i1 i2 val1 val2 out |
	i1 := first.
	i2 := middle + 1.
	val1 := self at: i1.
	val2 := self at: i2.
	out := first - 1.  "will be pre-incremented"

	"select 'lower' half of the elements based on comparator"
	[(i1 <= middle) and: [i2 <= last]] whileTrue: [
		(aBlock
			ifNil: [val1 <= val2]
			ifNotNil: [ aBlock value: val1 value: val2])
						ifTrue: [dst at: (out := out + 1) put: val1.
								val1 := self at: (i1 := i1 + 1)]
						ifFalse: [dst at: (out := out + 1) put: val2.
								i2 := i2 + 1.
								i2 <= last ifTrue: [val2 := self at: i2]]].

	"copy the remaining elements"
	i1 <= middle
		ifTrue: [dst replaceFrom: out + 1 to: last with: self startingAt: i1]
		ifFalse: [dst replaceFrom: out + 1 to: last with: self startingAt: i2]! !

!DOArrayedCollection methodsFor: 'sorting' stamp: 'jannik.laval 5/1/2010 16:51'!
mergeSortFrom: startIndex to: stopIndex by: aBlock
	"Sort the given range of indices using the mergesort algorithm.
	Mergesort is a worst-case O(N log N) sorting algorithm that usually
	does only half as many comparisons as heapsort or quicksort."

	"Details: recursively split the range to be sorted into two halves,
	mergesort each half, then merge the two halves together. An extra 
	copy of the data is used as temporary storage and successive merge 
	phases copy data back and forth between the receiver and this copy.
	The recursion is set up so that the final merge is performed into the
	receiver, resulting in the receiver being completely sorted."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	startIndex = stopIndex ifTrue: [^ self].
	[startIndex >= 1 and: [startIndex < stopIndex]] assert. "bad start index"
	[stopIndex <= self size] assert. "bad stop index"
	self
		mergeSortFrom: startIndex
		to: stopIndex 
		src: self shallowCopy 
		dst: self 
		by: aBlock! !

!DOArrayedCollection methodsFor: 'removing' stamp: 'klub 9/14/2009 16:27'!
removeAll

	self shouldNotImplement! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'StephaneDucasse 3/17/2010 20:52'!
restoreEndianness
	"This word object was just read in from a stream.  It was stored in Big Endian (Mac) format.  Reverse the byte order if the current machine is Little Endian.
	We only intend this for non-pointer arrays.  Do nothing if I contain pointers."

	self class isPointers | self class isWords not ifTrue: [^self].
	Smalltalk isLittleEndian 
		ifTrue: 
			[Bitmap 
				swapBytesIn: self
				from: 1
				to: self basicSize]! !

!DOArrayedCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:36'!
size
	"Answer how many elements the receiver contains."

	<primitive: 62>
	^ self basicSize! !

!DOArrayedCollection methodsFor: 'private' stamp: ''!
storeElementsFrom: firstIndex to: lastIndex on: aStream

	| noneYet defaultElement arrayElement |
	noneYet := true.
	defaultElement := self defaultElement.
	firstIndex to: lastIndex do: 
		[:index | 
		arrayElement := self at: index.
		arrayElement = defaultElement
			ifFalse: 
				[noneYet
					ifTrue: [noneYet := false]
					ifFalse: [aStream nextPut: $;].
				aStream nextPutAll: ' at: '.
				aStream store: index.
				aStream nextPutAll: ' put: '.
				aStream store: arrayElement]].
	^noneYet! !

!DOArrayedCollection methodsFor: 'printing' stamp: ''!
storeOn: aStream

	aStream nextPutAll: '(('.
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' new: '.
	aStream store: self size.
	aStream nextPut: $).
	(self storeElementsFrom: 1 to: self size on: aStream)
		ifFalse: [aStream nextPutAll: '; yourself'].
	aStream nextPut: $)! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'tk 3/7/2001 17:36'!
swapHalves
		"A normal switch in endianness (byte order in words) reverses the order of 4 bytes.  That is not correct for SoundBuffers, which use 2-bytes units.  If a normal switch has be done, this method corrects it further by swapping the two halves of the long word.
	This method is only used for 16-bit quanities in SoundBuffer, ShortIntegerArray, etc."

	| hack blt |
	"The implementation is a hack, but fast for large ranges"
	hack := Form new hackBits: self.
	blt := (BitBlt toForm: hack) sourceForm: hack.
	blt combinationRule: Form reverse.  "XOR"
	blt sourceY: 0; destY: 0; height: self size; width: 2.
	blt sourceX: 0; destX: 2; copyBits.  "Exchange bytes 0&1 with 2&3"
	blt sourceX: 2; destX: 0; copyBits.
	blt sourceX: 0; destX: 2; copyBits.! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'jb 4/30/2010 17:26'!
writeOn: aStream 
	"Store the array of bits onto the argument, aStream.  (leading byte ~= 16r80) identifies this as raw bits (uncompressed).  Always store in Big Endian (Mac) byte order.  Do the writing at BitBlt speeds. We only intend this for non-pointer arrays.  Do nothing if I contain pointers."
	(self class isPointers or: [ self class isWords not ]) ifTrue: [^ self ].
	aStream nextInt32Put: self basicSize.
	aStream nextWordsPutAll: self.! !

DOSequenceableCollection subclass: #DOOrderedCollection
	uses: TSortable
	instanceVariableNames: 'array firstIndex lastIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-AdaptedClasses'!

!DOOrderedCollection commentStamp: '<historical>' prior: 0!
I represent a collection of objects ordered by the collector.!

DOOrderedCollection class
	uses: TSortable classTrait
	instanceVariableNames: ''!

!DOOrderedCollection class methodsFor: 'private' stamp: 'pmaer 4/27/2012 14:00'!
arrayType
	^ DOArray! !

!DOOrderedCollection class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/23/2012 15:23'!
compilerClass
	^OwnershipCompiler3 ! !

!DOOrderedCollection class methodsFor: 'instance creation' stamp: 'sma 5/12/2000 17:41'!
new
	^ self new: 10! !

!DOOrderedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/1/2012 11:08'!
new: anInteger
"TODO: should this be instrumented too?"
<meta>
| o internalArray |
o := self basicNew.
internalArray:= self arrayType new: anInteger.
internalArray owner: o.
^o setCollection: internalArray.! !

!DOOrderedCollection class methodsFor: 'instance creation' stamp: 'cmm 10/25/2010 22:28'!
new: anInteger withAll: anObject
	^ self basicNew setContents: (self arrayType new: anInteger withAll: anObject)! !

!DOOrderedCollection class methodsFor: 'instance creation' stamp: ''!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."

	| newCollection |
	newCollection := self new: aCollection size.
	newCollection addAll: aCollection.
	^newCollection

"	OrderedCollection newFrom: {1. 2. 3}
	{1. 2. 3} as: OrderedCollection
	{4. 2. 7} as: SortedCollection
"! !

!DOOrderedCollection class methodsFor: 'instance creation' stamp: 'apb 10/15/2000 22:02'!
ofSize: n
	"Create a new collection of size n with nil as its elements.
	This method exists because OrderedCollection new: n creates an
	empty collection,  not one of size n."
	| collection |
	collection := self new: n.
	collection setContents: (collection collector).
	^ collection
! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
add: newObject

	^self addLast: newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
add: newObject after: oldObject 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just succeeding oldObject. Answer newObject."
	
	| index |
	index := self find: oldObject.
	self insert: newObject before: index + 1.
	^newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'CamilloBruni 4/12/2011 13:52'!
add: newObject afterIndex: index 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just after index. Answer newObject."
	(index between: 0 and: self size) ifFalse:[^self errorSubscriptBounds: index].
	self insert: newObject before: firstIndex + index.
	^ newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
add: newObject before: oldObject 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just preceding oldObject. Answer newObject."
	
	| index |
	index := self find: oldObject.
	self insert: newObject before: index.
	^newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'ar 7/15/2008 23:05'!
add: newObject beforeIndex: index 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just before index. Answer newObject."
	(index between: 1 and: self size+1) ifFalse:[^self errorSubscriptBounds: index].
	self insert: newObject before: firstIndex + index - 1.
	^ newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'sma 5/12/2000 11:26'!
addAll: aCollection 
	"Add each element of aCollection at my end. Answer	aCollection."

	^ self addAllLast: aCollection! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
addAllFirst: anOrderedCollection 
	"Add each element of anOrderedCollection at the beginning of the 
	receiver. Answer anOrderedCollection."

	anOrderedCollection reverseDo: [:each | self addFirst: each].
	^anOrderedCollection! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'sw 3/1/2001 11:03'!
addAllFirstUnlessAlreadyPresent: anOrderedCollection 
	"Add each element of anOrderedCollection at the beginning of the receiver, preserving the order, but do not add any items that are already in the receiver.  Answer anOrderedCollection."

	anOrderedCollection reverseDo:
		[:each | (self includes: each) ifFalse: [self addFirst: each]].
	^ anOrderedCollection! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'StephaneDucasse 12/25/2009 12:13'!
addAllLast: aCollection 
	"Add each element of aCollection at the end of the receiver. 
	Answer aCollection."

	aCollection do: [:each | self addLast: each].
	^aCollection! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
addFirst: newObject 
	"Add newObject to the beginning of the receiver. Answer newObject."

	firstIndex = 1 ifTrue: [self makeRoomAtFirst].
	firstIndex := firstIndex - 1.
	array at: firstIndex put: newObject.
	^ newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
addLast: newObject 
	"Add newObject to the end of the receiver. Answer newObject."

	lastIndex = array size ifTrue: [self makeRoomAtLast].
	lastIndex := lastIndex + 1.
	array at: lastIndex put: newObject.
	^ newObject! !

!DOOrderedCollection methodsFor: 'converting' stamp: 'pmaer 4/27/2012 14:00'!
asArray
	^ (DOArray new: self size) replaceFrom: 1 to: self size with: array startingAt: firstIndex.! !

!DOOrderedCollection methodsFor: 'converting' stamp: 'pmaer 5/7/2012 00:35'!
asDOArray
	^ (DOArray new: self size) replaceFrom: 1 to: self size with: array startingAt: firstIndex.! !

!DOOrderedCollection methodsFor: 'accessing' stamp: 'CamilloBruni 4/11/2011 15:36'!
at: anInteger 
	"Answer my element at index anInteger. at: is used by a knowledgeable
	client to access an existing element"

	self ensureBoundsFrom: anInteger to: anInteger.
	^ array at: anInteger + firstIndex - 1! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'ajh 5/22/2003 12:03'!
at: index ifAbsentPut: block
	"Return value at index, however, if value does not exist (nil or out of bounds) then add block's value at index (growing self if necessary)"

	| v |
	index <= self size ifTrue: [
		^ (v := self at: index)
			ifNotNil: [v]
			ifNil: [self at: index put: block value]
	].
	[self size < index] whileTrue: [self add: nil].
	^ self at: index put: block value! !

!DOOrderedCollection methodsFor: 'accessing' stamp: 'CamilloBruni 4/11/2011 15:39'!
at: anInteger put: anObject 
	"Put anObject at element index anInteger. at:put: cannot be used to
	append, front or back, to an ordered collection; it is used by a
	knowledgeable client to replace an element."
	self ensureBoundsFrom: anInteger to: anInteger.
	^array at: anInteger + firstIndex - 1 put: anObject! !

!DOOrderedCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:42'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'sma 2/5/2000 15:22'!
collect: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect the 
	resulting values into a collection that is like me. Answer the new 
	collection. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (aBlock value: (array at: index))].
	^ newCollection! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'CamilloBruni 4/11/2011 15:34'!
collect: aBlock from: fromIndex to: toIndex
	"Override superclass in order to use addLast:, not at:put:."
	| result |
	self ensureBoundsFrom: fromIndex to: toIndex.
	result := self species new: toIndex - fromIndex + 1.
	firstIndex + fromIndex - 1 to: firstIndex + toIndex - 1 do:
		[:index | result addLast: (aBlock value: (array at: index))].
	^ result
! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'hfm 2/12/2009 13:28'!
collect: collectBlock thenSelect: selectBlock
    " Utility method to improve readability.
	Do not create the intermediate collection."

    | newCollection |

    newCollection := self copyEmpty.
    firstIndex to: lastIndex do:[: index | 
		| newElement |
		newElement := collectBlock value: ( array at: index ).
		( selectBlock value: newElement ) 
			ifTrue:[ newCollection addLast: newElement. ]
    ].
    ^ newCollection! !

!DOOrderedCollection methodsFor: 'private' stamp: ''!
collector  "Private"
	^ array! !

!DOOrderedCollection methodsFor: 'copying' stamp: ''!
copyEmpty
	"Answer a copy of the receiver that contains no elements."

	^self species new! !

!DOOrderedCollection methodsFor: 'copying' stamp: 'nice 10/5/2009 10:18'!
copyFrom: startIndex to: endIndex 
	"Answer a copy of the receiver that contains elements from position
	startIndex to endIndex."

	^self shallowCopy postCopyFrom: startIndex to: endIndex! !

!DOOrderedCollection methodsFor: 'copying' stamp: ''!
copyReplaceFrom: start to: stop with: replacementCollection 
	"Answer a copy of the receiver with replacementCollection's elements in
	place of the receiver's start'th to stop'th elements. This does not expect
	a 1-1 map from replacementCollection to the start to stop elements, so it
	will do an insert or append."

	| newOrderedCollection delta startIndex stopIndex |
	"if start is less than 1, ignore stop and assume this is inserting at the front. 
	if start greater than self size, ignore stop and assume this is appending. 
	otherwise, it is replacing part of me and start and stop have to be within my 
	bounds. "
	delta := 0.
	startIndex := start.
	stopIndex := stop.
	start < 1
		ifTrue: [startIndex := stopIndex := 0]
		ifFalse: [startIndex > self size
				ifTrue: [startIndex := stopIndex := self size + 1]
				ifFalse: 
					[(stopIndex < (startIndex - 1) or: [stopIndex > self size])
						ifTrue: [self errorOutOfBounds].
					delta := stopIndex - startIndex + 1]].
	newOrderedCollection := 
		self species new: self size + replacementCollection size - delta.
	1 to: startIndex - 1 do: [:index | newOrderedCollection add: (self at: index)].
	1 to: replacementCollection size do: 
		[:index | newOrderedCollection add: (replacementCollection at: index)].
	stopIndex + 1 to: self size do: [:index | newOrderedCollection add: (self at: index)].
	^newOrderedCollection! !

!DOOrderedCollection methodsFor: 'copying' stamp: ''!
copyWith: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver and 
	includes the argument, newElement, at the end."

	| newCollection |
	newCollection := self copy.
	newCollection add: newElement.
	^newCollection! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: ''!
do: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[aBlock value: (array at: index).
			index := index + 1]! !

!DOOrderedCollection methodsFor: 'testing' stamp: 'CamilloBruni 4/11/2011 15:34'!
ensureBoundsFrom: fromIndex to: toIndex
	(fromIndex < 1)
		ifTrue: [^self errorSubscriptBounds: fromIndex].
	(toIndex + firstIndex - 1 > lastIndex)
		ifTrue: [^self errorSubscriptBounds: toIndex].! !

!DOOrderedCollection methodsFor: 'private' stamp: ''!
errorConditionNotSatisfied

	self error: 'no element satisfies condition'! !

!DOOrderedCollection methodsFor: 'private' stamp: 'BG 1/9/2004 12:26'!
find: oldObject
  "  This method answers an index in the range firstIndex .. lastIndex, which is meant for internal use only.
     Never use this method in your code, the methods for public use are:
        #indexOf:
        #indexOf:ifAbsent: "

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue:
			[(array at: index) = oldObject ifTrue: [^ index].
			index := index + 1].
	self errorNotFound: oldObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'MarcusDenker 8/8/2011 17:47'!
grow
	"Become larger. Typically, a subclass has to override this if the subclass
	adds instance variables."
	| newArray |
	newArray :=  self class arrayType new: self size + self growSize.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!DOOrderedCollection methodsFor: 'private' stamp: 'cmm 10/25/2010 22:27'!
growAtFirst
	"Add new empty slots to the front of array, while keeping the empty slots at the end."

	| newArray newFirstIndex newLastIndex |
	newArray := self class arrayType new: (array size * 2 max: 1).
	newFirstIndex := newArray size - array size + firstIndex.
	newLastIndex := newFirstIndex + lastIndex - firstIndex.
	newArray 
		replaceFrom: newFirstIndex
		to: newLastIndex
		with: array
		startingAt: firstIndex.
	array := newArray.
	firstIndex := newFirstIndex.
	lastIndex := newLastIndex! !

!DOOrderedCollection methodsFor: 'private' stamp: 'cmm 10/25/2010 22:27'!
growAtLast
	"Add new empty slots to the end of array, while keeping the empty slots at the front."

	| newArray |
	newArray := self class arrayType new: (array size * 2 max: 1).
	newArray 
		replaceFrom: firstIndex
		to: lastIndex
		with: array
		startingAt: firstIndex.
	array := newArray! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
growSize
	^ array size max: 2! !

!DOOrderedCollection methodsFor: 'testing' stamp: 'md 8/13/2008 21:40'!
hasContentsInExplorer

	^self notEmpty! !

!DOOrderedCollection methodsFor: 'private' stamp: 'BG 1/9/2004 12:29'!
insert: anObject before: spot

  "  spot is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection. 
     Never use this method in your code, it is meant for private use by OrderedCollection only.
     The methods for use are:
        #add:before:   to insert an object before another object
        #add:beforeIndex:   to insert an object before a given position. "
	| "index" delta spotIndex|
	spotIndex := spot.
	delta := spotIndex - firstIndex.
	firstIndex = 1
		ifTrue: 
			[self makeRoomAtFirst.
			spotIndex := firstIndex + delta].
	firstIndex := firstIndex - 1.
	array
		replaceFrom: firstIndex
		to: spotIndex - 2
		with: array
		startingAt: firstIndex + 1.
	array at: spotIndex - 1 put: anObject.
"	index := firstIndex := firstIndex - 1.
	[index < (spotIndex - 1)]
		whileTrue: 
			[array at: index put: (array at: index + 1).
			index := index + 1].
	array at: index put: anObject."
	^ anObject! !

!DOOrderedCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/12/2009 19:44'!
join: aCollection 
	| result |
	result := self class new.
	aCollection
		do: [:each | each appendTo: result]
		separatedBy: [self appendTo: result].
	^ result! !

!DOOrderedCollection methodsFor: 'private' stamp: ''!
makeRoomAtFirst
	| delta index |
	delta := array size - self size.
	delta = 0 ifTrue: 
			[self grow.
			delta := array size - self size].
	lastIndex = array size ifTrue: [^ self]. "just in case we got lucky"
	index := array size.
	[index > delta]
		whileTrue: 
			[array at: index put: (array at: index - delta + firstIndex - 1).
			array at: index - delta + firstIndex - 1 put: nil.
			index := index - 1].
	firstIndex := delta + 1.
	lastIndex := array size! !

!DOOrderedCollection methodsFor: 'private' stamp: ''!
makeRoomAtLast
	| newLast delta |
	newLast := self size.
	array size - self size = 0 ifTrue: [self grow].
	(delta := firstIndex - 1) = 0 ifTrue: [^ self].
	"we might be here under false premises or grow did the job for us"
	1 to: newLast do:
		[:index |
		array at: index put: (array at: index + delta).
		array at: index + delta put: nil].
	firstIndex := 1.
	lastIndex := newLast! !

!DOOrderedCollection methodsFor: 'sorting' stamp: 'jannik.laval 5/1/2010 16:20'!
mergeSortFrom: startIndex to: stopIndex by: aBlock
	"Sort the given range of indices using the mergesort algorithm.
	Mergesort is a worst-case O(N log N) sorting algorithm that usually
	does only half as many comparisons as heapsort or quicksort."

	"Details: recursively split the range to be sorted into two halves,
	mergesort each half, then merge the two halves together. An extra 
	copy of the data is used as temporary storage and successive merge 
	phases copy data back and forth between the receiver and this copy.
	The recursion is set up so that the final merge is performed into the
	receiver, resulting in the receiver being completely sorted."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	startIndex = stopIndex ifTrue: [^ self].
	[startIndex >= 1 and: [startIndex < stopIndex]] assert. "bad start index"
	[stopIndex <= self size] assert. "bad stop index"
	self
		mergeSortFrom: startIndex
		to: stopIndex 
		src: self copy 
		dst: self 
		by: aBlock! !

!DOOrderedCollection methodsFor: 'copying' stamp: 'nice 10/5/2009 08:50'!
postCopy
	array := array copy! !

!DOOrderedCollection methodsFor: 'copying' stamp: 'nice 5/28/2008 21:02'!
postCopyFrom: startIndex to: endIndex 
	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!DOOrderedCollection methodsFor: 'removing' stamp: ''!
remove: oldObject ifAbsent: absentBlock

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[oldObject = (array at: index)
				ifTrue: 
					[self removeIndex: index.
					^ oldObject]
				ifFalse: [index := index + 1]].
	^ absentBlock value! !

!DOOrderedCollection methodsFor: 'removing' stamp: 'cmm 10/25/2010 22:26'!
removeAll
	"remove all the elements from this collection.
	Keep same amount of storage"
	
	self setCollection: (self class arrayType new: array size)! !

!DOOrderedCollection methodsFor: 'removing' stamp: 'StephaneDucasse 10/18/2010 14:51'!
removeAllSuchThat: aBlock 
	"Remove each element of the receiver for which aBlock evaluates to true.
	The method in Collection is O(N^2), this is O(N)."

	| n |
	n := firstIndex.
	firstIndex to: lastIndex do: [:index |
	    (aBlock value: (array at: index)) ifFalse: [
			array at: n put: (array at: index).
			n := n + 1]].
	array from: n to: lastIndex put: nil.
	lastIndex := n - 1! !

!DOOrderedCollection methodsFor: 'removing' stamp: 'ar 5/22/2000 12:19'!
removeAt: index
	| removed |
	removed := self at: index.
	self removeIndex: index + firstIndex - 1.
	^removed! !

!DOOrderedCollection methodsFor: 'removing' stamp: ''!
removeFirst
	"Remove the first element of the receiver and answer it. If the receiver is 
	empty, create an error notification."
	| firstObject |
	self emptyCheck.
	firstObject := array at: firstIndex.
	array at: firstIndex put: nil.
	firstIndex := firstIndex + 1.
	^ firstObject! !

!DOOrderedCollection methodsFor: 'removing' stamp: 'cmm 10/25/2010 22:26'!
removeFirst: n 
	"Remove first n object into an array"
	| list |
	list := self class arrayType new: n.
	1
		to: n
		do:
			[ : i | list
				at: i
				put: self removeFirst ].
	^ list! !

!DOOrderedCollection methodsFor: 'private' stamp: 'BG 1/9/2004 12:28'!
removeIndex: removedIndex
  "  removedIndex is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection.
    Never use this method in your code, it is meant for private use by OrderedCollection only.
     The method for public use is:
        #removeAt: "

	array 
		replaceFrom: removedIndex 
		to: lastIndex - 1 
		with: array 
		startingAt: removedIndex+1.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.! !

!DOOrderedCollection methodsFor: 'removing' stamp: ''!
removeLast
	"Remove the last element of the receiver and answer it. If the receiver is 
	empty, create an error notification."
	| lastObject |
	self emptyCheck.
	lastObject := array at: lastIndex.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.
	^ lastObject! !

!DOOrderedCollection methodsFor: 'removing' stamp: 'cmm 10/25/2010 22:26'!
removeLast: n 
	"Remove last n object into an array with last in last position"
	| list |
	list := self class arrayType new: n.
	n
		to: 1
		by: -1
		do:
			[ : i | list
				at: i
				put: self removeLast ].
	^ list! !

!DOOrderedCollection methodsFor: 'private' stamp: 'di 11/14/97 12:54'!
reset
	firstIndex := array size // 3 max: 1.
	lastIndex := firstIndex - 1! !

!DOOrderedCollection methodsFor: 'private' stamp: 'ar 4/16/1999 07:59'!
resetTo: index
	firstIndex := index.
	lastIndex := firstIndex - 1! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: ''!
reverseDo: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := lastIndex.
	[index >= firstIndex]
		whileTrue: 
			[aBlock value: (array at: index).
			index := index - 1]! !

!DOOrderedCollection methodsFor: 'copying' stamp: 'sw 1/26/96'!
reversed
	"Answer a copy of the receiver with element order reversed.  "
	| newCol |
	newCol := self species new.
	self reverseDo:
		[:elem | newCol addLast: elem].
	^ newCol

"#(2 3 4 'fred') reversed"! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'sma 2/5/2000 15:13'!
select: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect into
	a new collection like the receiver, only those elements for which aBlock
	evaluates to true."

	| newCollection element |
	newCollection := self copyEmpty.
	firstIndex to: lastIndex do:
		[:index |
		(aBlock value: (element := array at: index))
			ifTrue: [newCollection addLast: element]].
	^ newCollection! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'hfm 2/12/2009 13:30'!
select: selectBlock thenCollect: collectBlock
    " Utility method to improve readability.
	Do not create the intermediate collection. "

	| newCollection |

    newCollection := self copyEmpty.
    firstIndex to: lastIndex do:[:index |
		| element |
		element := array at: index.
		( selectBlock value: element ) 
			ifTrue:[ newCollection addLast: ( collectBlock value: element ) ]
    ].
    ^ newCollection! !

!DOOrderedCollection methodsFor: 'private' stamp: 'di 11/14/97 12:54'!
setCollection: anArray
	array := anArray.
	self reset! !

!DOOrderedCollection methodsFor: 'private' stamp: 'apb 10/15/2000 18:10'!
setContents: anArray
	array := anArray.
	firstIndex := 1.
	lastIndex := array size.! !

!DOOrderedCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:39'!
size
	"Answer how many elements the receiver contains."

	^ lastIndex - firstIndex + 1! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 12/23/2009 21:28'!
sort
	"Sort the receiver into ascending order using the '<=' operator."

	self sort: [:a :b | a <= b]! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'pmm 3/13/2010 11:33'!
sort: aSortBlock 
	"Sort this array using aSortBlock. The block should take two arguments
	and return true if the first element should preceed the second one."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	array
		mergeSortFrom: firstIndex
		to: lastIndex 
		src: array shallowCopy 
		dst: array 
		by: aSortBlock! !

!DOOrderedCollection methodsFor: 'sorting' stamp: 'StephaneDucasse 3/28/2010 22:40'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if the first element should preceed the second one. If aSortBlock is nil then <= is used for comparison."
	
	^self copy sort: aSortBlockOrNil! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'di 8/31/1999 13:13'!
with: otherCollection collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with 
	corresponding elements from this collection and otherCollection."
	| result |
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	result := self species new: self size.
	1 to: self size do:
		[:index | result addLast: (twoArgBlock value: (self at: index)
									value: (otherCollection at: index))].
	^ result! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'bf 5/16/2000 16:30'!
withIndexCollect: elementAndIndexBlock 
	"Just like with:collect: except that the iteration index supplies the second argument to the block. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (elementAndIndexBlock
			value: (array at: index)
			value: index - firstIndex + 1)].
	^ newCollection! !

!DOSequenceableCollection class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/23/2012 15:23'!
compilerClass
	^OwnershipCompiler3 ! !

!DOSequenceableCollection class methodsFor: 'stream creation' stamp: 'ul 9/12/2009 17:29'!
new: newSize streamContents: blockWithArg

	| stream |
	stream := WriteStream on: (self new: newSize).
	blockWithArg value: stream.
	stream position = newSize
		ifTrue: [ ^stream originalContents ]
		ifFalse: [ ^stream contents ]! !

!DOSequenceableCollection class methodsFor: 'instance creation' stamp: 'MarcusDenker 12/7/2009 14:55'!
ofSize: n
	"Create a new collection of size n with nil as its elements.
	This method exists because OrderedCollection new: n creates an
	empty collection,  not one of size n."
	^ self new: n! !

!DOSequenceableCollection class methodsFor: 'stream creation' stamp: 'StephaneDucasse 12/25/2009 12:32'!
streamContents: blockWithArg

	^self new: 100 streamContents: blockWithArg! !

!DOSequenceableCollection class methodsFor: 'stream creation' stamp: 'di 6/20/97 09:07'!
streamContents: blockWithArg limitedTo: sizeLimit
	| stream |
	stream := LimitedWriteStream on: (self new: (100 min: sizeLimit)).
	stream setLimit: sizeLimit limitBlock: [^ stream contents].
	blockWithArg value: stream.
	^ stream contents
"
String streamContents: [:s | 1000 timesRepeat: [s nextPutAll: 'Junk']] limitedTo: 25
 'JunkJunkJunkJunkJunkJunkJ'
"! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'md 7/14/2006 12:11'!
, otherCollection 
	"Concatenate two Strings or Collections."
	
	^ self copyReplaceFrom: self size + 1
		  to: self size
		  with: otherCollection
"
#(2 4 6 8) , #(who do we appreciate)
((2989 storeStringBase: 16) copyFrom: 4 to: 6) , ' boy!!'
"! !

!DOSequenceableCollection methodsFor: 'comparing' stamp: 'sma 5/12/2000 14:04'!
= otherCollection 
	"Answer true if the receiver is equivalent to the otherCollection.
	First test for identity, then rule out different species and sizes of
	collections. As a last resort, examine each element of the receiver
	and the otherCollection."

	self == otherCollection ifTrue: [^ true].
	self species == otherCollection species ifFalse: [^ false].
	^ self hasEqualElements: otherCollection! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'TAG 11/6/1998 15:55'!
@ aCollection 
	^ self with: aCollection collect: [:a :b | a @ b]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 18:00'!
after: target
	"Answer the element after target.  Raise an error if target is not
	in the receiver, or if there are no elements after it."

	^ self after: target ifAbsent: [self errorNotFound: target]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 4/19/2011 00:07'!
after: target ifAbsent: exceptionBlock
	"Answer the element after target.  Answer the result of evaluation
	the exceptionBlock if target is not in the receiver, or if there are 
	no elements after it."

	| index |
	index := self indexOf: target.
	^ (index = 0 or: [index = self size])
		ifTrue: [exceptionBlock value]
		ifFalse: [self at: index + 1]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:34'!
allButFirst
	"Answer a copy of the receiver containing all but the first
	element. Raise an error if there are not enough elements."

	^ self allButFirst: 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:35'!
allButFirst: n
	"Answer a copy of the receiver containing all but the first n
	elements. Raise an error if there are not enough elements."

	^ self copyFrom: n + 1 to: self size! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 15:03'!
allButFirstDo: block

	2 to: self size do:
		[:index | block value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:35'!
allButLast
	"Answer a copy of the receiver containing all but the last
	element. Raise an error if there are not enough elements."

	^ self allButLast: 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:35'!
allButLast: n
	"Answer a copy of the receiver containing all but the last n
	elements. Raise an error if there are not enough elements."

	^ self copyFrom: 1 to: self size - n! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 15:01'!
allButLastDo: block

	1 to: self size - 1 do:
		[:index | block value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 1/13/2010 22:02'!
allPairsDo: aBinaryBlock
	"
	Iterate over all the pairs of the receiver and apply the binaryBlock
	to each pair. 
	
	| res | 
	res := OrderedCollection new. 
	#(0 1 2 3) allPairsDo: [:first :second | res add: {first . second} ].
	res 
	 an OrderedCollection(#(0 0) #(0 1) #(0 2) #(0 3) #(1 0) #(1 1) #(1 2) #(1 3) #(2 0) #(2 1) #(2 2) #(2 3) #(3 0) #(3 1) #(3 2) #(3 3))
	"
	
	self do: [:first| self do: [:second| aBinaryBlock value: first value: second]]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:33'!
anyOne
	^ self first! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/12/2009 19:58'!
appendTo: aCollection
	"double dispatch for join:"
	^ aCollection addAllLast: self! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'pmaer 4/27/2012 14:00'!
asArray
	"Answer an Array whose elements are the elements of the receiver."

	^ DOArray withAll: self! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'sma 5/12/2000 17:36'!
asByteArray
	"Answer a ByteArray whose elements are the elements of the receiver."

	^ ByteArray withAll: self! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'tk 7/30/97 12:42'!
asDigitsAt: anInteger in: aCollection do: aBlock
	"(0 to: 1) asDigitsToPower: 4 do: [:each | Transcript cr; show: each printString]"

	self do: 
		[:each | 
		aCollection at: anInteger put: each.
		anInteger = aCollection size 
			ifTrue: [aBlock value: aCollection]
			ifFalse: [self asDigitsAt: anInteger + 1 in: aCollection do: aBlock]].! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'pmaer 4/27/2012 14:00'!
asDigitsToPower: anInteger do: aBlock
	"Repeatedly value aBlock with a single Array.  Adjust the collection
	so that aBlock is presented all (self size raisedTo: anInteger) possible 
	combinations of the receiver's elements taken as digits of an anInteger long number."
	"(0 to: 1) asDigitsToPower: 4 do: [:each | Transcript cr; show: each printString]"

	| aCollection |
	aCollection := DOArray new: anInteger.
	self asDigitsAt: 1 in: aCollection do: aBlock! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'ar 9/14/1998 23:47'!
asFloatArray
	"Answer a FloatArray whose elements are the elements of the receiver, in 
	the same order."

	| floatArray |
	floatArray := FloatArray new: self size.
	1 to: self size do:[:i| floatArray at: i put: (self at: i) asFloat ].
	^floatArray! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'ar 10/10/1998 16:19'!
asIntegerArray
	"Answer an IntegerArray whose elements are the elements of the receiver, in 
	the same order."

	| intArray |
	intArray := IntegerArray new: self size.
	1 to: self size do:[:i| intArray at: i put: (self at: i)].
	^intArray! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'PeterHugossonMiller 9/3/2009 11:11'!
asStringWithCr
	"Convert to a string with returns between items.  Elements are
usually strings.
	 Useful for labels for PopUpMenus."
	| labelStream |
	labelStream := (String new: 200) writeStream.
	self do: [:each |
		each isString
			ifTrue: [labelStream nextPutAll: each; cr]
			ifFalse: [each printOn: labelStream. labelStream cr]].
	self size > 0 ifTrue: [labelStream skip: -1].
	^ labelStream contents! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'ar 10/10/1998 16:20'!
asWordArray
	"Answer a WordArray whose elements are the elements of the receiver, in 
	the same order."

	| wordArray |
	wordArray := WordArray new: self size.
	1 to: self size do:[:i| wordArray at: i put: (self at: i)].
	^wordArray! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 12:11'!
at: index ifAbsent: exceptionBlock 
	"Answer the element at my position index. If I do not contain an element 
	at index, answer the result of evaluating the argument, exceptionBlock."

	(index between: 1 and: self size) ifTrue: [^ self at: index].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'raok 11/22/2002 12:34'!
at: index incrementBy: value
	^self at: index put: (self at: index) + value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'apb 11/4/2000 22:51'!
atAll: indexArray
	"Answer a new collection like the receiver which contains all elements
	of the receiver at the indices of indexArray."
	"#('one' 'two' 'three' 'four') atAll: #(3 2 4)"

	| newCollection |
	newCollection := self species ofSize: indexArray size.
	1 to: indexArray size do:
		[:index |
		newCollection at: index put: (self at: (indexArray at: index))].
	^ newCollection! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 12:17'!
atAll: aCollection put: anObject 
	"Put anObject at every index specified by the elements of aCollection."

	aCollection do: [:index | self at: index put: anObject].
	^ anObject! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 12:18'!
atAll: indexArray putAll: valueArray
	"Store the elements of valueArray into the slots
	of this collection selected by indexArray."

	indexArray with: valueArray do: [:index :value | self at: index put: value].
	^ valueArray! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 4/22/2000 17:45'!
atAllPut: anObject 
	"Put anObject at every one of the receiver's indices."

	| size |
	(size := self size) > 26 "first method faster from 27 accesses and on"
		ifTrue: [self from: 1 to: size put: anObject]
		ifFalse: [1 to: size do: [:index | self at: index put: anObject]]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nk 6/12/2004 17:06'!
atLast: indexFromEnd
	"Return element at indexFromEnd from the last position.
	 atLast: 1, returns the last element"

	^ self atLast: indexFromEnd ifAbsent: [self error: 'index out of range']! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ajh 6/27/2002 17:52'!
atLast: indexFromEnd ifAbsent: block
	"Return element at indexFromEnd from the last position.
	 atLast: 1 ifAbsent: [] returns the last element"

	^ self at: self size + 1 - indexFromEnd ifAbsent: block! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ajh 6/27/2002 18:10'!
atLast: indexFromEnd put: obj
	"Set the element at indexFromEnd from the last position.
	 atLast: 1 put: obj, sets the last element"

	^ self at: self size + 1 - indexFromEnd put: obj! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'di 11/6/1998 14:32'!
atPin: index 
	"Return the index'th element of me if possible.
	Return the first or last element if index is out of bounds."

	index < 1 ifTrue: [^ self first].
	index > self size ifTrue: [^ self last].
	^ self at: index! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 12:50'!
atRandom: aGenerator
	"Answer a random element of the receiver.  Uses aGenerator which
	should be kept by the user in a variable and used every time. Use
	this instead of #atRandom for better uniformity of random numbers 
	because only you use the generator.  Causes an error if self has no 
	elements."

	^ self at: (aGenerator nextInt: self size)! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 13:51'!
atWrap: index 
	"Answer the index'th element of the receiver.  If index is out of bounds,
	let it wrap around from the end to the beginning until it is in bounds."

	^ self at: index - 1 \\ self size + 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 13:52'!
atWrap: index put: value
	"Store value into the index'th element of the receiver.  If index is out
	of bounds, let it wrap around from the end to the beginning until it 
	is in bounds. Answer value."

	^ self at: index  - 1 \\ self size + 1 put: value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 18:04'!
before: target
	"Answer the receiver's element immediately before target. Raise an
	error if target is not an element of the receiver, or if there are no 
	elements before it (i.e. it is the first element)."

	^ self before: target ifAbsent: [self errorNotFound: target]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'StephaneDucasse 5/28/2011 13:41'!
before: target ifAbsent: exceptionBlock
	"Answer the receiver's element immediately before target. Answer
	the result of evaluating the exceptionBlock if target is not an element
	of the receiver, or if there are no elements before it."

	| index |
	index := self indexOf: target.
	^ (index = 0 or: [index = 1])
		ifTrue: [exceptionBlock value]
		ifFalse: [self at: index - 1]! !

!DOSequenceableCollection methodsFor: 'testing' stamp: 'StephaneDucasse 3/28/2010 21:01'!
beginsWith: aSequenceableCollection
	"Answer true if the receiver starts with the argument collection"
	(aSequenceableCollection isEmpty or: [self size < aSequenceableCollection size]) ifTrue: [^false].
	aSequenceableCollection withIndexDo: [:each :index | (self at: index) ~= each ifTrue: [^false]].
	^true! !

!DOSequenceableCollection methodsFor: 'testing' stamp: 'StephaneDucasse 3/28/2010 21:07'!
beginsWithAnyOf: aCollection
	"Return true if the receiver starts with any of the elements in aCollection."
	^aCollection anySatisfy:[:prefix| self beginsWith: prefix]! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'sma 5/12/2000 13:57'!
checkedAt: index
	index > self size ifTrue: [self error: 'not enough elements'].
	^ self at: index! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:46'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection := self species new: self size.
	1 to: self size do:
		[:index |
		newCollection at: index put: (aBlock value: (self at: index))].
	^ newCollection! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'sma 6/1/2000 11:47'!
collect: aBlock from: firstIndex to: lastIndex
	"Refer to the comment in Collection|collect:."

	| size result j |
	size := lastIndex - firstIndex + 1.
	result := self species new: size.
	j := firstIndex.
	1 to: size do: [:i | result at: i put: (aBlock value: (self at: j)). j := j + 1].
	^ result! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 7/13/97 09:44'!
collectWithIndex: elementAndIndexBlock
	"Use the new version with consistent naming"
	^ self withIndexCollect: elementAndIndexBlock! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'pmaer 4/27/2012 14:00'!
combinations: kk atATimeDo: aBlock
	"Take the items in the receiver, kk at a time, and evaluate the block for each combination.  Hand in an array of elements of self as the block argument.  Each combination only occurs once, and order of the elements does not matter.  There are (self size take: kk) combinations."
	" 'abcde' combinations: 3 atATimeDo: [:each | Transcript cr; show: each printString]"

	| aCollection |
	aCollection := DOArray new: kk.
	self combinationsAt: 1 in: aCollection after: 0 do: aBlock! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'tk 7/30/97 12:42'!
combinationsAt: jj in: aCollection after: nn do: aBlock
	"Choose k of N items and put in aCollection.  jj-1 already chosen.  Indexes of items are in numerical order, to avoid the same combo being used twice.  In this slot, we are allowed to use items in self indexed by nn+1 to self size.  nn is the index used for position jj-1."
	"(1 to: 6) combinationsSize: 3 do: [:each | Transcript cr; show: each printString]"

nn+1 to: self size do: [:index | 
		aCollection at: jj put: (self at: index).
		jj = aCollection size 
			ifTrue: [aBlock value: aCollection]
			ifFalse: [self combinationsAt: jj + 1 in: aCollection after: index do: aBlock]].! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'pmaer 4/27/2012 14:00'!
concatenation
	|result index|

	result := DOArray new: (self inject: 0 into: [:sum :each | sum + each size]).
	index := 0.
	self do: [:each | each do: [:item | result at: (index := index+1) put: item]].
	^result! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:05'!
copyAfter: anElement
	"Answer a copy of the receiver from after the first occurence
	of anElement up to the end. If no such element exists, answer 
	an empty copy."

	^ self allButFirst: (self indexOf: anElement ifAbsent: [^ self copyEmpty])! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:05'!
copyAfterLast: anElement
	"Answer a copy of the receiver from after the last occurence
	of anElement up to the end. If no such element exists, answer 
	an empty copy."

	^ self allButFirst: (self lastIndexOf: anElement ifAbsent: [^ self copyEmpty])! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:07'!
copyEmpty
	^ self species new: 0! !

!DOSequenceableCollection methodsFor: 'copying' stamp: ''!
copyFrom: start to: stop 
	"Answer a copy of a subset of the receiver, starting from element at 
	index start until element at index stop."

	| newSize |
	newSize := stop - start + 1.
	^(self species new: newSize)
		replaceFrom: 1
		to: newSize
		with: self
		startingAt: start! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:06'!
copyLast: num
	"Deprecated. Use #last:"

	^ self last: num! !

!DOSequenceableCollection methodsFor: 'copying' stamp: ''!
copyReplaceAll: oldSubstring with: newSubstring 
	"Default is not to do token matching.
	See also String copyReplaceTokens:with:"
	^ self copyReplaceAll: oldSubstring with: newSubstring asTokens: false
	"'How now brown cow?' copyReplaceAll: 'ow' with: 'ello'"
	"'File asFile Files File''s File' copyReplaceTokens: 'File' with: 'Pile'"! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'yo 9/2/2002 18:22'!
copyReplaceAll: oldSubstring with: newSubstring asTokens: ifTokens
	"Answer a copy of the receiver in which all occurrences of
	oldSubstring have been replaced by newSubstring.
	ifTokens (valid for Strings only) specifies that the characters
	surrounding the recplacement must not be alphanumeric.
		Bruce Simth,  must be incremented by 1 and not 
	newSubstring if ifTokens is true.  See example below. "

	| aString startSearch currentIndex endIndex |
	(ifTokens and: [(self isString) not])
		ifTrue: [(self isKindOf: Text) ifFalse: [
			self error: 'Token replacement only valid for Strings']].
	aString := self.
	startSearch := 1.
	[(currentIndex := aString indexOfSubCollection: oldSubstring startingAt: startSearch)
			 > 0]
		whileTrue: 
		[endIndex := currentIndex + oldSubstring size - 1.
		(ifTokens not
			or: [(currentIndex = 1
					or: [(aString at: currentIndex-1) isAlphaNumeric not])
				and: [endIndex = aString size
					or: [(aString at: endIndex+1) isAlphaNumeric not]]])
			ifTrue: [aString := aString
					copyReplaceFrom: currentIndex
					to: endIndex
					with: newSubstring.
				startSearch := currentIndex + newSubstring size]
			ifFalse: [
				ifTokens 
					ifTrue: [startSearch := currentIndex + 1]
					ifFalse: [startSearch := currentIndex + newSubstring size]]].
	^ aString

"Test case:
	'test te string' copyReplaceAll: 'te' with: 'longone' asTokens: true   "
! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'ar 10/16/2001 19:03'!
copyReplaceFrom: start to: stop with: replacementCollection 
	"Answer a copy of the receiver satisfying the following conditions: If 
	stop is less than start, then this is an insertion; stop should be exactly 
	start-1, start = 1 means insert before the first character, start = size+1 
	means append after last character. Otherwise, this is a replacement; start 
	and stop have to be within the receiver's bounds."

	| newSequenceableCollection newSize endReplacement |
	newSize := self size - (stop - start + 1) + replacementCollection size.
	endReplacement := start - 1 + replacementCollection size.
	newSequenceableCollection := self species new: newSize.
	start > 1 ifTrue:[
		newSequenceableCollection
			replaceFrom: 1
			to: start - 1
			with: self
			startingAt: 1].
	start <= endReplacement ifTrue:[
		newSequenceableCollection
			replaceFrom: start
			to: endReplacement
			with: replacementCollection
			startingAt: 1].
	endReplacement < newSize ifTrue:[
		newSequenceableCollection
			replaceFrom: endReplacement + 1
			to: newSize
			with: self
			startingAt: stop + 1].
	^newSequenceableCollection! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'MarcusDenker 12/20/2010 16:00'!
copyUpThrough: anElement
    "Answer all elements up to and including anObject. If there
     is no such object, answer a copy of the receiver."

	^self first: (self indexOf: anElement ifAbsent: [^ self copy])! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:00'!
copyUpTo: anElement 
	"Answer all elements up to but not including anObject. If there
	is no such object, answer a copy of the receiver."

	^ self first: (self indexOf: anElement ifAbsent: [^ self copy]) - 1! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:02'!
copyUpToLast: anElement
	"Answer a copy of the receiver from index 1 to the last occurrence of 
	anElement, not including anElement."

	^ self first: (self lastIndexOf: anElement ifAbsent: [^ self copy]) - 1! !

!DOSequenceableCollection methodsFor: 'copying' stamp: ''!
copyWith: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver and has 
	newElement at the last element."

	| newIC |
	newIC := self species new: self size + 1.
	newIC 
		replaceFrom: 1
		to: self size
		with: self
		startingAt: 1.
	newIC at: newIC size put: newElement.
	^newIC! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'ajh 9/27/2002 12:09'!
copyWithFirst: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver with newElement as the first element."

	| newIC |
	newIC := self species ofSize: self size + 1.
	newIC 
		replaceFrom: 2
		to: self size + 1
		with: self
		startingAt: 1.
	newIC at: 1 put: newElement.
	^ newIC! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 15:38'!
copyWithoutFirst
	"Deprecatd. Return a copy of the receiver which doesn't include
	the first element."

	^ self allButFirst! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'rhi 12/6/2001 14:04'!
copyWithoutIndex: index
	"Return a copy containing all elements except the index-th."

	| copy |
	copy := self species ofSize: self size - 1.
	copy replaceFrom: 1 to: index-1 with: self startingAt: 1.
	copy replaceFrom: index to: copy size with: self startingAt: index+1.
	^ copy! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: ''!
do: aBlock 
	"Refer to the comment in Collection|do:."
	1 to: self size do:
		[:index | aBlock value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:56'!
do: elementBlock separatedBy: separatorBlock
	"Evaluate the elementBlock for all elements in the receiver,
	and evaluate the separatorBlock between."

	1 to: self size do:
		[:index |
		index = 1 ifFalse: [separatorBlock value].
		elementBlock value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ar 5/1/1999 05:01'!
do: aBlock without: anItem
	"Enumerate all elements in the receiver.
	Execute aBlock for those elements that are not equal to the given item"
	"Refer to the comment in Collection|do:."
	1 to: self size do:
		[:index | anItem = (self at: index) ifFalse:[aBlock value: (self at: index)]]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 7/13/97 09:43'!
doWithIndex: elementAndIndexBlock
	"Use the new version with consistent naming"
	^ self withIndexDo: elementAndIndexBlock! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
eighth
	"Answer the eighth element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 8! !

!DOSequenceableCollection methodsFor: 'testing' stamp: 'StephaneDucasse 3/28/2010 21:01'!
endsWith: aSequenceableCollection
	"Answer true if the receiver ends with the argument collection"
	
	| start |
	(aSequenceableCollection isEmpty or: [self size < aSequenceableCollection size]) ifTrue: [^false].
	start := self size - aSequenceableCollection size.
	aSequenceableCollection withIndexDo: [:each :index | (self at: start + index) ~= each ifTrue: [^false]].
	^true! !

!DOSequenceableCollection methodsFor: 'testing' stamp: 'StephaneDucasse 3/28/2010 21:06'!
endsWithAnyOf: aCollection
	"Return true if the receiver ends with any of the elements in aCollection."
	^aCollection anySatisfy:[:suffix| self endsWith: suffix]! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'sma 5/12/2000 18:06'!
errorFirstObject: anObject
	self error: 'specified object is first object'! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'sma 5/12/2000 18:03'!
errorLastObject: anObject
	self error: 'specified object is last object'! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/21/2011 13:02'!
errorOutOfBounds

	SubscriptOutOfBounds signal! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
fifth
	"Answer the fifth element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 5! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'jmv 5/10/2010 14:05'!
findBinary: aBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If no matching element is found, raise an error.
	Examples:
		#(1 3 5 7 11 15 23) findBinary: [ :arg | 11 - arg ]
	"
	^self findBinary: aBlock do: [ :found | found ] ifNone: [ self errorNotFound: aBlock ]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'JuanVuletich 10/11/2010 20:21'!
findBinary: aBlock do: actionBlock ifNone: exceptionBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If found, evaluate actionBlock with the found element as argument
	If no matching element is found, evaluate exceptionBlock,
	with the  'bounding' elements (or nil) as arguments.
	Examples:
		#(1 3 5 7 11 15 23)
			findBinary: [ :arg | 11 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinary: [ :arg | 12 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinary: [ :arg | 0.5 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinary: [ :arg | 25 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ',{a. b} printString) print]
	"
	^ self
		findBinaryIndex: aBlock
		do: [ :foundIndex |
			actionBlock value: (self at: foundIndex) ]
		ifNone: [ :prevIndex :nextIndex |
			exceptionBlock
				value:
					(prevIndex > 0 ifTrue: [ self at: prevIndex ])
				value:
					(nextIndex <= self size ifTrue: [ self at: nextIndex ]) ].
! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ar 6/3/2000 15:52'!
findBinary: aBlock ifNone: exceptionBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If no matching element is found, evaluate exceptionBlock."
	| index low high test item |
	low := 1.
	high := self size.
	[index := high + low // 2.
	low > high] whileFalse:[
		test := aBlock value: (item := self at: index).
		test = 0 
			ifTrue:[^item]
			ifFalse:[test > 0
				ifTrue: [low := index + 1]
				ifFalse: [high := index - 1]]].
	^exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'jmv 5/10/2010 14:03'!
findBinaryIndex: aBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If no matching element is found, raise an error.
	Examples:
		#(1 3 5 7 11 15 23) findBinaryIndex: [ :arg | 11 - arg ]
	"
	^self findBinaryIndex: aBlock do: [ :found | found ] ifNone: [ self errorNotFound: aBlock]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'JuanVuletich 10/11/2010 20:22'!
findBinaryIndex: aBlock do: actionBlock ifNone: exceptionBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If found, evaluate actionBlock with the index as argument
	If no matching element is found, evaluate exceptionBlock,
	with the indexes of the  'bounding' elements as arguments.
	Warning: Might give invalid indexes, see examples below
	Examples:
		#(1 3 5 7 11 15 23)
			findBinaryIndex: [ :arg | 11 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinaryIndex: [ :arg | 12 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinaryIndex: [ :arg | 0.5 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinaryIndex: [ :arg | 25 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ',{a. b} printString) print]
	"
	| index low high test |
	low := 1.
	high := self size.
	[
		index := high + low // 2.
		low > high ] whileFalse: [
		test := aBlock value: (self at: index).
		test = 0 
			ifTrue: [ ^actionBlock value: index ]
			ifFalse: [ test > 0
				ifTrue: [ low := index + 1 ]
				ifFalse: [ high := index - 1 ]]].
	^exceptionBlock valueWithPossibleArgs: {high. low}! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ar 6/3/2000 15:54'!
findBinaryIndex: aBlock ifNone: exceptionBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If no matching element is found, evaluate exceptionBlock."
	| index low high test |
	low := 1.
	high := self size.
	[index := high + low // 2.
	low > high] whileFalse:[
		test := aBlock value: (self at: index).
		test = 0 
			ifTrue:[^index]
			ifFalse:[test > 0
				ifTrue: [low := index + 1]
				ifFalse: [high := index - 1]]].
	^exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: ''!
findFirst: aBlock
	"Return the index of my first element for which aBlock evaluates as true."

	| index |
	index := 0.
	[(index := index + 1) <= self size] whileTrue:
		[(aBlock value: (self at: index)) ifTrue: [^index]].
	^ 0! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: ''!
findLast: aBlock
	"Return the index of my last element for which aBlock evaluates as true."

	| index |
	index := self size + 1.
	[(index := index - 1) >= 1] whileTrue:
		[(aBlock value: (self at: index)) ifTrue: [^index]].
	^ 0! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'md 1/19/2006 09:57'!
first
	"Answer the first element of the receiver"

	^ self at: 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:31'!
first: n
	"Answer the first n elements of the receiver.
	Raise an error if there are not enough elements."

	^ self copyFrom: 1 to: n! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'nice 2/26/2009 11:48'!
forceTo: length paddingStartWith: elem 
	"Force the length of the collection to length, padding  
	the beginning of the result if necessary with elem.  
	Note that this makes a copy."
	| newCollection padLen |
	newCollection := self species ofSize: length.
	padLen := length - self size max: 0.
	newCollection
		from: 1
		to: padLen
		put: elem.
	newCollection
		replaceFrom: padLen + 1
		to: ((padLen + self size) min: length)
		with: self
		startingAt:  1.
	^ newCollection! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'nice 2/24/2009 11:33'!
forceTo: length paddingWith: elem
	"Force the length of the collection to length, padding
	if necessary with elem.  Note that this makes a copy."

	| newCollection |
	newCollection := self species new: length withAll: elem.
	newCollection replaceFrom: 1 to: (self size min: length) with: self startingAt: 1.
	^ newCollection! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
fourth
	"Answer the fourth element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 4! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 18:11'!
from: start to: stop do: aBlock
	"Evaluate aBlock for all elements between start and stop (inclusive)."

	start to: stop do: [:index | aBlock value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'SqR 10/30/2000 22:06'!
from: startIndex to: endIndex put: anObject
	"Put anObject in all indexes between startIndex 
	and endIndex. Very fast. Faster than to:do: for
	more than 26 positions. Answer anObject"

	| written toWrite thisWrite |

	startIndex > endIndex ifTrue: [^self].
	self at: startIndex put: anObject.
	written := 1.
	toWrite := endIndex - startIndex + 1.
	[written < toWrite] whileTrue:
		[
			thisWrite := written min: toWrite - written.
			self 
				replaceFrom: startIndex + written
				to: startIndex + written + thisWrite - 1
				with: self startingAt: startIndex.
			written := written + thisWrite
		].
	^anObject! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nice 1/5/2010 15:59'!
groupsOf: n atATimeCollect: aBlock 
	"Evaluate aBlock with my elements taken n at a time. Ignore any 
	leftovers at the end. 
	Allows use of a flattened  
	array for things that naturally group into groups of n. 
	If aBlock has a single argument, pass it an array of n items, 
	otherwise, pass the items as separate arguments. 
	See also pairsDo:"
	| passArray |
	passArray := aBlock numArgs = 1.
	^(n
		to: self size
		by: n)
		collect: [:index | | args | 
			args := (self copyFrom: index - n + 1 to: index) asArray.
			passArray
				ifTrue: [aBlock value: args]
				ifFalse: [aBlock valueWithArguments: args]]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nice 1/5/2010 15:59'!
groupsOf: n atATimeDo: aBlock 
	"Evaluate aBlock with my elements taken n at a time. Ignore any leftovers at the end.
	Allows use of a flattened 
	array for things that naturally group into groups of n.
	If aBlock has a single argument, pass it an array of n items,
	otherwise, pass the items as separate arguments.
	See also pairsDo:"
	| passArray |
	passArray := (aBlock numArgs = 1).
	n
		to: self size
		by: n
		do: [:index | | args | 
			args := (self copyFrom: index - n + 1 to: index) asArray.
			passArray ifTrue: [ aBlock value: args ]
				ifFalse: [ aBlock valueWithArguments: args ]].! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'nice 2/26/2009 11:26'!
grownBy: length
	"Answer a copy of receiver collection with size grown by length"

	| newCollection |
	newCollection := self species ofSize: self size + length.
	newCollection replaceFrom: 1 to: self size with: self startingAt: 1.
	^ newCollection! !

!DOSequenceableCollection methodsFor: 'comparing' stamp: 'pmaer 4/27/2012 13:58'!
hasEqualElements: otherCollection
	"Answer whether the receiver's size is the same as otherCollection's
	size, and each of the receiver's elements equal the corresponding 
	element of otherCollection.
	This should probably replace the current definition of #= ."

	| size |
	(otherCollection isKindOf: DOSequenceableCollection) ifFalse: [^ false].
	(size := self size) = otherCollection size ifFalse: [^ false].
	1 to: size do:
		[:index |
		(self at: index) = (otherCollection at: index) ifFalse: [^ false]].
	^ true! !

!DOSequenceableCollection methodsFor: 'comparing' stamp: 'SqR 8/3/2000 13:39'!
hash
	| hash |

	hash := self species hash.
	1 to: self size do: [:i | hash := (hash + (self at: i) hash) hashMultiply].
	^hash! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 8/14/1998 21:20'!
identityIndexOf: anElement 
	"Answer the index of anElement within the receiver. If the receiver does 
	not contain anElement, answer 0."

	^self identityIndexOf: anElement ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 8/14/1998 21:21'!
identityIndexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of anElement within the receiver. If the receiver does 
	not contain anElement, answer the result of evaluating the argument, 
	exceptionBlock."
	1 to: self size do:
		[:i | (self at: i) == anElement ifTrue: [^ i]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'testing' stamp: 'sma 5/12/2000 14:08'!
includes: anObject
	"Answer whether anObject is one of the receiver's elements."

	^ (self indexOf: anObject) ~= 0! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:46'!
indexOf: anElement
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer 0."

	^ self indexOf: anElement ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:47'!
indexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the 
	result of evaluating the argument, exceptionBlock."

	^ self indexOf: anElement startingAt: 1 ifAbsent: exceptionBlock! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'StephaneDucasse 9/18/2010 21:18'!
indexOf: anElement startingAt: start
       "Answer the index of the first occurence of anElement after start within the receiver. If the receiver does not contain anElement, answer 0."

	^self indexOf: anElement startingAt: start ifAbsent: 0! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:47'!
indexOf: anElement startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement after start
	within the receiver. If the receiver does not contain anElement, 
	answer the 	result of evaluating the argument, exceptionBlock."

	start to: self size do:
		[:index |
		(self at: index) = anElement ifTrue: [^ index]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 12/9/2009 14:55'!
indexOfAnyOf: aCollection
	"Answer the index of the first occurence of any element included in aCollection within the receiver.
	If the receiver does not contain anElement, answer zero, which is an invalid index."

	^self indexOfAnyOf: aCollection startingAt: 1 ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 12/9/2009 14:55'!
indexOfAnyOf: aCollection ifAbsent: exceptionBlock
	"Answer the index of the first occurence of any element included in aCollection within the receiver.
	If the receiver does not contain anElement, answer the result of evaluating the argument, exceptionBlock."

	^self indexOfAnyOf: aCollection startingAt: 1 ifAbsent: exceptionBlock! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 12/9/2009 14:54'!
indexOfAnyOf: aCollection startingAt: start
	"Answer the index of the first occurence of any element included in aCollection after start within the receiver.
	If the receiver does not contain anElement, answer zero, which is an invalid index."

	^self indexOfAnyOf: aCollection startingAt: start ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 12/9/2009 14:57'!
indexOfAnyOf: aCollection startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the first occurence of any element included in aCollection after start within the receiver.
	If the receiver does not contain anElement, answer the result of evaluating the argument, exceptionBlock.
	Note: it is user responsibility to provide aCollection that behaves relatevily fast when asked for includes: (like a Set)"

	start to: self size do:
		[:index |
		(aCollection includes: (self at: index)) ifTrue: [^ index]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: ''!
indexOfSubCollection: aSubCollection startingAt: anIndex 
	"Answer the index of the receiver's first element, such that that element 
	equals the first element of aSubCollection, and the next elements equal 
	the rest of the elements of aSubCollection. Begin the search at element 
	anIndex of the receiver. If no such match is found, answer 0."

	^self
		indexOfSubCollection: aSubCollection
		startingAt: anIndex
		ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: ''!
indexOfSubCollection: sub startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the receiver's first element, such that that element 
	equals the first element of sub, and the next elements equal 
	the rest of the elements of sub. Begin the search at element 
	start of the receiver. If no such match is found, answer the result of 
	evaluating argument, exceptionBlock."
	| first index |
	sub isEmpty ifTrue: [^ exceptionBlock value].
	first := sub first.
	start to: self size - sub size + 1 do:
		[:startIndex |
		(self at: startIndex) = first ifTrue:
			[index := 1.
			[(self at: startIndex+index-1) = (sub at: index)]
				whileTrue:
				[index = sub size ifTrue: [^startIndex].
				index := index+1]]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 3/3/2001 22:43'!
integerAt: index
	"Return the integer at the given index"
	^self at: index! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 3/3/2001 22:43'!
integerAt: index put: value
	"Return the integer at the given index"
	^self at: index put: value! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'di 11/6/1998 09:35'!
isSequenceable
	^ true! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/12/2009 20:19'!
join: aCollection
	"NB: this implementation only works for Array, since WriteStreams only work for Arrays and Strings. (!!)
	Overridden in OrderedCollection and SortedCollection."
	^ self class
		streamContents: [:stream | aCollection
				do: [:each | each joinTo: stream]
				separatedBy: [stream nextPutAll: self]]! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/12/2009 19:58'!
joinTo: stream
	"double dispatch for join:"
	^ stream nextPutAll: self! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/10/2009 22:53'!
joinUsing: joiner
	"joiner - character, string or sequenceable collection
	returns collection of the same collection class as 'joiner', or a String"
	^ joiner join: self! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'pmaer 4/27/2012 14:00'!
joinUsing: joiner last: last 
	"#(1 2 3 4) joinUsing: ', ' last: 'and'. => '1, 2, 3 and 4"
	^ last join: (DOArray
				with: (joiner join: self allButLast)
				with: self last)! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 18:13'!
keysAndValuesDo: aBlock 
	"Enumerate the receiver with all the keys (aka indices) and values."

	1 to: self size do: [:index | aBlock value: index value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'md 1/19/2006 09:56'!
last
	"Answer the last element of the receiver"

	^ self at: self size! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:30'!
last: n
	"Answer the last n elements of the receiver.  
	Raise an error if there are not enough elements."

	| size |
	size := self size.
	^ self copyFrom: size - n + 1 to: size! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 12/16/2001 01:06'!
lastIndexOf: anElement
	"Answer the index of the last occurence of anElement within the 
	receiver. If the receiver does not contain anElement, answer 0."

	^ self lastIndexOf: anElement startingAt: self size ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 12/16/2001 01:06'!
lastIndexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of the last occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the
	result of evaluating the argument, exceptionBlock."
	^self lastIndexOf: anElement startingAt: self size ifAbsent: exceptionBlock! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 12/16/2001 01:05'!
lastIndexOf: anElement startingAt: lastIndex ifAbsent: exceptionBlock
	"Answer the index of the last occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the
	result of evaluating the argument, exceptionBlock."

	lastIndex to: 1 by: -1 do:
		[:index |
		(self at: index) = anElement ifTrue: [^ index]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 11/16/2009 10:31'!
lastIndexOfAnyOf: aCollection startingAt: lastIndex ifAbsent: exceptionBlock
	"Answer the index of the last occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the
	result of evaluating the argument, exceptionBlock."

	lastIndex to: 1 by: -1 do:
		[:index |
		(aCollection includes: (self at: index)) ifTrue: [^ index]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'sorting' stamp: 'jannik.laval 5/1/2010 16:27'!
mergeSortFrom: startIndex to: stopIndex by: aBlock
	"Sort the given range of indices using the mergesort algorithm.
	Mergesort is a worst-case O(N log N) sorting algorithm that usually
	does only half as many comparisons as heapsort or quicksort."

	"Details: recursively split the range to be sorted into two halves,
	mergesort each half, then merge the two halves together. An extra 
	copy of the data is used as temporary storage and successive merge 
	phases copy data back and forth between the receiver and this copy.
	The recursion is set up so that the final merge is performed into the
	receiver, resulting in the receiver being completely sorted."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	startIndex = stopIndex ifTrue: [^ self].
	[startIndex >= 1 and: [startIndex < stopIndex]] assert. "bad start index"
	[stopIndex <= self size] assert. "bad stop index"
	self
		mergeSortFrom: startIndex
		to: stopIndex 
		src: self copy 
		dst: self 
		by: aBlock! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'md 1/19/2006 09:56'!
middle
	"Answer the middle element of the receiver."
	^ self at: self size // 2 + 1! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nk 8/23/2003 10:42'!
nextToLast
	^self at: self size - 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
ninth
	"Answer the ninth element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 9! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 3/1/2011 14:22'!
overlappingPairsCollect: aBlock 
	"Answer the result of evaluating aBlock with all of the overlapping pairs of my elements."
	| retval |
	retval := self species ofSize: self size - 1.
	1 to: self size - 1
		do: [:i | retval at: i put: (aBlock value: (self at: i) value: (self at: i + 1)) ].
	^retval! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nk 7/17/2003 17:55'!
overlappingPairsDo: aBlock 
	"Emit overlapping pairs of my elements into aBlock"

	1 to: self size - 1
		do: [:i | aBlock value: (self at: i) value: (self at: i + 1)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nk 7/17/2003 17:54'!
overlappingPairsWithIndexDo: aBlock 
	"Emit overlapping pairs of my elements into aBlock, along with an index."

	1 to: self size - 1
		do: [:i | aBlock value: (self at: i) value: (self at: i + 1) value: i ]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nk 3/30/2002 12:45'!
paddedWith: otherCollection do: twoArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection.
	Missing elements from either will be passed as nil."
	1 to: (self size max: otherCollection size) do:
		[:index | twoArgBlock value: (self at: index ifAbsent: [])
				value: (otherCollection at: index ifAbsent: [])]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 11/12/1998 15:01'!
pairsCollect: aBlock 
	"Evaluate aBlock with my elements taken two at a time, and return an Array with the results"

	^ (1 to: self size // 2) collect:
		[:index | aBlock value: (self at: 2 * index - 1) value: (self at: 2 * index)]
"
#(1 'fred' 2 'charlie' 3 'elmer') pairsCollect:
	[:a :b | b, ' is number ', a printString]
"! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 11/12/1998 15:01'!
pairsDo: aBlock 
	"Evaluate aBlock with my elements taken two at a time.  If there's an odd number of items, ignore the last one.  Allows use of a flattened array for things that naturally group into pairs.  See also pairsCollect:"

	1 to: self size // 2 do:
		[:index | aBlock value: (self at: 2 * index - 1) value: (self at: 2 * index)]
"
#(1 'fred' 2 'charlie' 3 'elmer') pairsDo:
	[:a :b | Transcript cr; show: b, ' is number ', a printString]
"! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ward 7/28/97 09:41'!
permutationsDo: aBlock
	"Repeatly value aBlock with a single copy of the receiver. Reorder the copy
	so that aBlock is presented all (self size factorial) possible permutations."
	"(1 to: 4) permutationsDo: [:each | Transcript cr; show: each printString]"

	self shallowCopy permutationsStartingAt: 1 do: aBlock! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'ward 7/28/97 09:38'!
permutationsStartingAt: anInteger do: aBlock
	"#(1 2 3 4) permutationsDo: [:each | Transcript cr; show: each printString]"

	anInteger > self size ifTrue: [^self].
	anInteger = self size ifTrue: [^aBlock value: self].
	anInteger to: self size do:
		[:i | self swap: anInteger with: i.
		self permutationsStartingAt: anInteger + 1 do: aBlock.
		self swap: anInteger with: i]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'tk 12/27/2000 09:53'!
polynomialEval: thisX
	| sum valToPower |
	"Treat myself as the coeficients of a polynomial in X.  Evaluate it with thisX.  First element is the constant and last is the coeficient for the highest power."
	"  #(1 2 3) polynomialEval: 2   "   "is 3*X^2 + 2*X + 1 with X = 2"

	sum := self first.
	valToPower := thisX.
	2 to: self size do: [:ind | 
		sum := sum + ((self at: ind) * valToPower).
		valToPower := valToPower * thisX].
	^ sum! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'sma 5/12/2000 12:51'!
readStream
	^ ReadStream on: self! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'LukasRenggli 5/10/2010 12:59'!
reduce: aBlock
	^ self reduceLeft: aBlock! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'pmaer 4/27/2012 14:00'!
reduceLeft: aBlock
	"Fold the result of the receiver from left to right into aBlock. The argument aBlock must take two or more arguments."

	"#(1 2 3) reduceLeft: [ :a :b | a - b ].
		--> ((1 - 2) - 3) = -4
	#(1 + 3 - 5) reduceLeft: [ :a :op :b | a perform: op with: b ].
		--> ((1 + 3) - 5) = -1"

	| arguments |
	self emptyCheck.
	arguments := DOArray new: aBlock argumentCount.
	(arguments size = 0 or: [ (self size + 1) \\ (arguments size - 1) > 0 ])
		ifTrue: [ self error: 'Collection size and block argument count do not match.' ].
	arguments at: 1 put: self first.
	2 to: self size by: arguments size - 1 do: [ :index |
		arguments
			replaceFrom: 2 to: arguments size with: self startingAt: index;
			at: 1 put: (aBlock valueWithArguments: arguments) ].
	^ arguments first! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'pmaer 4/27/2012 14:00'!
reduceRight: aBlock
	"Fold the result of the receiver from right to left into aBlock. The argument aBlock must take two or more arguments."

	"#(1 2 3) reduceRight: [ :a :b | a - b ].
		--> (1 - (2 - 3)) = 2
	#(1 + 3 - 5) reduceRight: [ :a :op :b | a perform: op with: b ].
		--> (1 + (3 - 5)) = -1"

	| arguments |
	self emptyCheck.
	arguments := DOArray new: aBlock argumentCount.
	(arguments size = 0 or: [ (self size + 1) \\ (arguments size - 1) > 0 ])
		ifTrue: [ self error: 'Collection size and block argument count do not match.' ].
	arguments at: arguments size put: self last.
	self size - arguments size + 1 to: 1 by: 1 - arguments size do: [ :index |
		arguments
			replaceFrom: 1 to: aBlock argumentCount - 1 with: self startingAt: index;
			at: arguments size put: (aBlock valueWithArguments: arguments) ].
	^ arguments last! !

!DOSequenceableCollection methodsFor: 'removing' stamp: ''!
remove: oldObject ifAbsent: anExceptionBlock 
	"SequencableCollections cannot implement removing."

	self shouldNotImplement! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ul 11/11/2009 19:38'!
replace: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into self."

	1 to: self size do: [ :index |
		self at: index put: (aBlock value: (self at: index)) ]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 1/20/98 16:22'!
replaceAll: oldObject with: newObject 
	"Replace all occurences of oldObject with newObject"
	| index |
	index := self
				indexOf: oldObject
				startingAt: 1
				ifAbsent: [0].
	[index = 0]
		whileFalse: 
			[self at: index put: newObject.
			index := self
						indexOf: oldObject
						startingAt: index + 1
						ifAbsent: [0]]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: ''!
replaceFrom: start to: stop with: replacement 
	"This destructively replaces elements from start to stop in the receiver. 
	Answer the receiver itself. Use copyReplaceFrom:to:with: for 
	insertion/deletion which may alter the size of the result."

	replacement size = (stop - start + 1)
		ifFalse: [self error: 'Size of replacement doesnt match'].
	^self replaceFrom: start to: stop with: replacement startingAt: 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: ''!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"This destructively replaces elements from start to stop in the receiver 
	starting at index, repStart, in the sequenceable collection, 
	replacementCollection. Answer the receiver. No range checks are 
	performed."

	| index repOff |
	repOff := repStart - start.
	index := start - 1.
	[(index := index + 1) <= stop]
		whileTrue: [self at: index put: (replacement at: repOff + index)]! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'lr 5/13/2010 16:25'!
reverse
	"Answer a copy of the receiver with element order reversed, as expected by ANSI."

	^ self reversed! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: ''!
reverseDo: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument, 
	starting with the last element and taking each in sequence up to the 
	first. For SequenceableCollections, this is the reverse of the enumeration 
	for do:."

	self size to: 1 by: -1 do: [:index | aBlock value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: ''!
reverseWith: aSequenceableCollection do: aBlock 
	"Evaluate aBlock with each of the receiver's elements, in reverse order, 
	along with the  
	corresponding element, also in reverse order, from 
	aSequencableCollection. "

	self size ~= aSequenceableCollection size ifTrue: [^ self errorNoMatch].
	self size
		to: 1
		by: -1
		do: [:index | aBlock value: (self at: index)
				value: (aSequenceableCollection at: index)]! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'jm 4/27/98 04:09'!
reversed
	"Answer a copy of the receiver with element order reversed."
	"Example: 'frog' reversed"

	| n result src |
	n := self size.
	result := self species new: n.
	src := n + 1.
	1 to: n do: [:i | result at: i put: (self at: (src := src - 1))].
	^ result
! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
second
	"Answer the second element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 2! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'PeterHugossonMiller 9/3/2009 11:20'!
select: aBlock 
	"Refer to the comment in Collection|select:."
	| aStream |
	aStream := (self species new: self size) writeStream.
	1 to: self size do: 
		[:index |
		(aBlock value: (self at: index))
			ifTrue: [aStream nextPut: (self at: index)]].
	^ aStream contents! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
seventh
	"Answer the seventh element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 7! !

!DOSequenceableCollection methodsFor: 'shuffling' stamp: 'pmaer 4/27/2012 13:58'!
shuffle

	^self shuffleBy: DOCollection randomForPicking! !

!DOSequenceableCollection methodsFor: 'shuffling' stamp: 'StephaneDucasse 7/10/2010 18:26'!
shuffleBy: aRandom
	"Durstenfeld's version of the Fisher-Yates shuffle"

	self size to: 2 by: -1 do: [ :i | 
		self swap: i with: (aRandom nextInt: i) ]! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'pmaer 4/27/2012 13:58'!
shuffled
	^ self shuffledBy: DOCollection randomForPicking

"Examples:
	($A to: $Z) shuffled
"! !

!DOSequenceableCollection methodsFor: 'shuffling' stamp: 'StephaneDucasse 7/10/2010 18:26'!
shuffledBy: aRandom
	"Durstenfeld's version of the Fisher-Yates shuffle"

	^self copy shuffleBy: aRandom! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:22'!
sixth
	"Answer the sixth element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 6! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'pmaer 4/27/2012 14:02'!
split: aSequencableCollection
	| result position oldPosition |
	result := DOOrderedCollection new.
	position := 1.
	oldPosition := position.
	position := aSequencableCollection indexOfSubCollection: self startingAt: position.
	[ position > 0 ] whileTrue: [
		result add: (aSequencableCollection copyFrom: oldPosition to: position - 1).
		position := position + self size.
		oldPosition := position.
		position := aSequencableCollection indexOfSubCollection: self startingAt: position.
	].
	result add: (aSequencableCollection copyFrom: oldPosition to: aSequencableCollection size).
	^ result

! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/12/2009 20:20'!
splitOn: splitter 
	"splitter - can be a subsequence, a Block or a Regex (String receiver only).
	Any other object used as a splitter is treated as an Array containing that object."
	^ splitter split: self! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: ''!
swap: oneIndex with: anotherIndex 
	"Move the element at oneIndex to anotherIndex, and vice-versa."

	| element |
	element := self at: oneIndex.
	self at: oneIndex put: (self at: anotherIndex).
	self at: anotherIndex put: element! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:22'!
third
	"Answer the third element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 3! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 8/31/1999 13:13'!
with: otherCollection collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with corresponding elements from this collection and otherCollection."
	| result |
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	result := self species new: self size.
	1 to: self size do:
		[:index | result at: index put:
		(twoArgBlock
			value: (self at: index)
			value: (otherCollection at: index))].
	^ result! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 8/3/1999 15:26'!
with: otherCollection do: twoArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection."
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	1 to: self size do:
		[:index |
		twoArgBlock value: (self at: index)
				value: (otherCollection at: index)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 5/17/1998 13:34'!
withIndexCollect: elementAndIndexBlock 
	"Just like with:collect: except that the iteration index supplies the second argument to the block."
	| result |
	result := self species new: self size.
	1 to: self size do:
		[:index | result at: index put:
		(elementAndIndexBlock
			value: (self at: index)
			value: index)].
	^ result! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 7/13/97 09:35'!
withIndexDo: elementAndIndexBlock 
	"Just like with:do: except that the iteration index supplies the second argument to the block."
	1 to: self size do:
		[:index |
		elementAndIndexBlock
			value: (self at: index)
			value: index]! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'sma 5/12/2000 12:52'!
writeStream
	^ WriteStream on: self! !

Object subclass: #DOFlag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Util'!

DOFlag class
	instanceVariableNames: 'doFlag'!

DOFlag class
	instanceVariableNames: 'doFlag'!

!DOFlag class methodsFor: 'accessing' stamp: 'pmaer 2/15/2012 15:11'!
doFlag
	(doFlag = nil) ifTrue: [ doFlag:= false ].
	^ doFlag! !

!DOFlag class methodsFor: 'accessing' stamp: 'pmaer 2/15/2012 15:10'!
doFlag: anObject
	doFlag := anObject! !

Object subclass: #Die
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!Die commentStamp: 'on 3/14/2006 19:06' prior: 0!
Responsibilities:
- Yields a random number from 1 to 6 ;-)!

!Die class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!Die methodsFor: 'playing' stamp: 'on 3/14/2006 15:41'!
roll
	^ (1 to: 6) atRandom! !

Die subclass: #LoadedDie
	instanceVariableNames: 'roll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!LoadedDie commentStamp: 'on 3/17/2006 10:50' prior: 0!
For testing purposes. When rolled, a loaded die returns a fixed value.!

!LoadedDie class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!LoadedDie methodsFor: 'playing' stamp: 'on 3/18/2006 15:24'!
roll
	self assert: roll notNil.
	^ roll! !

!LoadedDie methodsFor: 'playing' stamp: 'on 3/18/2006 15:25'!
roll: aNumber
	self assert: ((1 to: 6) includes: aNumber).
	roll := aNumber.! !

Object subclass: #GamePlayer
	instanceVariableNames: 'name square'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!GamePlayer commentStamp: 'on 3/14/2006 19:07' prior: 0!
Responsibilities:
- Keep track of the square you are on
- Roll the die
- Attempt to move the resulting number of squares!

!GamePlayer class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!GamePlayer class methodsFor: 'instance creation' stamp: 'on 3/18/2006 12:48'!
named: aName
	^ self new setName: aName! !

!GamePlayer methodsFor: 'initialize-release' stamp: 'on 3/18/2006 12:08'!
invariant
	^ square notNil
		and: [ name notNil ]! !

!GamePlayer methodsFor: 'private' stamp: 'on 3/14/2006 15:53'!
leaveCurrentSquare
	square notNil ifTrue: [ square remove: self ].! !

!GamePlayer methodsFor: 'playing' stamp: 'on 3/18/2006 15:21'!
moveTo: aSquare
	self leaveCurrentSquare.
	square := aSquare landHere: self.
! !

!GamePlayer methodsFor: 'playing' stamp: 'on 3/23/2006 09:04'!
moveWith: aDie
	| roll destination |
	self assert: self invariant.
	roll := aDie roll.
	destination := square forwardBy: roll.
	self moveTo: destination.
	^ name, ' rolls ', roll asString, ' and lands at ', square asString! !

!GamePlayer methodsFor: 'testing' stamp: 'on 3/15/2006 14:57'!
name
	^ name! !

!GamePlayer methodsFor: 'testing' stamp: 'on 3/14/2006 17:03'!
position
	^ square position! !

!GamePlayer methodsFor: 'printing' stamp: 'on 3/14/2006 15:32'!
printOn: aStream
	aStream nextPutAll: name! !

!GamePlayer methodsFor: 'initialize-release' stamp: 'on 3/18/2006 12:49'!
setName: aName
	name := aName.! !

!Object class methodsFor: '*dynamicownership' stamp: 'ewe 4/20/2012 16:22'!
isOwnershipAware
	^ self  compilerClass == OwnershipCompiler3 ! !

!Object class methodsFor: '*dynamicownership' stamp: 'ewe 4/23/2012 14:56'!
newOwned: owner 
	| n |
	n := self new. 
	n owner: owner.
	^ n.! !

!Object class methodsFor: '*dynamicownership' stamp: 'ewe 4/25/2012 18:17'!
owners
	( Owners = nil) ifTrue: [ Owners := WeakKeyDictionary new. ].
	^ Owners. ! !

!Object class methodsFor: '*dynamicownership' stamp: 'ewe 4/26/2012 09:57'!
resetOwners
	Owners := IdentityDictionary new. ! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 5/2/2012 16:50'!
acceptOwnee: candidateOwnee
	^false.! !

!Object methodsFor: '*dynamicownership' stamp: 'pmaer 2/1/2012 11:10'!
boundaryCrossed: returnValue receiver: receiver
	"hook"
	"TODO: implement behavior for boundary crossing"
	^returnValue! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 5/2/2012 16:55'!
checkValidSend3: sender message: selector block: block arguments: arguments
	| argumentsWithSelf |
	
	
	"special case for object instantiation"
	( selector = #new ) ifTrue: [
		^ self new primOwner: sender. 
	].

	"checks if the message send is valid. if valid send: evaluate the block, if non valid send: return false (for now)"
	"TODO actual checkValidSend method is on OwnedObject3>>checkValidSend3, move to here when finished"
	Transcript show: self class printString ; show: ' ' ; show: selector ; cr.
	
	argumentsWithSelf := OrderedCollection new.
	argumentsWithSelf addAll: arguments. 
	argumentsWithSelf addFirst: self. 
	
	"TODO temporary hack" 
	"[ ^block valueWithArguments: argumentsWithSelf. ] "
	[ ^self perform: selector withArguments: arguments ] 
	on: Exception 
	do: [ :ex | Transcript show: ( 'Exception', ex printString).  ex pass ]! !

!Object methodsFor: '*dynamicownership' stamp: 'pmaer 2/21/2012 13:24'!
checkValidSend: receiver message: selector block: block
	"checks if the message send is valid. if valid send: evaluate the block, if non valid send: return false (for now)"
	"(DOFlag doFlag) ifTrue: [
		
		[
			^block valueWithArguments: { self }.
		] on: Error do: [  ].
	] ifFalse: [ DOFlag doFlag: true.
				self halt.].
	"
	
	"evaluate the block"
	"DOFlag doFlag: false."
	[
		^block valueWithArguments: { self }.
	] on: Error do: [  ] ! !

!Object methodsFor: '*dynamicownership' stamp: 'pmaer 4/20/2012 17:01'!
checkVisibility: objectToCheck
	"check if objectToCheck is visible to self "

	| tempOwner |
	
	"check self"
	( self == objectToCheck ) ifTrue: [^true].
	
	"check children"
	(objectToCheck owner == self) ifTrue: [^true].
	
	"check sibling"
	(objectToCheck owner == self owner) ifTrue: [^true].
	
	"check above ownership tree"
	tempOwner := self owner.

	[ tempOwner == objectToCheck  or: tempOwner = WorldOwner getInstance ] whileFalse: [
	
		( tempOwner == nil)
			ifTrue: [^false]
			ifFalse: [tempOwner := tempOwner owner]
		].
	
	^true! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 4/27/2012 11:52'!
dynamicOwner
	"returns the owner, if no owner is assinged, return the WorldOwner"
	^Object owners at: self ifAbsent: [ ^ WorldOwner getInstance ] ! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 4/27/2012 11:52'!
dynamicOwner: anOwner
	"setter for owner"
	Object owners at: self put: anOwner.! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 5/2/2012 16:16'!
inFilters
	^{#none}! !

!Object methodsFor: '*dynamicownership' stamp: 'pmaer 4/20/2012 17:08'!
isOwnershipAware
	[^self compilerClass = OwnershipCompiler3] on: MessageNotUnderstood do: [^false].! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 5/2/2012 16:16'!
outFilters
	^{#all}! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 4/27/2012 14:57'!
owner
	"returns the owner, if no owner is assinged, return the WorldOwner"
	^Object owners at: self ifAbsent: [ ^ WorldOwner getInstance ] ! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 4/27/2012 14:57'!
owner: anOwner
	"setter for owner"
	Object owners at: self put: anOwner.! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 4/20/2012 17:03'!
ownersAsList
	|tempOwner owners|
	owners := OrderedCollection new.
	tempOwner:= self owner.
	[ tempOwner ~= WorldOwner getInstance ] whileTrue: [ 
		owners addFirst: tempOwner.
		tempOwner:= tempOwner owner.
	].
	^ owners.! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 5/2/2012 16:55'!
primOwner: anOwner
	"This method should be used only internaly. It a hack to create object with the sender as owner by default."
	Object owners at: self put: anOwner.! !

Object subclass: #OwnedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel'!

OwnedObject subclass: #ObjectWithOwnershipCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel'!

!ObjectWithOwnershipCompiler class methodsFor: 'as yet unclassified' stamp: 'pmaer 12/5/2011 09:31'!
compilerClass
^ OwnershipCompiler! !

!ObjectWithOwnershipCompiler methodsFor: 'as yet unclassified' stamp: 'pmaer 1/23/2012 16:52'!
objectName   
	| a b anObj | 
	self do: a with: b.
	
	anObj doWith: anObj name.     ! !

!ObjectWithOwnershipCompiler methodsFor: 'as yet unclassified' stamp: 'pmaer 1/23/2012 16:55'!
test
	| a |
	^a  ! !

!OwnedObject class methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:44'!
new
	| n |
	n := super new. 
	"n owner: 'the caller'."
	^ n.! !

!OwnedObject class methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:36'!
newOwned: owner 
	| n |
	n := super new. 
	n owner: owner.
	^ n.! !

!OwnedObject class methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:45'!
owners
	( Owners = nil) ifTrue: [ Owners := WeakKeyDictionary new. ].
	^ Owners. ! !

!OwnedObject methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:40'!
checkValidSend: receiver message: selector block: block
	"checks if the message send is valid. if valid send: evaluate the block, if non valid send: return false (for 	now)"


	| messagePragmas aMethodDict oneWay pure |
	
	oneWay := false.
	pure := false.
	
	aMethodDict:= receiver class methodDict.
	messagePragmas := (aMethodDict at: selector) pragmas.
	
	messagePragmas do: [:each |
			(each keyword = #pure) ifTrue: [
				pure:= true].
			(each keyword = #oneWay) ifTrue: [
				oneWay := true].
		 ].
	
	
	"normal message send, only allowed to self or owned"
	(oneWay or: pure) ifFalse: [

		( (receiver == self) or: (receiver owner == self ) ) ifFalse: [^false]
		
		]
	

	"oneWay or pure message send, allowed to all visible"
	 ifTrue: [

		(self checkVisibility: receiver) ifFalse: [^false].
		
		].
	
	"evaluate the block and return"
	^block valueWithArguments: { receiver }.
		
	"Add a check for the returned value. Inovke the hook if necessary"! !

!OwnedObject methodsFor: 'as yet unclassified' stamp: 'pmaer 4/20/2012 16:59'!
checkVisibility: objectToCheck
	"check if objectToCheck is visible to self "

	| tempOwner |
	
	"check self"
	( self == objectToCheck ) ifTrue: [^true].
	
	"check children"
	(objectToCheck owner == self) ifTrue: [^true].
	
	"check sibling"
	(objectToCheck owner == self owner) ifTrue: [^true].
	
	"check above ownership tree"
	tempOwner := self owner.

	[ tempOwner == objectToCheck ] whileFalse: [
	
		( tempOwner == nil or: tempOwner = WorldOwner getInstance )
			ifTrue: [^false]
			ifFalse: [tempOwner := tempOwner owner]
		].
	
	^true! !

OwnedObject subclass: #OwnedObjectWithPragmas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel-Test'!

!OwnedObjectWithPragmas methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 20:53'!
normalMethod
	Transcript show: 'normal method executed'.! !

!OwnedObjectWithPragmas methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 20:53'!
oneWayMethod
	<oneWay>
	Transcript show: 'oneWay method executed'.! !

!OwnedObjectWithPragmas methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 20:54'!
pureMethod
	<pure>
	Transcript show: 'pure method executed'.! !

OwnedObject subclass: #TestLiterals
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel-Test'!

!TestLiterals methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 13:56'!
a
	Object new.
	OwnedObject new.
	"Random Stuff"! !

!TestLiterals methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 15:00'!
b
	| objectName eachLiteral |
			eachLiteral := 'Object->OwnedObject'.
			objectName := ' '.
			[
			(eachLiteral asString at: 2) isUppercase ifTrue: [
				
					
					
					2 to: (eachLiteral length) do: [ :n | ((eachLiteral at: n) isLetter ) 

whileTrue: [ 
							objectName join: (eachLiteral at: n).
								
							
							 ]   ]
					
					Transcript show: objectName.
					
				]]! !

Object subclass: #OwnedObject2
	instanceVariableNames: 'internalInterface externalInterface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

OwnedObject2 subclass: #ObjectWithOwnershipCompiler2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

!ObjectWithOwnershipCompiler2 class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_1! !

!ObjectWithOwnershipCompiler2 methodsFor: 'as yet unclassified' stamp: 'pmaer 1/2/2012 19:18'!
objectName   
	| a b anObj | 
	self do: a with: b.
	
	anObj doWith: anObj name.    ! !

!ObjectWithOwnershipCompiler2 methodsFor: 'as yet unclassified' stamp: 'pmaer 2/3/2012 15:02'!
test
	|a|
	a:= Object new.
	^a do: a.   ! !

OwnedObject2 subclass: #ObjectWithReadWriteInterface
	instanceVariableNames: 'studentNumber studentName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel-Test'!

!ObjectWithReadWriteInterface methodsFor: 'accessing' stamp: 'pmaer 1/16/2012 23:00'!
studentName
	<read>
	<readWrite>
	^ studentName! !

!ObjectWithReadWriteInterface methodsFor: 'accessing' stamp: 'pmaer 1/16/2012 23:00'!
studentName: anObject
	<readWrite>
	studentName := anObject! !

!ObjectWithReadWriteInterface methodsFor: 'accessing' stamp: 'pmaer 1/16/2012 23:00'!
studentNumber
	<read>
	<readWrite>
	^ studentNumber! !

!ObjectWithReadWriteInterface methodsFor: 'accessing' stamp: 'pmaer 1/16/2012 23:01'!
studentNumber: anObject
	<readWrite>
	studentNumber := anObject! !

!ObjectWithReadWriteInterface methodsFor: 'as yet unclassified' stamp: 'pmaer 1/16/2012 23:38'!
studentNumberGetterWithDifferentInterface
	<somethingDifferent>
	^studentNumber.
	! !

!ObjectWithReadWriteInterface methodsFor: 'as yet unclassified' stamp: 'pmaer 1/16/2012 23:38'!
studentNumberSetterWithDifferentInterface: anObject
	<somethingDifferent>
	studentNumber := anObject
	! !

!OwnedObject2 methodsFor: 'as yet unclassified' stamp: 'pmaer 1/30/2012 17:39'!
boundaryCrossed: returnValue receiver: receiver
	"hook"
	"TODO: implement behavior for boundary crossing"
	^returnValue! !

!OwnedObject2 methodsFor: 'as yet unclassified' stamp: 'pmaer 1/30/2012 17:40'!
checkValidSend: receiver message: selector block: block
	"checks if the message send is valid. if valid send: evaluate the block, if non valid send: return false (for now)"


	| messagePragmas aMethodDict isInternalInterface isExternalInterface returnValue |
	
	isInternalInterface := false.
	isExternalInterface := false.
	
	aMethodDict:= receiver class methodDict.
	messagePragmas := (aMethodDict at: selector) pragmas.
	
	messagePragmas do: [:each |
			(each keyword = receiver externalInterface ) ifTrue: [
				isExternalInterface:= true].
			(each keyword = receiver internalInterface ) ifTrue: [
				isInternalInterface := true].
		 ].
	
	(isInternalInterface and: isExternalInterface not) ifTrue:[
		( (receiver == self) or: (receiver owner == self ) ) ifFalse: [^false]
		]
		ifFalse: [ (isExternalInterface) ifFalse: [^false] ].
	
	"evaluate the block"
	returnValue:= block valueWithArguments: { receiver }.
	
	"check for boundary crossing"
	(receiver checkVisibility: returnValue) ifTrue: [ ^returnValue ]
		"TODO: decide where to call boundaryCrossed (now on owner)"
		ifFalse: [ ^(returnValue owner boundaryCrossed: returnValue receiver: receiver) ]! !

!OwnedObject2 methodsFor: 'as yet unclassified' stamp: 'pmaer 4/20/2012 17:00'!
checkVisibility: objectToCheck
	"check if objectToCheck is visible to self "

	| tempOwner |
	
	"check self"
	( self == objectToCheck ) ifTrue: [^true].
	
	"check children"
	(objectToCheck owner == self) ifTrue: [^true].
	
	"check sibling"
	(objectToCheck owner == self owner) ifTrue: [^true].
	
	"check above ownership tree"
	tempOwner := self owner.

	[ tempOwner == objectToCheck or: tempOwner = WorldOwner getInstance ] whileFalse: [
	
		( tempOwner == nil)
			ifTrue: [^false]
			ifFalse: [tempOwner := tempOwner owner]
		].
	
	^true! !

!OwnedObject2 methodsFor: 'accessing' stamp: 'pmaer 1/2/2012 22:57'!
externalInterface
	^ externalInterface! !

!OwnedObject2 methodsFor: 'accessing' stamp: 'pmaer 1/2/2012 22:57'!
externalInterface: anObject
	externalInterface := anObject! !

!OwnedObject2 methodsFor: 'accessing' stamp: 'pmaer 1/2/2012 22:57'!
internalInterface
	^ internalInterface! !

!OwnedObject2 methodsFor: 'accessing' stamp: 'pmaer 1/2/2012 22:57'!
internalInterface: anObject
	internalInterface := anObject! !

Object subclass: #OwnedObject3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

OwnedObject3 subclass: #BasicTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!BasicTester class methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:09'!
compilerClass 
	^OwnershipCompiler3 ! !

!BasicTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:10'!
testDefaultOwner
	| o |
	o := OwnedObject3 new. 
	^ o owner.! !

OwnedObject3 subclass: #Customer
	instanceVariableNames: 'identifier firstname lastname amount partner type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!Customer class methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 14:42'!
compilerClass
	^ OwnershipCompiler3! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:39'!
amount
	^ amount! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:39'!
amount: anObject
	amount := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 11:06'!
credit: credit
	<anonym>
	amount := amount + credit! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:37'!
firstname
	^ firstname! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:37'!
firstname: anObject
	firstname := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:43'!
identifier
	<anonym>
	^ identifier! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:37'!
identifier: anObject
	identifier := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 12:02'!
initalize
 	amount := 0.
	type := #economy! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 17:04'!
isCustomerOf: aBank

	^ aBank customers includes: self.   ! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:37'!
lastname
	^ lastname! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:37'!
lastname: anObject
	lastname := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 17:07'!
partner
	^ partner! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 17:07'!
partner: anObject
	partner := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/23/2012 15:35'!
printString
	^ identifier! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 12:05'!
promoteFrom: aBank
	aBank promoteCustomer: self. ! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 12:03'!
type
	^ type! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 12:03'!
type: anObject
	type := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 11:07'!
withdraw: debit
	amount := amount - debit! !

OwnedObject3 subclass: #Hotel
	uses: TNoOwernship
	instanceVariableNames: 'room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

Hotel class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!Hotel class methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:17'!
compilerClass 
	^ OwnershipCompiler3! !

!Hotel methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:13'!
anyRoom
	<unsafe>
	^room.! !

!Hotel methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:12'!
inFilters
	^ { #public }! !

!Hotel methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:21'!
initialize 
	room := Room newOwned: self.! !

!Hotel methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ { #all }
	! !

OwnedObject3 subclass: #HotelTester
	uses: TNoOwernship
	instanceVariableNames: 'hotel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

HotelTester class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!HotelTester class methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:22'!
compilerClass 
	^OwnershipCompiler3 ! !

!HotelTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#none}! !

!HotelTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:19'!
initialize 
	hotel := Hotel new.! !

!HotelTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ { #all }
	! !

!HotelTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:22'!
testContent
	^ hotel anyRoom safe content.  ! !

!HotelTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:22'!
testStatus
	^ hotel anyRoom safe status.  ! !

OwnedObject3 subclass: #OComponent
	uses: TDefensiveCopyOwernship
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OComponent class
	uses: TDefensiveCopyOwernship classTrait
	instanceVariableNames: ''!

!OComponent class methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:50'!
compilerClass
	^OwnershipCompiler3! !

!OComponent methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:57'!
addItem: anItem
	items addFirst: anItem. ! !

!OComponent methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:31'!
doNotCrossBoundary: anObject
	| clone |
	( self selectedCopyClass includes: anObject class ) ifTrue: [
			Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') copied by ', self printString ) ; cr.
			"The handler is subject t ownership (no meta pragma), so the owner of the new list is the boundary."
			clone := anObject class new.
			clone addAll: anObject.  
			clone owner: WorldOwner getInstance.
			^ clone. 
	]	ifFalse: [
			Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
			OwnershipViolation signal: 'Boundary crossed'    
	]
! !

!OComponent methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:05'!
initialize 
	items := OLinkedList new.! !

!OComponent methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:56'!
items
	^ items ! !

!OComponent methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:52'!
selectedCopyClass 
	^ { OLinkedList }! !

OwnedObject3 subclass: #OComponentTester
	uses: TNoOwernship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OComponentTester class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!OComponentTester class methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:52'!
compilerClass 
	^OwnershipCompiler3 ! !

!OComponentTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:34'!
testReturnCopy
	| comp items1 items2 |
	comp := OComponent  new.
	comp addItem: '1'. 
	comp addItem: '2'. 
	items1 := comp items. 
	items2 := comp items. 
	^items1 == items2. ! !

OwnedObject3 subclass: #OIterator
	instanceVariableNames: 'current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!OIterator class methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:18'!
compilerClass 
	^ OwnershipCompiler3  ! !

!OIterator methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:03'!
current
	^ current! !

!OIterator methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:03'!
current: v
	 current := v ! !

!OIterator methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:31'!
hasNext
	<iteration>
	^ (self current = nil ) not. ! !

!OIterator methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:31'!
next
	<iteration>
	| v |
	v := self current content.
	self current: self current next. 
	^ v.! !

OwnedObject3 subclass: #OLinkedList
	uses: TSelectiveOwernship
	instanceVariableNames: 'head'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OLinkedList class
	uses: TSelectiveOwernship classTrait
	instanceVariableNames: ''!

!OLinkedList class methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:18'!
compilerClass 
	^ OwnershipCompiler3  ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:59'!
addAll: aList
	| it |
	it := aList iterator.
	[ it hasNext ] whileTrue: [ self addFirst: it next. ] ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:41'!
addFirst: value
	| node |
	node := ( ONode newOwned: self ) content: value ; next: self head. 
	node owner: self. 
	self head: node. ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:06'!
first
	^ self head content. ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:04'!
head
	^ head! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:04'!
head: h
	head := h.! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#iteration}! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:04'!
initialize 
	self head: nil. ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:41'!
iterator 
	^ ( OIterator newOwned: self ) current: self head. ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ { #all }
	! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:04'!
removeFirst
	self head: self head next. ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:30'!
selectedClasses 
	^ { OIterator }! !

OwnedObject3 subclass: #OLinkedListTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!OLinkedListTester class methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:20'!
compilerClass 
	^ OwnershipCompiler3  ! !

!OLinkedListTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:38'!
buildList
	| list |
	 list := OLinkedList new owner: self .
	list addFirst: #1. 
	list addFirst: #2. 
	^ list.! !

!OLinkedListTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:37'!
testAddRemoveFirst
	| list |
	list := self buildList .
	list removeFirst. 
	^ list first. ! !

!OLinkedListTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:37'!
testIterator
	| list it |
	list := self buildList .
  	it := list iterator. 
	it next.
	^ it next! !

!OLinkedListTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:37'!
testLeakAddRemoveFirst
	| list |
	list := self buildList .
	list first .
	list first .
	^ list head. "should fail"! !

!OLinkedListTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:37'!
testLeakIterator
	| list it |
	list := self buildList .
  	it := list iterator. 
	it next.
	it next. 
	^ it current. "should fail"! !

OwnedObject3 subclass: #ONode
	instanceVariableNames: 'value next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!ONode class methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:18'!
compilerClass 
	^ OwnershipCompiler3  ! !

!ONode methodsFor: 'accessing' stamp: 'ewe 4/26/2012 15:00'!
content
	^ value.! !

!ONode methodsFor: 'accessing' stamp: 'ewe 4/26/2012 15:10'!
content: val
	value := val.! !

!ONode methodsFor: 'accessing' stamp: 'ewe 4/26/2012 14:59'!
next
	^ next! !

!ONode methodsFor: 'accessing' stamp: 'ewe 4/26/2012 14:59'!
next: anObject
	next := anObject! !

OwnedObject3 subclass: #OSecureTree
	uses: TNoOwernship
	instanceVariableNames: 'left content right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OSecureTree class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!OSecureTree class methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:42'!
compilerClass 
	^ OwnershipCompiler3  ! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:23'!
content
	<traversal>
 	^content..! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:23'!
content: val
	content:= val.! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:31'!
do: aBlock

^aBlock value. ! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:30'!
expandLeft
	^ left := OTree newOwned: self .! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:30'!
expandRight
	^ right := OTree newOwned: self .! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:26'!
inFilters
	^ {#traversal}! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:21'!
left
	<traversal>
	^left.! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:21'!
right
	<traversal>
	^ right.! !

OSecureTree subclass: #OTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!OTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:27'!
freeze
	self owner: (OTreeSandbox newOwned: self owner ). ! !

!OTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:27'!
inFilters 
	^{ #all}! !

OwnedObject3 subclass: #OTreeSandbox
	uses: TSelectiveOwernship
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OTreeSandbox class
	uses: TSelectiveOwernship classTrait
	instanceVariableNames: ''!

!OTreeSandbox methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!OTreeSandbox methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:42'!
inFilters
	^ {#traversal}! !

!OTreeSandbox methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:24'!
selectedClasses 
	^ {OTree}! !

OwnedObject3 subclass: #OTreeTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!OTreeTester class methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:46'!
compilerClass 
	^OwnershipCompiler3  ! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 17:02'!
acceptOwnee: anOwnee
	"TODO how could we make the sandbox more transparent? "
	^( anOwnee class name = #OTree or: [ anOwnee class name = #OTreeSandbox ])! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:19'!
buildSandboxedTree
	| tree sandbox |
	tree := OTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	tree left content: '2a'. 
	
	tree expandRight.  
	tree right content: '2b'. 
	
	tree left expandLeft.  
	tree left left content: '3a'. 
	
	sandbox := OTreeSandbox new. 
	tree owner: sandbox. 
	^ tree.
	! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:49'!
testCreation
	| tree |
	tree := OTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	tree left content: '2a'. 
	
	tree expandRight.  
	tree right content: '2b'. 
	
	tree left expandLeft.  
	tree left left content: '3a'. ! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:28'!
testCreationFreeze
	| tree |
	tree := OTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	tree left content: '2a'. 
	
	tree expandRight.  
	tree right content: '2b'. 
	
	tree left expandLeft.  
	tree left left content: '3a'. 
	
	tree freeze.
	tree left left content: 'new'.! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:19'!
testSandboxCreation
	| tree  |
	tree := self buildSandboxedTree .
	
	! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:19'!
testSandboxMutation
	| tree  |
	tree := self buildSandboxedTree .
	tree content: 'new'.
	
	! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:20'!
testSandboxTraversal
	| tree  |
	tree := self buildSandboxedTree .
	tree content.
	
	
	! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:43'!
testSecureCreationBorrow
	| tree |
	tree := OSecureTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	self borrow: tree left do: [ :node | node content: '2a' ]. "write is ok if borrowed"! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:43'!
testSecureCreationFail
	| tree |
	tree := OSecureTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	tree left  content: '2a' . "can only read otherwise"! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:43'!
testSecureCreationImpersonate
	| tree |
	tree := OSecureTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	tree do: [ tree left content: '2a' ]. "the sender of message in the block is still self, so it fails. "! !

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 5/2/2012 16:45'!
borrow: anObject do: aBlock
	| oldOwner |
	oldOwner := anObject owner. 
	anObject owner: self. 
	[
	  ^aBlock value: anObject. 
	] ensure: [
		anObject owner: oldOwner. 
	]! !

!OwnedObject3 methodsFor: 'testing' stamp: 'ewe 4/20/2012 11:20'!
canNotSend: selector to: receiver
	[ self canSend: selector to: receiver ] on: MessageFiltered do: [ ^ true ]. 
	^ false. 
	
! !

!OwnedObject3 methodsFor: 'testing' stamp: 'ewe 4/19/2012 16:10'!
canSend: selector to: receiver
	"Tests whether the object can send the message to the receiver"
	self checkValidSend3: receiver message: selector block: [:t | ^ true] arguments: {}.
	^ false. 
	
! !

!OwnedObject3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 15:29'!
checkContainment: objectToCheck
	"check if objectToCheck is 'down' in the ownership tree w.r.t the sender"

	| tempOwner |
	
	"check above ownership tree"
	tempOwner := objectToCheck.

	[ tempOwner == self ] whileFalse: [
	
		( tempOwner == nil | tempOwner == WorldOwner getInstance )
			ifTrue: [^false]
			ifFalse: [tempOwner := tempOwner owner]
		].
	
	^true! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 5/2/2012 16:29'!
checkValidSend3: sender message: selector block: block arguments: arguments
	
	| returnValue argumentsWithSelf |			
	Transcript show: self class printString ; show: ' ' ; show: selector ; cr.
	
	self handleFilters: sender selector: selector.
	self handleViolation: sender arguments: arguments. 
	
	"evaluate the block"
	argumentsWithSelf := OrderedCollection new.
	argumentsWithSelf addAll: arguments. 
	argumentsWithSelf addFirst: self. 
	"TODO temporary hack"
	returnValue := self perform: selector withArguments: arguments. 
	"returnValue:= block valueWithArguments: argumentsWithSelf ."
	
	^ self handleViolation: sender returnValue: returnValue. 
	! !

!OwnedObject3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 15:26'!
checkVisibility: objectToCheck
	"check if objectToCheck is 'up' in the ownership tree w.r.t the sender"

	| tempOwner |
	
	"check self"
	( self == objectToCheck ) ifTrue: [^true].
	
	"check children"
	(objectToCheck owner == self) ifTrue: [^true].
	
	"check sibling"
	(objectToCheck owner == self owner) ifTrue: [^true].
	
	"check above ownership tree"
	tempOwner := self owner.

	[ tempOwner == objectToCheck ] whileFalse: [
	
		( tempOwner == nil | tempOwner == WorldOwner getInstance )
			ifTrue: [^false]
			ifFalse: [tempOwner := tempOwner owner]
		].
	
	^true! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 4/26/2012 14:13'!
computePathFrom: sender to: returnValue
	| senderOwners valueOwners |
	senderOwners:= sender ownersAsList .
	valueOwners := returnValue ownersAsList .
	[valueOwners notEmpty and: [ senderOwners notEmpty and: [valueOwners first == senderOwners first]]] whileTrue: 	[
		valueOwners removeFirst.
		senderOwners removeFirst.
	].
	(valueOwners notEmpty and: [ sender = valueOwners first ]) ifTrue: [ valueOwners removeFirst. ].  
	^valueOwners. 
	! !

!OwnedObject3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 16:53'!
dummyCheckCode

|sender returnValue |

	(sender checkContainment: self) ifTrue: [
		"sender contains receiver"
		 " s//v - r//v is the set of additonal boundary crossed "
	] ifFalse: [
		(self checkContainment: sender) ifTrue: [
			"receiver contains sender"
			"return value cross boundaries in, not out,  so this particular return can not be the source of a violation"
			"s//v - r//v = 0"
				^ returnValue. 
		] ifFalse: [
			"sender and receiver are disjoint"
			"to anlayze"
		]
	]! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 5/1/2012 16:17'!
handleFilters: sender selector: selector 

	| receiverOwners senderOwners filters interfaces pragmas |
	
	"find path in ownership tree"
	receiverOwners:= self ownersAsList .
	senderOwners := sender ownersAsList .

	"find the lowest-in-the-tree element that is in both lists"
	[receiverOwners notEmpty and: [ senderOwners notEmpty and: [receiverOwners first == senderOwners first]]] whileTrue: 	[
		receiverOwners removeFirst.
		senderOwners removeFirst.
	].
	
	"Customer can ask anything to its bank" 
 	(senderOwners notEmpty and: [ senderOwners first = self ])
		ifTrue: [ senderOwners removeFirst  ].
		
	"Bank can ask anything to its customer"
	(receiverOwners notEmpty and: [ receiverOwners first = sender ])
		 ifTrue: [ receiverOwners removeFirst ].
	
	"check filters"
	pragmas := (self class lookupSelector: selector) pragmas.
	interfaces := pragmas collect: [ :pragma | pragma keyword ].

	"note: method #matches: handle the special #all filter"
	senderOwners do: [ :out | ( out outFilters matches: interfaces ) ifFalse: [ ^MessageFiltered signal: selector ] ].
	receiverOwners do: [ :in | ( in inFilters matches: interfaces ) ifFalse: [ ^MessageFiltered signal: selector ]  ].
	! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 4/27/2012 12:14'!
handleViolation: sender arguments: arguments 
	
	| rp sp violationOwners |
	
	arguments do: [ :argument | 
		"Let   a//b denotes the out boudnaries between a and b.
		s=sender, r=receiver, v=return value, p=argument 
		We need to trigger boundary violations for r//p - s//p. "
	
		rp := self computePathFrom: self to: argument. "compute s//v"
		Transcript show: ( 'r//p ', rp printString ) ; cr.
		sp := self computePathFrom: sender to: argument. "compute r//v"
		Transcript show: ( 's//p ', sp printString ) ; cr. 
		violationOwners := rp removeAllIfPresent: sp.  "compute s//v - r//v"
		Transcript show: ( 'r//p - s//p ', violationOwners printString ) ; cr.
	
		"TODO: boundaryCrosse could replace the argument, make sure order is preserved" 
		violationOwners do: [ :boundary |
			Transcript show: ( 'sender: ', sender printString  ); cr.
			Transcript show: ( 'receiver: ', self printString) ; cr. 
			Transcript show: ( 'parameter: ', argument printString  ); cr.
			( boundary canCrossBoundary: argument ) ifTrue: [
				boundary doCrossBoundary: argument. 
			] ifFalse: [
				 boundary doNotCrossBoundary: argument.
			]
		]
	]! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 5/2/2012 16:29'!
handleViolation: sender returnValue: returnValue 
	
	| sv rv violationOwners |
	
	"Let   a//b denotes the out boudnaries between a and b.
	s=sender, r=receiver, v=return value, p=argument 
	We need to trigger boundary violations for s//v - r//v. "
	
	sv := self computePathFrom: sender to: returnValue. "compute s//v"
	Transcript show: ( 's//v ', sv printString ) ; cr.
	rv := self computePathFrom: self to: returnValue. "compute r//v"
	Transcript show: ( 'r//v ', rv printString ) ; cr.
	violationOwners := sv removeAllIfPresent: rv.  "compute s//v - r//v"
	Transcript show: ( 's//v - r//v ', violationOwners printString ) ; cr.
	
	violationOwners do: [ :boundary |
		Transcript show: ( 'sender: ', sender printString  ); cr.
		Transcript show: ( 'receiver: ', self printString) ; cr. 
		Transcript show: ( 'value: ', returnValue printString  ); cr.
		( boundary canCrossBoundary: returnValue ) ifTrue: [
			boundary doCrossBoundary: returnValue. 
		] ifFalse: [
			"TODO should be recursive if mutlipe non crossable barriers are crossed"
			^ boundary doNotCrossBoundary: returnValue.
		]
	].
	^ returnValue. ! !

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 5/2/2012 16:47'!
owner: newOwner
	(newOwner acceptOwnee: self ) ifTrue: [ super owner: newOwner ] ifFalse: [ TransferError signal ]! !

OwnedObject3 subclass: #OwnershipCompilerTester
	instanceVariableNames: 'value myself'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!OwnershipCompilerTester class methodsFor: 'as yet unclassified' stamp: 'ewe 4/23/2012 15:58'!
compilerClass 
	^ OwnershipCompiler3 ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:26'!
doFirst
	value := value * 5. ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:29'!
doSecond: dontCare
	value := value + 1.! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:26'!
initialize 
	myself := self.  ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:25'!
multiply: n by: factor 
	^ n * factor.
	 ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:25'!
sum: n with: m
	^ n + m.  ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 13:36'!
testArray
	^{1. 2. 3}! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 14:21'!
testArrayAndLiteralArray
	^{1. 2+3. #(2+3 {3+4}). 4}.! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 11:47'!
testArrayRecursion
	^{ 1. 1+2. 3. {5. 1 } }. ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:06'!
testCascade
	Transcript show: 'Hello' ; show: 'World' ; cr.  
  ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:07'!
testException

	^ 'Hello' , 4 ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:08'!
testExceptionSignal
	Error signal: 'Test'. ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:12'!
testExperssionAsArguments
	| a b c |
	a := 1.
	b := 2.
	c := 3. 
	^ myself sum: (a+b) with: (b+c) "8"! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 13:45'!
testLiteralArray
	^#(1 2 3) ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 13:58'!
testLiteralArrayRecursion
	^#(1 2 (3 4) 5 #(6 7)).! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:13'!
testObjectAsArguments
	| a b  |
	a := 1.
	b := 2.
	^ myself sum: a with: b. "3"! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:26'!
testOrderOfEvaluation
	value := 1. 
	"doFirst multiplies by 5. doSecond adds 1"
	myself doSecond: ( myself doFirst ).
	^ value.! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:26'!
testOrderOfEvaluation2
	"doFirst multiplies by 5. doSecond adds 1"
	^ myself sum: ( myself multiply: 1 by: 5 ) with: 1.   ! !

OwnedObject3 subclass: #Room
	uses: TNoOwernship
	instanceVariableNames: 'safe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

Room class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!Room class methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:17'!
compilerClass 
	^ OwnershipCompiler3! !

!Room methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:54'!
inFilters
	^ {#unsafe}! !

!Room methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:22'!
initialize 
	safe := Safe newOwned: self.! !

!Room methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ { #all }
	! !

!Room methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:16'!
safe
	<public>
	^safe.! !

OwnedObject3 subclass: #Safe
	instanceVariableNames: 'content status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!Safe class methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:17'!
compilerClass 
	^ OwnershipCompiler3! !

!Safe methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:08'!
content
	<safe>
	^content
	! !

!Safe methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:08'!
initialize 
	status := #locked.
	content := #jewels.! !

!Safe methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:13'!
status
	<unsafe> <public>
	^status
	 ! !

OwnedObject3 subclass: #SecureBank
	uses: TDeepOwernship
	instanceVariableNames: 'acronym customers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

SecureBank class
	uses: TDeepOwernship classTrait
	instanceVariableNames: ''!

SecureBank subclass: #LessSecureBank
	uses: TSelectiveOwernship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

LessSecureBank class
	uses: TSelectiveOwernship classTrait
	instanceVariableNames: ''!

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#anonym.}! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ {#all}
	! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:57'!
selectedClasses 
	^ { Customer }! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:25'!
transferFrom: donator to: receiver

	receiver credit: donator amount.
	donator amount: 0.
	 
	" self tansferFrom: donator to: receiver amount: donator amount "! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:25'!
transferFrom: donator to: receiver amount: amount 
	receiver credit: amount . 
	donator withdraw: amount. ! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:25'!
transferFromX: donator to: receiver amount: amount
  	"to be fixed"
	| ra da |
	ra := receiver amount.
	da := donator amount.
	receiver amount: ( ra + amount ).
	donator amount: ( da - amount ).! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:25'!
transferToPartnerOf: client 

	self transferFrom: client to: 	client partner  ! !

!SecureBank class methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:56'!
compilerClass 
	^ OwnershipCompiler3! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/24/2012 16:18'!
acquireBank: aBank
	aBank customers do: [ :each |  self acquireCustomer: each ].! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 14:36'!
acronym: a
	acronym := a. ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 11:28'!
amountOf: aCustomer
	^ aCustomer amount. ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/23/2012 14:57'!
customers
	^ customers. ! !

!SecureBank methodsFor: 'violation' stamp: 'ewe 5/2/2012 15:13'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/24/2012 16:56'!
hasMoreCustomerThan: aBank 
	"^ customers size > aBank customers size "
	 aBank customers ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 11:28'!
identifierOf: aCustomer
	^ aCustomer identifier. ! !

!SecureBank methodsFor: 'filters' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#anonym.}! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/23/2012 17:13'!
initialize
	customers := DOOrderedCollection newOwned: self. ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/23/2012 14:54'!
newCustomer
	| c|
	c := Customer newOwned: self.
	customers add: c.
	^ c. 
	! !

!SecureBank methodsFor: 'filters' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ { #all }
	! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 14:38'!
printString
	^ acronym. ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 16:46'!
promoteCustomer:  aCustomer 
	( aCustomer type = #premium) ifFalse: [
		aCustomer type: #premium.
	].! !

Object subclass: #SnakesAndLadders
	instanceVariableNames: 'players squares turn die over'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!SnakesAndLadders commentStamp: 'on 3/14/2006 19:05' prior: 0!
SnakesAndLadders example playToEnd

A simple board game in which players roll a die to move from the starting square to the end. A square may contain a snake (moves you back) or a ladder (moves you up). If youland on a square already occupied, you go back to the start. If you move past the end, you reverse direction the remaining number of moves.

See http://en.wikipedia.org/wiki/Snakes_and_ladders for the rules of the game

SnakesAndLadders has the following responsibilities:
- enable scripting of an initial configuration of squares and players
- keep track of the rules of the game
- keep track whose turn it is to play
- initiate a move
- play a game to the end
- report on moves and intermediate game states
- stop when the game is over

Typical usage (see the example):
- Instantiate a new SnakesAndLadders
- Add squares, snakes and ladders to build the game board 
- Join players
- Play single moves or PlayToEnd!

!SnakesAndLadders class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!SnakesAndLadders class methodsFor: 'documentation' stamp: 'pmaer 2/14/2012 00:11'!
example
	"self example playToEnd"

	^ (self new)
		add: FirstSquare new;
		add: (LadderSquare forward: 4);
		add: BoardSquare new;
		add: BoardSquare new;
		add: BoardSquare new;
		add: BoardSquare new;
		add: (LadderSquare forward: 2);
		add: BoardSquare new;
		add: BoardSquare new;
		add: BoardSquare new;
		add: (SnakeSquare back: 6);
		add: BoardSquare new;
		join: (GamePlayer named: 'Jack');
		join: (GamePlayer named: 'Jill');
		yourself! !

!SnakesAndLadders class methodsFor: 'documentation' stamp: 'pmaer 2/14/2012 00:30'!
example2
	"self example2 playToEnd"

	^ (self new)
		add: FirstSquare new;
		add: BoardSquare new;
		add: (LadderSquare forward: 4);
		add: BoardSquare new;
		add: BoardSquare new;
		add: (SnakeSquare back: 2);
		add: BoardSquare new;
		add: (LadderSquare forward: 3);
		add: BoardSquare new;
		add: BoardSquare new;
		add: (SnakeSquare back: 4);
		add: BoardSquare new;
		add: BoardSquare new;
		join: (GamePlayer named: 'Jack');
		join: (GamePlayer named: 'Jill');
		yourself! !

!SnakesAndLadders class methodsFor: 'documentation' stamp: 'pmaer 2/15/2012 13:19'!
example3 
	"self example2 playToEnd"
	| temp |
	temp:= self new.
	self halt.
	^ (temp)
		add: FirstSquare new;
		add: BoardSquare new;
		add: (LadderSquare forward: 4);
		add: BoardSquare new;
		add: BoardSquare new;
		add: (SnakeSquare back: 2);
		add: BoardSquare new;
		add: (LadderSquare forward: 3);
		add: BoardSquare new;
		add: BoardSquare new;
		add: (SnakeSquare back: 4);
		add: BoardSquare new;
		add: BoardSquare new;
		join: (GamePlayer named: 'Jack');
		join: (GamePlayer named: 'Jill');
		yourself! !

!SnakesAndLadders methodsFor: 'initialize-release' stamp: 'on 3/18/2006 15:13'!
add: aSquare 
	squares add: aSquare.
	aSquare setPosition: squares size board: self! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/14/2006 16:30'!
at: position
	^ squares at: position! !

!SnakesAndLadders methodsFor: 'playing' stamp: 'on 3/14/2006 17:10'!
checkResult
	^ self currentPlayer position = self lastPosition
		ifTrue: [
			over := true.
			' -- ', self currentPlayer asString, ' wins!!'
			]
		ifFalse: [ '' ]! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/14/2006 16:54'!
currentPlayer
	^ players at: turn! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/14/2006 16:43'!
firstSquare
	^ squares first! !

!SnakesAndLadders methodsFor: 'initialize-release' stamp: 'pmaer 2/27/2012 12:12'!
initialize
	super initialize.
	die := Die new.
	squares := OrderedCollection  new.
	players := OrderedCollection new.
	turn := 1.
	over := false.! !

!SnakesAndLadders methodsFor: 'initialize-release' stamp: 'pmaer 2/27/2012 12:12'!
invariant
	"Should also check that snakes and ladders lead to ordinary squares, and do not bounce
	past the beginning or end of the board."
	^ squares size > 1
		and: [[players size > 1]
		and: [[turn >= 1]
		and: [[turn <= players size]]]]! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'pmaer 2/3/2012 15:14'!
isNotOver 
	^ self isOver not! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/18/2006 15:04'!
isOver
	^ over! !

!SnakesAndLadders methodsFor: 'initialize-release' stamp: 'on 3/18/2006 12:10'!
join: aPlayer
	players add: aPlayer.
	aPlayer moveTo: self firstSquare.
! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/14/2006 16:59'!
lastPosition
	^ squares size! !

!SnakesAndLadders methodsFor: 'playing' stamp: 'on 5/17/2006 16:49'!
playOneMove
	| result |
	self assert: self invariant.
	^ self isOver 
		ifTrue: ['The game is over!!']
		ifFalse: 
			[result := (self currentPlayer moveWith: die) , self checkResult.
			self upDateTurn.
			result]! !

!SnakesAndLadders methodsFor: 'playing' stamp: 'on 3/18/2006 15:01'!
playToEnd
	"SnakesAndLadders example playToEnd"

	Transcript closeAllViews.
	Transcript open.
	Transcript
		show: self asString;
		cr;
		cr.
	[self isNotOver] whileTrue: 
			[Transcript
				show: self playOneMove asString;
				cr.
			Transcript
				show: self asString;
				cr;
				cr]! !

!SnakesAndLadders methodsFor: 'accessors' stamp: 'on 3/15/2006 15:01'!
players
	"needed for testing"
	^ players! !

!SnakesAndLadders methodsFor: 'printing' stamp: 'on 3/16/2006 18:06'!
printOn: aStream
	squares do: [:each | each printOn: aStream].! !

!SnakesAndLadders methodsFor: 'initialize-release' stamp: 'on 3/16/2006 11:30'!
reset
	die := Die new.
	turn := 1.
	over := false.
	players do: [:each | each moveTo: self firstSquare ].
	self assert: self invariant.! !

!SnakesAndLadders methodsFor: 'accessors' stamp: 'on 3/15/2006 13:29'!
setDie: aDie
	"For testing only. Can play the game with a loaded die."
	die := aDie.! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/14/2006 16:22'!
turn
	^ turn! !

!SnakesAndLadders methodsFor: 'playing' stamp: 'on 3/14/2006 16:21'!
upDateTurn
	turn := 1 + (turn\\players size).! !

Object subclass: #TestA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-TestStuff'!

!TestA methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 16:12'!
randomStuff
	| a b c |
	a := TestA new.
	b := TestB new.
	c := TestC new.! !

Object subclass: #TestAST
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel'!

!TestAST class methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2011 11:41'!
compilerClass 
^ DebugCompiler! !

!TestAST methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2011 11:39'!
objectNameTransformed
^ self checkValidSend: [ self name ].! !

!TestAST methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 13:26'!
testArrayCompilation
	| a |
	
	DOArray withAll: #(1 2 (3 4) 5 #(6 7)).
	
	a do: { 1. 1+2. 3. {5. 1 } }.! !

Object subclass: #TestB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-TestStuff'!

!TestB methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 16:13'!
moreRandomStuff
	| a b c d |
	a := TestA new.
	b := TestB new.
	c := TestC new.
	d := TestD new.! !

Object subclass: #TestC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-TestStuff'!

!TestC methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 16:13'!
randomrandom
	| c d e |
	c := TestC new.
	d := TestD new.
	e := TestE new.! !

Object subclass: #TestD
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-TestStuff'!

Object subclass: #TestE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-TestStuff'!

Object subclass: #VariableNameCounter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Util'!

VariableNameCounter class
	instanceVariableNames: 'counter'!

VariableNameCounter class
	instanceVariableNames: 'counter'!

!VariableNameCounter class methodsFor: 'as yet unclassified' stamp: 'pmaer 12/5/2011 16:46'!
counter
	(counter = nil) ifTrue: [ self resetCounter ].
	^counter! !

!VariableNameCounter class methodsFor: 'as yet unclassified' stamp: 'pmaer 12/5/2011 16:46'!
increment
	counter := counter + 1.! !

!VariableNameCounter class methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:28'!
nextVariableName
	VariableNameCounter increment.
	^ 'r', self counter asString .! !

!VariableNameCounter class methodsFor: 'as yet unclassified' stamp: 'pmaer 12/5/2011 16:45'!
resetCounter
	counter := 0.! !

Object subclass: #WorldOwner
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!WorldOwner class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/16/2012 11:02'!
getInstance
	"returns the Instance, if it doesn't exist yet create it"
	^Instance ifNil: [Instance := self basicNew ].! !

!WorldOwner class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/16/2012 11:03'!
new
	"WorldOwner is a singleton, use getInstance instead"
	^self shouldNotImplement.! !

!WorldOwner methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:51'!
acceptOwnee: candidateOwnee
	^true.! !
DOCollection initialize!
